function bgblob_callback(src,eventdata)
%default bgblob_callback for single-axis graphs

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
uicontrol(handles.dummyobj)

bgblobs=findobj(handles.tabobjects,'tag','bgblob');
set(bgblobs,'value',0);
set(src,'value',1);

newidx=get(src,'userdata');
udata.format.bg=newidx;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%get colors:
axescolors=handles.colors.axes{newidx};
fgcolor=axescolors(1,:);
bgcolor=axescolors(2,:);
lightgrid=axescolors(3,:);
stronggrid=axescolors(4,:);
txt=axescolors(5,:);

%change colors
set(handles.fakerax(handles.activeindex),'color',bgcolor,'xcolor',lightgrid,'ycolor',lightgrid,'zcolor',lightgrid)
set(handles.fakeax(handles.activeindex),'xcolor',stronggrid,'ycolor',stronggrid,'zcolor',stronggrid);
set(handles.activegraph,'xcolor',fgcolor,'ycolor',fgcolor,'zcolor',fgcolor);
set([get(handles.activegraph,'xlabel') get(handles.activegraph,'ylabel') get(handles.activegraph,'zlabel')],'color',fgcolor)

xticklabel=findall(handles.activegraph,'type','text','tag','xticklabel');
yticklabel=findall(handles.activegraph,'type','text','tag','yticklabel');
zticklabel=findall(handles.activegraph,'type','text','tag','zticklabel');

set([xticklabel;yticklabel;zticklabel],'color',txt);

xlab=get(handles.activegraph,'xlabel');
ylab=get(handles.activegraph,'ylabel');
zlab=get(handles.activegraph,'zlabel');

set([xlab;ylab;zlab],'color',txt);



%look for legends:
legdata=get(handles.fakerax(handles.activeindex),'userdata');
if isempty(legdata);return;end
L=findobj(legdata(ishandle(legdata)),'type','axes','tag','legend');
set(L,'color',bgcolor);
ttt=findobj(L,'type','text');
set(ttt,'color',txt);



