function controls=makeuicontrolsdrawconstraint(src,ev)
%Draw Constraint(s) on Graph
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
origin=get(handles.tabaxes,'position');

ctext=text(.10,.87,'Select constraints to draw:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,'parent',handles.tabaxes,'fontsize',10,...
    'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

if isempty(handles.constrainttext{udata.view.dataset}{udata.view.analysis})
    conststring='No constraints have been created yet.';
else
    conststring=[cellstr('') handles.constrainttext{udata.view.dataset}{udata.view.analysis}];
end

constraintmenu=uicontrol('position',[origin(1)+30 origin(2)+120 220 420],...
    'style','listbox','string',conststring,...
    'callback',@constraintmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','constraintmenu','max',100,'value',udata.view.constraints+1);
%update tabobjects:
controls=[ctext constraintmenu];

guidata(src,handles);

function constraintmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.constraints=get(src,'value')-1; %indicies of constraints drawn on this graph.

set(handles.fakeax(handles.activeindex),'userdata',udata);

%Delete existing constraints:
delete(findall(handles.activegraph,'tag','constraint'))
delete(findall(handles.activegraph,'tag','constrainthatches'))


h=ravedrawconstraint(src,handles.activeindex,udata.view.constraints);



