function controls=makeuicontrolszoombars(src,ev)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2012 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
origin=get(handles.tabaxes,'position');

enablebutton=uicontrol('style','togglebutton','position',[origin(1)+25 origin(2)+545 220 26],...
    'fontsize',14,'foregroundcolor',[.2 .2 .2],'string','Push to Enable',...
    'callback',@enablebutton_callback);

if ismember('zoombars',udata.explore.method);
    set(enablebutton','value',1,'string','Enabled','foregroundcolor',[0 .8 0]);
end

%update tabobjects:
controls=[enablebutton];
guidata(src,handles);

function enablebutton_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');


if get(src,'value')
   set(src,'foregroundcolor',[0 .8 0],'string','Enabled');
   udata.explore.method=union(udata.explore.method,{'zoombars'});    
else
   set(src,'foregroundcolor',[.2 .2 .2],'string','Push to Enable');
   udata.explore.method=setdiff(udata.explore.method,{'zoombars'});     
end

set(handles.fakeax(handles.activeindex),'userdata',udata);
raveenablezoombars(src,ev,handles);


