function ravecreatebackgroundframe(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.activegraph;
targetindex=find(handles.allgraphs==targetaxes);

delete(udata.view.rectangle);
udata.view.rectangle=[];
delete(udata.view.title);
udata.view.title=[];
set(handles.fakeax(handles.activeindex),'userdata',udata);

%hide axes:
set(targetaxes,'visible','off','xticklabel','','yticklabel','')
set(handles.fakeax(targetindex),'visible','off')
set(handles.fakerax(targetindex),'visible','off')

pos=get(handles.allblockers(targetindex),'pos');
%set(handles.allblockers(targetindex),'parent',handles.boneyard);


radius=udata.format.radius;
if (2*radius)>pos(4)
    radius=floor(pos(4)/2);
end
if (2*radius)>pos(3)
    radius=floor(pos(3)/2);
end

if radius==0
    udata.view.rectangle=patch([pos(1) pos(1) pos(1)+pos(3) pos(1)+pos(3)],[pos(2) pos(2)+pos(4) pos(2)+pos(4) pos(2)],0*[10 10 10 10],[1 1 1],...
        'parent',handles.mainaxes,'linewidth',udata.format.edgewidth,'facecolor',udata.format.bgcolor,'hittest','off');
else
    %make circle data:
    xdata=0:radius;
    ydata=sqrt(radius.^2-xdata.^2);
    
    allxdata=[pos(1)-xdata+radius pos(1)-fliplr(xdata)+radius pos(1)+pos(3)+xdata-radius pos(1)+pos(3)-xdata];
    allydata=[pos(2)-ydata+radius pos(2)+pos(4)+fliplr(ydata)-radius pos(2)+pos(4)+ydata-radius pos(2)-fliplr(ydata)+radius];

    udata.view.rectangle=patch(allxdata,allydata,0*ones(size(allxdata)),[1 1 1],...
        'parent',handles.mainaxes,'linewidth',udata.format.edgewidth,'facecolor',udata.format.bgcolor,'hittest','off',...
        'edgecolor',udata.format.edgecolor);
end

offset=radius;
if offset<5
    offset=5;
end

udata.view.title=text(pos(1)+offset,pos(2)+pos(4),0.5,udata.format.titlestring,'parent',handles.mainaxes,...
    'fontname',udata.format.fontname,'fontsize',udata.format.fontsize,'backgroundcolor',udata.format.bgcolor);

if udata.format.fontstyle==1 || udata.format.fontstyle==3
    set(udata.view.title,'fontweight','bold');
end

if udata.format.fontstyle==2 || udata.format.fontstyle==3
    set(udata.view.title,'fontangle','italic');
end



if udata.format.titleposition==1 %title on top
   set(udata.view.title,'backgroundcolor','none','vertical','bottom');    
end



set(handles.fakeax(targetindex),'userdata',udata);

%handles.allgraphs(handles.activeindex)=udata.view.rectangle;
%set(udata.view.rectangle,'hittest','on','buttondownfcn',@raveselectgraph,'userdata','backgroundframe')
%set(handles.allblockers(handles.activeindex),'visible','off')

uistack(udata.view.rectangle,'bottom');
uistack(handles.allblockers(handles.activeindex),'bottom'); 
uistack(handles.expblockers(handles.activeindex),'bottom');


guidata(handles.fig,handles);

raveresizeaxes(handles.fig,[],targetindex)
clear ravearrangeobjects


