function formattabscrollabletext(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

appeartext=text(.15-.10317,.97*1.0317-.0317,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);


%% APPEARANCE:
titletext=uicontrol('position',[origin(1)+25 origin(2)+576 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+578 180 20],...
    'style','edit','string',udata.format.title,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

fontlist=handles.fonts.listfonts;

sizelist={'6';'8';'9';'10';'11';'12';'14';'16';'18';'20';'22';'24';'28';'32';'36';'42';'48';'60';'72';'96'};

fontvalue=find(strcmpi(fontlist,udata.format.fontname),1);
if isempty(fontvalue)
    fontvalue=1;
end

sizevalue=find(strcmp(sizelist,num2str(udata.format.fontsize)),1);
if isempty(sizevalue)
    sizevalue=6;
end

[style,javastyle,boldvalue,italicvalue]=ravegetfontstyle(udata.format.fontstyle);

%uicontrols
fontpicker=uicontrol('position',[origin(1)+25 origin(2)+124+450-30 219 22],'style','popupmenu',...
    'string',fontlist,'parent',handles.fig,'max',10,'value',fontvalue,...
    'backgroundcolor',[1 1 1],'tag','fontpicker','callback',@fontpicker_callback);

boldbutton=uicontrol('position',[origin(1)+25 origin(2)+90+455-30 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('bold.png'),...
    'tag','boldbutton','callback',@fontpicker_callback,'value',boldvalue);

italicbutton=uicontrol('position',[origin(1)+55 origin(2)+90+455-30 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('italic.bmp'),...
    'tag','italicbutton','callback',@fontpicker_callback,'value',italicvalue);

underlinebutton=uicontrol('position',[origin(1)+85 origin(2)+90+455-30 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('underline.bmp'),'tag','underlinebutton');

fontdownbutton=uicontrol('position',[origin(1)+145 origin(2)+90+455-30 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontdown.bmp'),...
    'callback',@fontdown_callback);

fontsizer=uicontrol('position',[origin(1)+176 origin(2)+90+455-30 40 22],'style','popupmenu',...
    'string',sizelist,...
    'parent',handles.fig,'max',1,'value',sizevalue,...
    'backgroundcolor',[1 1 1],'tag','fontsizer','callback',@fontpicker_callback);

fontupbutton=uicontrol('position',[origin(1)+220 origin(2)+90+455-30 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontup.bmp'),...
    'callback',@fontup_callback);

% TEXT COLOR BLOBS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fgindex=eye(5);
fgin=udata.format.fg;

textcolortext=uicontrol('position',[origin(1)+25 origin(2)+56+460-30 180 20],...
    'style','text','string','Text Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

textblack=uicontrol('position',[origin(1)+124 origin(2)+58+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],'value',fgindex(1,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',1);

textblue=uicontrol('position',[origin(1)+149 origin(2)+58+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 .9],'value',fgindex(2,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',2);

textred=uicontrol('position',[origin(1)+174 origin(2)+58+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.9 0 0],'value',fgindex(3,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',3);

textwhite=uicontrol('position',[origin(1)+199 origin(2)+58+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',fgindex(4,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',4);

textrainbow=uicontrol('position',[origin(1)+224 origin(2)+58+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',fgindex(5,fgin),...
    'callback',@colorrainbow_Callback,'cdata',imread('rainbow.bmp'),'tag','textblob','userdata',5);

% BACKGROUND COLOR BLOBS: (userdata = gridcolor; textcolor; index)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bgindex=eye(5);
bgin=udata.format.bg;

bgcolortext=uicontrol('position',[origin(1)+25 origin(2)+31+460-30 180 20],...
    'style','text','string','Background:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

bgwhite=uicontrol('position',[origin(1)+124 origin(2)+33+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;0 0 0;1 0 0],'value',bgindex(1,bgin));
bglight=uicontrol('position',[origin(1)+149 origin(2)+33+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.753 .753 .753],...
    'callback',@bgblob_Callback,'userdata',[1 1 1;0 0 0;2 0 0],'value',bgindex(2,bgin));
bgdark=uicontrol('position',[origin(1)+174 origin(2)+33+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.502 .502 .502],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;1 1 1;3 0 0],'value',bgindex(3,bgin));
bgblack=uicontrol('position',[origin(1)+199 origin(2)+33+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;0 0 0;1 0 0],'value',bgindex(4,bgin));
bgrainbow=uicontrol('position',[origin(1)+224 origin(2)+33+460-30 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],...
    'callback',@bgrainbow_Callback,'userdata',[.3 .3 .3;1 1 1;4 0 0],'cdata',imread('rainbow.bmp'),...
    'tooltip','Choose Color','value',bgindex(5,bgin));

handles.bgblobs=[bgwhite bglight bgdark bgblack bgrainbow];

edgecheck=uicontrol('position',[origin(1)+25 origin(2)+05+460-30 200 26],...
    'style','checkbox','string','Draw border around text box','fontsize',9,...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showedge,'callback',@edgecheck_Callback,'tag','edgecheck');


%% group items and finish up
handles.tabobjects=[appeartext fontpicker titletext titlebox ...
    boldbutton italicbutton underlinebutton fontupbutton fontdownbutton edgecheck ...
    fontsizer textblack textred textblue textwhite textrainbow bgwhite bglight bgdark bgblack bgrainbow ...
    textcolortext bgcolortext];

handles.activetab='format';
set(handles.infobar,'string','');
guidata(src,handles);




function fontdown_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');

value=get(fontsizer,'value');
if value>=2
    value=value-1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function fontup_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
maxvalue=numel(get(fontsizer,'string'));

value=get(fontsizer,'value');
if value<maxvalue
    value=value+1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function fontpicker_callback(src,ev) %#ok<INUSD>

handles=guidata(src);
getudata;

fontpicker=findobj(handles.tabobjects,'tag','fontpicker');
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
boldbutton=findobj(handles.tabobjects,'tag','boldbutton');
italicbutton=findobj(handles.tabobjects,'tag','italicbutton');
%underlinebutton=findobj(handles.tabobjects,'tag','underlinebutton');

fontlist=get(fontpicker,'string');
fontname=fontlist(get(fontpicker,'value'));

sizelist=get(fontsizer,'string');
fontsize=str2double(sizelist{get(fontsizer,'value')});

if get(boldbutton,'value') && get(italicbutton,'value')
    fontstyle=3;
elseif get(boldbutton,'value')
    fontstyle=1;
elseif get(italicbutton,'value')
    fontstyle=2;
else
    fontstyle=4;
end

udata.format.fontname=fontname{1};
udata.format.fontsize=fontsize;
udata.format.fontstyle=fontstyle;

setudata;
guidata(src,handles);

ravecreatescrollabletext(handles.fig,[]);




function colorblob_Callback(src,ev)
%callback for textbox text color buttons.
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata
newcolor=get(src,'backgroundcolor');

%update fakerax userdata
udata.format.fg=get(src,'userdata');
udata.format.color=newcolor;
setudata;

%unpop blobs:
textblobs=findobj(handles.tabobjects,'tag','textblob');
set(textblobs,'value',0);
set(src,'value',1)

ravecreatescrollabletext(src,ev);

function colorrainbow_Callback(src,ev)
%callback for textbox text color buttons.
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata
newcolor=ravecolorchooser(handles.fig,udata.format.color,'Choose a text color');

%update fakerax userdata
udata.format.fg=get(src,'userdata');
udata.format.color=newcolor;
setudata;

%unpop blobs:
textblobs=findobj(handles.tabobjects,'tag','textblob');
set(textblobs,'value',0);
set(src,'value',1)

ravecreatescrollabletext(src,ev);




function bgblob_Callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

colors=get(src,'userdata');
plotcolor=get(src,'backgroundcolor');

%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.bg=colors(3,1);
udata.format.bgcolor=plotcolor;
udata.format.gridlinecolor=plotcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.fakerax(handles.activeindex),'backgroundcolor',plotcolor)
ravecreatescrollabletext(handles.fig,[]);

function bgrainbow_Callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata;
plotcolor=ravecolorchooser(handles.fig,udata.format.bgcolor,'Choose a background color');

%update fakerax userdata
udata.format.bg=5;
udata.format.bgcolor=plotcolor;
udata.format.gridlinecolor=plotcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.fakerax(handles.activeindex),'backgroundcolor',plotcolor)
ravecreatescrollabletext(handles.fig,[]);


function edgecheck_Callback(src,ev)

handles=guidata(src);
getudata;

udata.format.showedge=get(src,'value');

setudata;
if udata.format.showedge;
    set(handles.fakerax(handles.activeindex),'highlightcolor',udata.format.edgecolor,'shadowcolor','default','bordertype','line')
else
    set(handles.fakerax(handles.activeindex),'highlightcolor',handles.colors.wsbg,'bordertype','none')
end



function title_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.title=get(src,'string');
titel=get(udata.format.titleaxes,'children');
set(titel,'string',get(src,'string'));
set(handles.fakeax(handles.activeindex),'userdata',udata);
raveresizetable(handles.fig,[],handles.activeindex);
