function viewtabscrollabletext(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

d=udata.view.dataset;
a=udata.view.analysis;



%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
valuetext=text(.15-.10317,.77*1.0317-.0317,'Value','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
optiontext=text(.15-.10317,.085,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);


%% project:
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',a);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d);

%% value:
splaintext=uicontrol('style','text','position',[origin(1)+15 origin(2)+350 240 120],'string',{'Enter the text to be displayed in the field below. Put text file paths in { } to insert the text contained in that file at the indicated location in the text box. Put line numbers in [ ] immediately after the { } to display only those lines.';'E.g.,{C:\Files\MyText.txt}[5-10]'},...
    'horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.fig,'fontsize',10,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal');

%make java text editor:
j=javax.swing.JTextPane;
h=javax.swing.JScrollPane(j,javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
[junk,handy]=javacomponent(h,[origin(1)+15 origin(2)+110 235 240]);

j.setText(udata.view.expression)

junk.FocusLostCallback={@expressionedit_Callback,handles.fig};
junk.KeyTypedCallback=@expressionedit_Callback;
junk.KeyTypedCallback=@expressionedit_Callback;

applybutton=uicontrol('position',[origin(1)+15 origin(2)+80 160 20],...
    'style','pushbutton','string','Apply Changes','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@applybutton_Callback);

wrapcheck=uicontrol('position',[origin(1)+25 origin(2)+20 160 20],...
    'style','checkbox','string','Wrap text','backgroundcolor',handles.colors.tabbg,...
    'horizontalalignment','left','callback',@wrapcheck_Callback,'value',udata.format.wordwrap);

handles.tabobjects=[valuetext splaintext optiontext wrapcheck...
    handy analysistext datasettext analysismenu datasetmenu projecttext applybutton];
handles.temp.textpane=j;
guidata(src,handles);


function datasetmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescrollabletext(handles.fig,[]);

function analysismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescrollabletext(handles.fig,[]);


function expressionedit_Callback(jsrc,jev,src)

function applybutton_Callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

jtext=handles.temp.textpane;
newstring=jtext.getText;
newstring=char(newstring);

udata.view.expression=newstring;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescrollabletext(handles.fig,[]);

function wrapcheck_Callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.wordwrap=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescrollabletext(handles.fig,[]);


