function ravearrangeobjectsderivativeprofiler(src,ev,ai)
% A variation of ravemovecustomticks to move the doule axis labels...
%(Note that ravemovecustomticks has already been called, so this function
%ONLY moves the axis labels)

handles=guidata(src);

if nargin<3
    ai=handles.activeindex;
end

udata=get(handles.fakeax(ai),'userdata');

%X axis... check length of all xticks:
xticks=cell(size(handles.subax{ai},2),1);
state=get(0,'ShowHiddenHandles');
set(0,'ShowHiddenHandles','on');
for c=1:numel(xticks)
    xticks{c}=ravefindobjinternal(handles.subax{ai}(end,c),'tag','xticklabel');
end
set(0,'ShowHiddenHandles',state);

% xticks=cell2mat(xticks);
xticks=cellfun(@transpose,xticks,'uniformoutput',false);
xticks=[xticks{:}];


xstrings=get(xticks,'string');

[widths,tickheight]=ravecalculatestringlengthfast(xstrings,handles.fontmetrics.tick);
xdim=max(widths);

if isempty(widths) %If there are no x labels...
    xdim=0;
end

%tickheight is the height of the current value axis label

%push down current value label by xdim (since prediction profiler tick
%labels are always rotated).

for c=1:size(handles.subax{ai},2)
    ax=handles.subax{ai}(end,c);
    ylim=get(ax,'ylim');
    xlim=get(ax,'xlim');
    axpos=getpixelposition(ax);
    yunitsperpix=(ylim(2)-ylim(1))./axpos(4);
    
    cvpos=ylim(1)-(3+xdim)*yunitsperpix;
    labelpos=ylim(1)-(3+xdim+tickheight)*yunitsperpix;
    
    cv=get(handles.subfakeax{ai}(end,c),'xlabel');
    xlab=get(ax,'xlabel');
    
    set(cv,'units','data','position',[mean(xlim) cvpos]);
    set(xlab,'units','data','position',[mean(xlim) labelpos]);
end


%And the y axis....
yticks=cell(size(handles.subax{ai},1),1);
state=get(0,'ShowHiddenHandles');
set(0,'ShowHiddenHandles','on');
for r=1:numel(yticks)
    yticks{r}=ravefindobjinternal(handles.subax{ai}(r,1),'tag','yticklabel');
end
set(0,'ShowHiddenHandles',state);

% yticks=cell2mat(yticks);
yticks=cellfun(@transpose,yticks,'uniformoutput',false);
yticks=[yticks{:}];
ystrings=get(yticks,'string');

[widths,tickheight]=ravecalculatestringlengthfast(ystrings,handles.fontmetrics.tick);
ydim=max(widths);

%tickheight is the height of the current value axis label

%push down current value label by xdim (since prediction profiler tick
%labels are always rotated).

for r=1:size(handles.subax{ai},1)
    ax=handles.subax{ai}(r,1);
    ylim=get(ax,'ylim');
    xlim=get(ax,'xlim');
    axpos=getpixelposition(ax);
    xunitsperpix=(xlim(2)-xlim(1))./axpos(3); %*sin(el*pi/180)*cos(az*pi/180);
    
    cvpos=xlim(1)-(5+ydim)*xunitsperpix;
    labelpos=xlim(1)-(5+ydim+tickheight)*xunitsperpix;
    
    cv=get(handles.subfakeax{ai}(r,1),'ylabel');
    ylab=get(ax,'ylabel');
    
    set(cv,'units','data','position',[cvpos mean(ylim)]);
    set(ylab,'units','data','position',[labelpos mean(ylim)]);
end

%Titles too...
if udata.format.xlabelabove
    for c=1:size(handles.subax{ai},2)
        ax=handles.subax{ai}(1,c);
        ylim=get(ax,'ylim');
        xlim=get(ax,'xlim');
        axpos=getpixelposition(ax);
        yunitsperpix=(ylim(2)-ylim(1))./axpos(4);
        titlepos=ylim(2)+3*yunitsperpix;
        titel=get(ax,'title');
        set(titel,'units','data','position',[mean(xlim) titlepos]);
    end
end


