function handles=raveupdatederivativeprofilerxdials(src,ev,handles,thesevars)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

%handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;
xcol=udata.view.x;
xdials=handles.xdials{udata.view.dataset}{udata.view.analysis};

% xdials(udata.view.x(index))=val;
set(handles.fakeax(handles.activeindex),'userdata',udata)

thesedials=xdials(udata.view.x);
for g=1:numel(thesedials)
    
    val=thesedials(g);
    thistype=handles.datatype{d}{udata.view.x(g)};
    
    %make text label:
    if ~any(strcmp(thistype,{'string','logical'}))
        valtext=strtrim(sprintf('%5.5g',val));
    elseif strcmp(thistype,'string')
        valtext=handles.discretevalues{d}{a}{xcol(g)}{val};
    else %logical
        if val
            valtext=handles.prefs.logicaltrue;
        else
            valtext=handles.prefs.logicalfalse;
        end
    end
    
    %set xlabel:
    set(udata.view.xhair(:,g),'xdata',[val val])
    if udata.view.showcurrentpoint && udata.format.xlabelbelow
        set(get(handles.subfakeax{handles.activeindex}(end,g),'xlabel'),'string',['\color[rgb]{',udata.format.linecolorString,'} ',valtext]);
    end
end


%calculate profiler data for each graph:
cols=length(udata.view.x);
if udata.view.singleyaxis
    rows=1;
else
    rows=length(udata.view.y);
end

numpts=udata.view.numpts;
xcol=udata.view.x;
ycol=udata.view.y;
numy=numel(ycol);

%get type of each variable:
datatypes=handles.datatype{d}(udata.view.x);

[xsteps totalrows]=ravecalculatexsteps(handles.fig,d,a,xcol,numpts,1);

rowz=sum(totalrows);

xfixed=repmat(xdials,[rowz,1]);

%convert to cell if strings are present:
if any(strcmp('string',datatypes))
    xfixed=num2cell(xfixed);
    for k=1:cols
        [xfixed{sum(totalrows(1:k-1))+1:sum(totalrows(1:k)),xcol(k)}]=deal(xsteps{k});
    end
    
else
    for k=1:cols
        xfixed(sum(totalrows(1:k-1))+1:sum(totalrows(1:k)),xcol(k))=xsteps{k};
    end
end

%evaluate the functions:
yvalues=raveevaluatefunction(src,d,udata.view.y,xfixed,handles);

for g=1:numy
    if min(yvalues(:,g))<handles.minlimit{d}{a}(ycol(g));handles.minlimit{d}{a}(ycol(g))=min(yvalues(:,g));end
    if max(yvalues(:,g))>handles.maxlimit{d}{a}(ycol(g));handles.maxlimit{d}{a}(ycol(g))=max(yvalues(:,g));end
end

ycurrent=raveevaluatefunction(src,d,udata.view.y,xdials,handles);

%put results of each response in a seperate cell:
yvalues=mat2cell(yvalues,size(yvalues,1),ones(1,numy));
ycurrent=mat2cell(ycurrent,size(ycurrent,1),ones(1,numy));

%and put each x for each resposne in its own cell too:
for zz=1:numy
    yvalues{zz}=mat2cell(yvalues{zz},totalrows,1);
end

if udata.view.showcurrentpoint && ~udata.view.singleyaxis
    for tt=1:rows
        yvaltext=strtrim(sprintf('%5.5g',ycurrent{tt}));
        set(get(handles.subfakeax{handles.activeindex}(tt,1),'ylabel'),'string',['\color[rgb]{',udata.format.linecolorString,'} ',yvaltext]);
    end
end

for tt=1:numy
    for cc=1:cols
        if  ~strcmp(datatypes{cc},'continuous') %if this variable is discrete
            allowed=handles.discretevalues{d}{a}{xcol(cc)};
            endind=numel(allowed);
            
            intsides=repmat(2:(endind-1),3,1);
            ymap=[1 1 intsides(:)' endind endind];
            
            xvals=xsteps{cc}(:); %force to be column.
            xintermediates=xvals+[diff(xvals)./2;0];
            
            xvals=sort([xvals;xintermediates(1:end-1)]);
            
            xmap=repmat(2:2:2*(endind-1),3,1);
            xmap(end,:)=xmap(end,:)+ones(size(xmap(end,:)));
            
            xmap=[1 xmap(:)'];
            
            set(udata.view.yhair(tt,cc),'ydata',[ycurrent{tt} ycurrent{tt}])
            set(udata.view.mainhandles(tt,cc),'ydata',yvalues{tt}{cc}(ymap),'xdata',xvals(xmap))
            if udata.explore.mouseover && ~udata.view.singleyaxis
               set(udata.explore.mouseoverhandles(tt,cc),'ydata',yvalues{tt}{cc}(ymap),'xdata',xvals(xmap)) 
            end
            
        else
            set(udata.view.yhair(tt,cc),'ydata',[ycurrent{tt} ycurrent{tt}])
            set(udata.view.mainhandles(tt,cc),'ydata',yvalues{tt}{cc},'xdata',xsteps{cc})
            if udata.explore.mouseover && ~udata.view.singleyaxis
               set(udata.explore.mouseoverhandles(tt,cc),'ydata',yvalues{tt}{cc},'xdata',xsteps{cc})
            end
        end
        
    end
end

ravedrawconstraint(handles.allgraphs(handles.activeindex),handles.activeindex,udata.view.constraints);


