function raveresizeaxeshyperslice(src,ev,targetindex)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.allgraphs(targetindex);
targetpos=get(handles.allblockers(targetindex),'position');

if udata.format.colorbar && udata.view.c;
    targetpos(3)=targetpos(3)-100;
end

inset=get(targetaxes,'tightinset')+[30 30 15 25];
if strcmp(udata.view.layout,'upper')
    inset=inset+[0 0 30 30];
end

%Shift by cvpos:
cvpos = get(handles.currentview,'position');
targetpos = targetpos - [cvpos(1) cvpos(2) 0 0];

newpos=floor([targetpos(1)+inset(1)+4 targetpos(2)+inset(2)+2 targetpos(3)-inset(1)-inset(3)-4 targetpos(4)-inset(2)-inset(4)]);

set(targetaxes,'position',newpos)
set(handles.fakeax(targetindex),'position',newpos)
set(handles.fakerax(targetindex),'position',newpos)

guidata(src,handles);