function pointselectsurfaceprofiler(src,ev)
%Change xdials by clicking on a surface profiler

handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

ai=find(handles.allgraphs==ancestor(src,'axes'));
udata=get(handles.fakeax(ai),'userdata');


fff = findobj(handles.allgraphs(ai),'tag','blahblahblah');
delete(fff)



xlim=get(gca,'xlim');
ylim=get(gca,'ylim');
zlim=get(gca,'zlim');

dx=diff(xlim);
dy=diff(ylim);
dz=diff(zlim);

%make uv coordinates:
%check that they clicked on current graph:
z = get(gca,'CameraTarget') - get(gca,'CameraPosition')
z = z./norm(z,2);
u = [1 1 1];
u = u - dot(z,u).*z;
u = u./norm(u);
v = cross(u,z);

u=u.*[dx dy dz];
v =v.*[dx dy dz];

% 
% figure
% axes
% line([0 u(1)],[0 u(2)],[0 u(3)],'color',[1 0 0])
% line([0 v(1)],[0 v(2)],[0 v(3)],'color',[0 1 0])
% line([0 z(1)],[0 z(2)],[0 z(3)],'color',[0 0 1])


d=udata.view.dataset;
a=udata.view.analysis;

clicked=get(handles.allgraphs(ai),'currentpoint');

% xclick=clicked(1,1,1);
% yclick=clicked(1,2,1);
% zclick=clicked(1,3,1);
% point=[xclick yclick zclick];

point = mean(clicked,1);
vec = clicked(1,:)-clicked(2,:);

uclick = point*u';
vclick = point*v';

line([point(1) point(1)+u(1)],[point(2) point(2)+u(2)],[point(3) point(3)+u(3)],'parent',gca,'tag','blahblahblah','color',[.2 .8 .2])
line([point(1) point(1)+v(1)],[point(2) point(2)+v(2)],[point(3) point(3)+v(3)],'parent',gca,'tag','blahblahblah','color',[.1 .2 .8])

%convert xclick/yclick to pixels.



xdata=get(src,'xdata');
ydata=get(src,'ydata');
zdata=get(src,'zdata');

xdata=xdata(:);
ydata=ydata(:);
zdata=zdata(:);

%project this data into uv plane:
pointdata=[xdata(:) ydata(:) zdata(:)];

uudata=pointdata*u';
vdata=pointdata*v';


ulim=[min(uudata) max(uudata)];
vlim=[min(vdata) max(vdata)];

Uclick=(uclick-ulim(1))/(ulim(2)-ulim(1));
Vclick=(vclick-vlim(1))/(vlim(2)-vlim(1));

Udata=(uudata-ulim(1))/(ulim(2)-ulim(1));
Vdata=(vdata-vlim(1))/(vlim(2)-vlim(1));

 
% figure
% axes
% line(Udata,Vdata,'linestyle','none','marker','.')
% line(Uclick,Vclick,'linestyle','none','marker','+')

if Uclick>1 || Uclick<0 || Vclick<0 || Vclick>1
   %Did something screw up somehow? if so just quit. 
   return 
end

%Else, make an interpolant:
Udiff=Udata-Uclick;
Vdiff=Vdata-Vclick;

distnce=single(sqrt(Udiff.^2+Vdiff.^2));
index = distnce==min(distnce);
index=index(:); %make sure it's a column.



inpoints=find(index)



pnt = pointdata(index,:);
line(pnt(1),pnt(2),pnt(3),'marker','o','tag','blahblahblah','parent',handles.allgraphs(ai),'markerfacecolor',[1 0 0],'markeredgecolor',[1 1 1])

return



%ravefindclosestpoint2D does not return correct index since some points may be hidden... expand out for hidden points:
 visiblepoints=find(handles.isvisible{d}{a});
 selectedpoint=visiblepoints(inpoints);
 realpoints=false(size(handles.isvisible{d}{a}));
 realpoints(selectedpoint)=true;
% 
% 
 inpoints=realpoints;

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints=handles.isselected{d}{a} | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{d}{a};
    lastselected(inpoints)=false;
    inpoints=lastselected;
end

handles.isselected{d}{a}=inpoints;

%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],d,a);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],d,a);
end




