function viewtabsliders(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
delete(handles.tabobjects)

d=udata.view.dataset;
a=udata.view.analysis;


%% text headers

projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Variables','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);


optionstext=text(.15-.10317,0.25,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);


%% text labels

analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

xaxistext=text(.25-.10317,.72*1.0317-.0317,'Choose Variables to Display:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

fcntext=text(.25-.10317,0.16,'After using slider, run function:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','normal');

updateanalysistext=text(.25-.10317,0.07,'Update Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','normal');

%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+540 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,...
    'value',a);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+495 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d,'callback',@datasetmenu_callback);

xval=find(ismember(find(~handles.isfunction{d}),udata.view.x));

xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+185 190 255],...
    'style','listbox','string',handles.allnames{d}(~handles.isfunction{d}),...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',xval,'callback',@xmenu_callback,'max',100);

updateonslidecheck=uicontrol('position',[origin(1)+35 origin(2)+115 220 30],...
    'style','checkbox','string','<html>Do not apply changes until mouse button is released</html>',...
    'backgroundcolor',[1 1 1],'value',~udata.view.updateonslide,'callback',@updateonslide_callback);

fcnedit=uicontrol('position',[origin(1)+35 origin(2)+65 220 22],...
    'style','edit','string',udata.view.userfcn,...
    'backgroundcolor',[1 1 1],'callback',@userfcn_callback);

updateanalysismenu=uicontrol('position',[origin(1)+35 origin(2)+10 220 22],...
    'style','popupmenu','string',{'Before running this function','Never, just run this function','After running this function'},...
    'backgroundcolor',[1 1 1],'callback',@updateanalysismenu_callback,'tag','updateanalysismenu');
if isempty(udata.view.userfcn)
    set(updateanalysismenu,'enable','off')
end


%% group items and finish up
handles.tabobjects=[datasettext xaxistext datasetmenu xaxismenu ,...
    analysistext projecttext analysismenu dataseriestext optionstext fcntext updateonslidecheck fcnedit,...
    updateanalysismenu updateanalysistext];

handles.activetab='view';

guidata(src,handles);


function xmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
notfuns=find(~handles.isfunction{udata.view.dataset});
udata.view.x=notfuns(get(src,'value'));
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatesliders(src,[])

function datasetmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);


ravecreatesliders(src,[])

function analysismenu_callback(src,ev)
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesliders(src,[]);

function updateonslide_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.updateonslide=~get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

function userfcn_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if ~isempty(get(src,'string')) && isempty(which(get(src,'string')));
    warndlg('The specified function could not be found on your Matlab search path.','File not found')
    udata.view.userfcn='';
else
    udata.view.userfcn=get(src,'string');
end

updateanalysismenu=findobj(handles.tabobjects,'tag','updateanalysismenu');
set(updateanalysismenu,'enable','on');
set(handles.fakeax(handles.activeindex),'userdata',udata);

function updateanalysismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.updateanalysis=get(src,'value')-2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

