function formattabgraphproject(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

t=uicontrol('style','text','position',[origin(1)+10 origin(2)+600 240 22],...
    'string','Layout:','backgroundcolor',handles.colors.tabbg,'fontsize',10,'fontweight','bold','hor','left');

if strcmp(udata.format.layout,'vertical')
    val=1;
else
    val=2;
end

tt=uicontrol('style','popupmenu','position',[origin(1)+10 origin(2)+580 240 20],...
    'string',{'Vertical','Horizontal'},'backgroundcolor',handles.colors.tabbg,'value',val,'callback',@layout_callback);


xaxistext=text(.15-.10317,.72*1.0317-.0317+0.17,'Dataset Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.15-.10317,.65*1.0317-.0317+0.17,'Analysis Menu Label:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists
xaxisedit=uicontrol('position',[origin(1)+20 origin(2)+405+10+108 180 22],...
    'style','edit','string',udata.view.D.label,'callback',@xaxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',udata.view.d,'hor','left');
yaxisedit=uicontrol('position',[origin(1)+20 origin(2)+360+10+108 180 22],...
    'style','edit','string',udata.view.A.label,'callback',@yaxisedit_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.a,'hor','left');


%% group items and finish up
handles.tabobjects=[t,tt,xaxistext,yaxistext,xaxisedit,yaxisedit];
handles.activetab='format';
set(handles.infobar,'string','');
guidata(src,handles);

function layout_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if get(src,'value')==1
    udata.format.layout='vertical';
elseif  get(src,'value')==2
    udata.format.layout='horizontal';
elseif get(src,'value')==3
    udata.format.layout='twocol';
elseif get(src,'value')==4
    udata.format.layout='tworow';
end

set(handles.fakeax(handles.activeindex),'userdata',udata);
ravearrangeobjectsgraphproject(src,ev)

function xaxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.D.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.D.menutext,'string',newlabel);

function yaxisedit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newlabel=get(src,'string');
udata.view.A.label=newlabel;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.A.menutext,'string',newlabel);

