function ravecreategraphproject(src,ev)
%create generic view tab controls on workspace.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.allgraphs(handles.activeindex); %=handles.activegraph
a=udata.view.analysis;
d=udata.view.dataset; %data set index

set(targetaxes,'visible','off')
set(handles.fakeax(handles.activeindex),'visible','off')
set(handles.fakerax(handles.activeindex),'visible','off')

origin=getpixelposition(targetaxes);

%delete old objects:
cla(targetaxes);
delete(udata.view.D.menuobj);
udata.view.D.menuobj=[];
delete(udata.view.D.menujobj);
udata.view.D.menujobj=[];
delete(udata.view.A.menuobj);
udata.view.A.menuobj=[];
delete(udata.view.A.menujobj);
udata.view.A.menujobj=[];

%make pixel coordinates:
set(targetaxes,'xlim',[1 origin(3)],'ylim',[1 origin(4)],'xticklabel','','yticklabel','');

if udata.view.linkedindex==0
    return
end


%make new objects:

%start at the top and work way down:
off=10; %offset in pixels from top of control:

pos=getpixelposition(targetaxes);
set(targetaxes,'xlim',[1 pos(3)],'ylim',[1 pos(4)],'xticklabel','','yticklabel','','visible','off');

strings={'D';'A'};

for r=1:2
    q=strings{r};
    if udata.view.ispresent(r) && udata.view.isvisible(r);
        udata.view.(q).menutext=text(0,pos(4)-off,udata.view.(q).label,'fontname','arial','fontsize',10,'fontweight','bold','verticalalign','baseline','parent',targetaxes);
        off=off+22;
        
        val=udata.view.(q).value;
        if val>numel(udata.view.(q).variables);val=1;end
        
        if numel(val)>1;val=val(1);end %IMPORTANT: In the future replace this with listboxes for multi-valued variables. this workaround is just to avoid an error.
        [udata.view.(q).menuobj,udata.view.(q).menujobj]=drawpopupmenu(handles.wspanel,[pos(1)+10,pos(2)+pos(4)-off 200 18],udata.view.(q).string(udata.view.(q).variables),val,{@menu_callback,handles.activeindex,q},handles.colors.wsbg);
        %set(udata.view.(q).menujobj,'deletefcn',''); %avoid error when
        %creating controls under 2011a or newer and then reusing in older versions.
        off=off+25;
    end
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

raveresizeaxes(handles.fig,[],handles.activeindex);
%ravearrangeobjectsgraphproject(handles.fig,[],handles.activeindex);
clear ravearrangeobjects


function menu_callback(src,value,ai,thisaxis)
%ai is index into handles.allgraphs of this control
%thisaxis is a member of {'D';'A'} indicating which axis was
%chagned.

handles=guidata(src);

status=validategraphproject(src,[],ai,thisaxis);
if ~status;return;end

udata=get(handles.fakeax(ai),'userdata'); %usedata of this control;
idx=udata.view.linkedindex;

switch thisaxis
    case 'D'
        thismenu=findobj(udata.view.tabobjects,'tag','datasetmenu');
    case 'A'
        thismenu=findobj(udata.view.tabobjects,'tag','analysismenu');
end

%value is the index in the list that was clicked. Need to convert this to
%the target graph's index.

udata.view.(thisaxis).value=value;
set(handles.fakeax(ai),'userdata',udata);


value=udata.view.(thisaxis).variables(value);

set(thismenu,'value',value)
cb=get(thismenu,'callback');

tabobjects=handles.tabobjects;
ai=handles.activeindex;
ag=handles.activegraph;
at=handles.activetype;

handles.tabobjects=udata.view.tabobjects;
handles.activeindex=idx;
handles.activegraph=handles.allgraphs(idx);
handles.activetype=get(handles.allgraphs(idx),'userdata');

guidata(handles.fig,handles)
cb(thismenu,[]);
handles=guidata(handles.fig);

handles.activeindex=ai;
handles.activegraph=ag;
handles.activetype=at;
handles.tabobjects=tabobjects;

guidata(handles.fig,handles);
