function pointselectline(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

%raise this line to the top:
%uistack(src,'top')

if ~strcmp(handles.selectionmode,'point')
    lineobject_callback(src,[]);
    return
end

ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
handles.temp.selected=findobj(gca,'tag','selected');
handles.temp.main=findobj(gca,'tag','line');

clicked=get(gca,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);

%convert xclick/yclick to pixels.
% xdata=get(src,'xdata');
% ydata=get(src,'ydata');

inpoints=ravefindclosestpoint2D(xclick,yclick,src);

%need to set all data properties so dimensions are correct.
for j=1:length(handles.temp.selected)
    ycol=get(handles.temp.selected(j),'userdata');
    thismain=findobj(handles.temp.main,'markersize',ycol);
    ydata=get(thismain,'ydata');
    xdata=get(thismain,'xdata');
    set(handles.temp.selected(j),'xdata',xdata(inpoints),'ydata',ydata(inpoints),'visible','on');
end

handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;

%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

if udata.format.updatedials
    datasets=raveguidata(handles.fig,'datasets');
    handles.xdials{udata.view.dataset}{udata.view.analysis}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],udata.view.dataset,udata.view.analysis);
end


