function formattabscatter(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);
dataseriestext=text(.15-.10317,.515*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);
legendtext=text(.15-.10317,.12*1.0317-.0317,'Legends','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);

%% GRAPH UICONTROLS

bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridtext=uicontrol('position',[origin(1)+25 origin(2)+550 180 20],...
    'style','text','string','Grid Lines:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


bgidx=udata.format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{1}(2,:),'value',bgidx==1,...
    'callback',@bgblob_callback,'userdata',1,'tag','bgblob');
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{2}(2,:),'value',bgidx==2,...
    'callback',@bgblob_callback,'userdata',2,'tag','bgblob');
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{3}(2,:),'value',bgidx==3,...
    'callback',@bgblob_callback,'userdata',3,'tag','bgblob');
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{4}(2,:),'value',bgidx==4,...
    'callback',@bgblob_callback,'userdata',4,'tag','bgblob');

gridindex=eye(3);
gridin=udata.format.grid;


%grid radios
nogrid=uicontrol('position',[origin(1)+100 origin(2)+551 60 20],...
    'style','radiobutton','string','None','backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(1,gridin),'callback',@nogrid_callback);
magrid=uicontrol('position',[origin(1)+152 origin(2)+551 60 20],...
    'style','radiobutton','string','Major','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(2,gridin),'callback',@magrid_callback);
migrid=uicontrol('position',[origin(1)+204 origin(2)+551 55 20],...
    'style','radiobutton','string','Minor','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(3,gridin),'callback',@migrid_callback);

handles.gridchecks=[nogrid magrid migrid];

%% Axes UICONTROLS

xlim=get(handles.activegraph,'xlim');
ylim=get(handles.activegraph,'ylim');

[xlabel ylabel zlabel]=ravemakelabelstrings(handles.activegraph);

xlabeltext=uicontrol('position',[origin(1)+25 origin(2)+498 180 20],...
    'style','text','string','X Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlimtext=uicontrol('position',[origin(1)+35 origin(2)+474 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xto=uicontrol('position',[origin(1)+158 origin(2)+474 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlabelbox=uicontrol('position',[origin(1)+85 origin(2)+500 160 20],...
    'style','edit','string',xlabel,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@xlabel_callback);
xminbox=uicontrol('position',[origin(1)+85 origin(2)+476 70 20],...
    'style','edit','string',xlim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmin_callback,...
    'tag','xminbox');
xmaxbox=uicontrol('position',[origin(1)+175 origin(2)+476 70 20],...
    'style','edit','string',xlim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmax_callback,...
    'tag','xmaxbox');
xresetbutton=uicontrol('position',[origin(1)+85 origin(2)+452 160 20],...
    'style','pushbutton','string','Reset X Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@xresetbutton_callback);

ylabeltext=uicontrol('position',[origin(1)+25 origin(2)+410 180 20],...
    'style','text','string','Y Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylimtext=uicontrol('position',[origin(1)+35 origin(2)+386 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
yto=uicontrol('position',[origin(1)+158 origin(2)+386 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylabelbox=uicontrol('position',[origin(1)+85 origin(2)+412 160 20],...
    'style','edit','string',ylabel,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@ylabel_callback);
yminbox=uicontrol('position',[origin(1)+85 origin(2)+388 70 20],...
    'style','edit','string',ylim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymin_callback,...
    'tag','yminbox');
ymaxbox=uicontrol('position',[origin(1)+175 origin(2)+388 70 20],...
    'style','edit','string',ylim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymax_callback,...
    'tag','ymaxbox');
yresetbutton=uicontrol('position',[origin(1)+85 origin(2)+364 160 20],...
    'style','pushbutton','string','Reset Y Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@yresetbutton_callback);

titletext=uicontrol('position',[origin(1)+25 origin(2)+332 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+333 180 20],...
    'style','edit','string',get(get(handles.activegraph,'title'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

%%  marker DATA SERIES UICONTROLS
markerstyletext=uicontrol('position',[origin(1)+50 origin(2)+280 49 20],...
    'style','text','string','Marker:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
markersizetext=uicontrol('position',[origin(1)+66 origin(2)+250 36 20],...
    'style','text','string','Size:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
markercolortext=uicontrol('position',[origin(1)+60 origin(2)+180 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

markerstyleaxes=axes('units','pixels','position',[origin(1)+102 origin(2)+282 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);
gap=.9/7;
%markerstyleoptions:
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

line(.05,.5,'marker','s','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+gap,.5,'marker','o','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+2*gap,.5,'marker','d','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+3*gap,.5,'marker','^','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+4*gap,.5,'marker','h','parent',markerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+5*gap,.5,'marker','p','parent',markerstyleaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.05+6*gap,.5,'marker','*','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')
line(.95,.5,'marker','+','parent',markerstyleaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@styleblob_callback,'tag','styleblob')

%handles.styleblobs=get(markerstyleaxes,'children');
%color selected style:

hhh=findobj(markerstyleaxes,'marker',udata.format.marker);
set(hhh,'markerfacecolor',oncolor);

markersizeaxes=axes('units','pixels','position',[origin(1)+100 origin(2)+277-25 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'parent',handles.fig);
%gap=.9/7;
%markersizeoptions:
line(.05,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',1,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.12,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.22,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',6,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.33,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.45,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.59,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.75,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',14,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.95,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',18,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')

%handles.sizeblobs=get(markersizeaxes,'children');

%make size blobs the right style

%color the selected blob
hhh=findobj(markersizeaxes,'markersize',sqrt(udata.format.minmarkersize));
set(hhh,'markerfacecolor',oncolor);

cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});

markercolor=uicontrol('position',[origin(1)+115 origin(2)+182 120 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','cdata',cdata,'callback',@mcolor_callback);

noisycolorcheck=uicontrol('position',[origin(1)+125 origin(2)+152 120 20],...
    'style','checkbox','string','Use Noisy Colors','value',udata.format.ncolor,'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left','callback',@ncolor_callback);


%% marker fill uicontrols:
markerfilltext=uicontrol('position',[origin(1)+74 origin(2)+215 29 20],...
    'style','text','string','Fill:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

markerfillaxes=axes('units','pixels','position',[origin(1)+132 origin(2)+217 80 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);
gap=.9/2;
%markerstyleoptions:
offcolor=[.6 .6 .6];
oncolor=handles.colors.text;

f1=line(.05,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',[1 1 1],...
    'markeredgecolor',offcolor,'buttondownfcn',@fillblob_callback,'userdata',1,'tag','fillblob');
f2=line(.05+gap,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',offcolor,...
    'markeredgecolor',offcolor,'buttondownfcn',@fillblob_callback,'userdata',2,'tag','fillblob');
f3=line(.95,.5,'marker','p','parent',markerfillaxes,'markersize',16,'markerfacecolor',offcolor,...
    'markeredgecolor',[0 0 0],'buttondownfcn',@fillblob_callback,'userdata',3,'tag','fillblob');

%handles.fillblobs=[f1 f2 f3];
%color selected style:
fillstyle=udata.format.markerfill;
if fillstyle==1
    set(f1,'markeredgecolor',oncolor)
elseif fillstyle==2
    set(f2,'markerfacecolor',oncolor,'markeredgecolor',oncolor)
else %fillstyle=3
    set(f3,'markerfacecolor',oncolor)
end


%% legend uicontrols
% legendbutton=uicontrol('position',[origin(1)+115 origin(2)+68 160 20],...
%     'style','pushbutton','string','Format Legend','fontname','arial','fontsize',10,...
%     'backgroundcolor',handles.colors.buttonbg,'callback',@formatlegend_callback,...
%     'fontweight','bold');


legendcheck=uicontrol('position',[origin(1)+35 origin(2)+28 160 20],...
    'style','checkbox','string','Show Legend','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@legendcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',udata.format.legend,...
    'visible','on');

colorbarcheck=uicontrol('position',[origin(1)+35 origin(2)+6 160 20],...
    'style','checkbox','string','Show Colorbar','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@colorbarcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',udata.format.colorbar);


%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext gridtext bgwhite...
    bglight bgdark bgblack nogrid magrid migrid xlabeltext ylabeltext...
    xlimtext ylimtext xlabelbox ylabelbox xminbox yminbox xto xmaxbox...
    xresetbutton yto ymaxbox yresetbutton markerstyletext markersizetext markercolortext...
    markerstyleaxes markersizeaxes markercolor markerfilltext markerfillaxes...
    legendtext legendcheck titletext titlebox noisycolorcheck colorbarcheck        ];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);

%% HERE BE CALLBACKS
%
%
%
%
%
%
%
%
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function styleblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);

offcolor=[.9 .9 .9];
styleblobs=findobj(handles.tabobjects,'tag','styleblob');

set(styleblobs,'markerfacecolor',offcolor)
set(src,'markerfacecolor',handles.colors.text)
%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.marker=get(src,'marker');
set(handles.fakeax(handles.activeindex),'userdata',udata);

%get target data series
targets=[udata.view.filthandles(:);udata.view.mainhandles(:);udata.view.selhandles(:)];
set(targets,'marker',get(src,'marker'));

if udata.explore.mouseover
    set(udata.explore.mouseoverhandles(1),'marker',get(src,'marker'));
end

%update sizeblobs
sizeblobs=findobj(handles.tabobjects,'tag','sizeblob');
set(sizeblobs,'marker',get(src,'marker'));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fillblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

offcolor=[.6 .6 .6];
oncolor=handles.colors.text;

fillblobs=sort(findobj(handles.tabobjects,'tag','fillblob'));

set(fillblobs(1),'markeredgecolor',offcolor)
set(fillblobs(2),'markerfacecolor',offcolor,'markeredgecolor',offcolor)
set(fillblobs(3),'markerfacecolor',offcolor)

%get target data series
fillstyle=get(src,'userdata');
if ~udata.view.uselines
    if fillstyle==1
        set(udata.view.mainhandles,'markerfacecolor','none','markeredgecolor','flat');
        set(udata.view.filthandles,'markerfacecolor','none','markeredgecolor',handles.colors.filtered);
        set(src,'markeredgecolor',oncolor)
    elseif fillstyle==2
        set(udata.view.mainhandles,'markerfacecolor','flat','markeredgecolor','none');
        set(udata.view.filthandles,'markerfacecolor',handles.colors.filtered,'markeredgecolor','none');
        set(src,'markerfacecolor',oncolor,'markeredgecolor',oncolor);
    else %fillstyle=3
        set(udata.view.mainhandles,'markerfacecolor','flat','markeredgecolor',[0 0 0]);
        set(udata.view.filthandles,'markerfacecolor',handles.colors.filtered,'markeredgecolor','none');
        set(src,'markerfacecolor',oncolor);
    end
else
    colors=handles.prefs.rowcolors;
    for j=1:10
        if fillstyle==1
            set(udata.view.mainhandles(j),'markerfacecolor','none','markeredgecolor',colors(j,:));
            set(udata.view.filthandles,'markerfacecolor','none','markeredgecolor',handles.colors.filtered);
            set(src,'markeredgecolor',oncolor);
        elseif fillstyle==2
            set(udata.view.mainhandles(j),'markerfacecolor',colors(j,:),'markeredgecolor','none');
            set(udata.view.filthandles,'markerfacecolor',handles.colors.filtered,'markeredgecolor','none');
            set(src,'markerfacecolor',oncolor,'markeredgecolor',oncolor);
        else %fillstyle=3
            set(udata.view.mainhandles(j),'markerfacecolor',colors(j,:),'markeredgecolor',[0 0 0]);
            set(udata.view.filthandles,'markerfacecolor',handles.colors.filtered,'markeredgecolor','none');
            set(src,'markerfacecolor',oncolor);
        end
    end
end

udata.format.markerfill=fillstyle;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizeblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

sizeblobs=findobj(handles.tabobjects,'tag','sizeblob');

%get new size:
newsize=get(src,'markersize')^2;

if strcmp(get(gcf,'selectiontype'),'alt')
    if newsize>udata.format.minmarkersize
        udata.format.maxmarkersize=newsize;
    else
        return
    end
else
    udata.format.minmarkersize=newsize;
    set(sizeblobs,'markerfacecolor',offcolor)
    set(src,'markerfacecolor',oncolor)
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatescatter(handles.fig,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function magrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.fakerax(handles.activeindex),'XGrid','on','YGrid','on')
set(handles.fakerax(handles.activeindex),'XminorGrid','off','YminorGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','off','YGrid','off')

function migrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=3;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(handles.fakerax(handles.activeindex),'XminorGrid','on','YminorGrid','on')
set(handles.fakerax(handles.activeindex),'XGrid','off','YGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','on','YGrid','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nogrid_callback(src, eventdata) %#ok<INUSD>
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=1;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.fakerax(handles.activeindex),'XminorGrid','off','YminorGrid','off')
set(handles.fakerax(handles.activeindex),'XGrid','off','YGrid','off')
set(handles.fakeax(handles.activeindex),'XGrid','off','YGrid','off')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function xmin_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(1)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xmax_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(2)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ymin_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
ylim=get(handles.activegraph,'ylim');
ylim(1)=newval;
set(handles.activegraph,'ylim',ylim)
set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ymax_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=eval(get(src,'string'));
ylim=get(handles.activegraph,'ylim');
ylim(2)=newval;
set(handles.activegraph,'ylim',ylim)
set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xresetbutton_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(handles.activegraph,'xlimmode','auto')
xlim=get(handles.activegraph,'xlim');

set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

xminbox=findobj(handles.tabobjects,'tag','xminbox');
xmaxbox=findobj(handles.tabobjects,'tag','xmaxbox');

set(xminbox,'string',num2str(xlim(1)))
set(xmaxbox,'string',num2str(xlim(2)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yresetbutton_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(handles.activegraph,'ylimmode','auto')
ylim=get(handles.activegraph,'ylim');

set(handles.fakeax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))
set(handles.fakerax(handles.activeindex),'ylim',ylim,'xlim',get(handles.activegraph,'xlim'))

yminbox=findobj(handles.tabobjects,'tag','yminbox');
ymaxbox=findobj(handles.tabobjects,'tag','ymaxbox');

set(yminbox,'string',num2str(ylim(1)))
set(ymaxbox,'string',num2str(ylim(2)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xlabel_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

label=get(src,'string');
newlabel=ravemakelabelcells(label,udata.format.nxlabelrows);
set(get(handles.activegraph,'xlabel'),'string',newlabel)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ylabel_callback(src,eventdata)

handles=guidata(src);
set(get(handles.activegraph,'ylabel'),'string',get(src,'string'))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mcolor_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

[newcmap,reverse]=ravechoosecolormap(src,[],udata.format.mcmap,udata.format.reversecolors);
if newcmap==udata.format.mcmap && reverse==udata.format.reversecolors
    return
end

udata.format.mcmap=newcmap;
udata.format.reversecolors=reverse;

set(handles.fakeax(handles.activeindex),'userdata',udata);



colorz=handles.cmapnames;
newcolormap=colorz{newcmap};
cdata=ravemakecdata(handles.fig,[],newcolormap);
set(src,'cdata',cdata);


ravecreatescatter(src,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
function ncolor_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.ncolor=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatescatter(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colorbarcheck_callback(src,eventdata)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.colorbar=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescatter(src,[]);


function legendcheck_callback(src,ev)
