function ravemouseoverscatterdata(src,ev,ai)
%persistent handles udata

handles=guidata(src);

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles.fig,[],handles,ai);    
end

function processmouseover(src,ev,handles,ai)
datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(ai),'userdata');

%show mouseovertext:
loc=get(handles.allgraphs(ai),'currentpoint');

xclick=loc(1,1);
yclick=loc(1,2);

xcol=udata.view.x;
ycol=udata.view.y;


[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);
allrows=find(mainrows | filteredrows);

%idx=ravefindclosestpoint2D(xclick,yclick,datasets.alldata{udata.view.dataset}(:,[xcol ycol]),handles.allgraphs(ai));
idx=ravefindclosestpoint2D(xclick,yclick,datasets.alldata{udata.view.dataset}(allrows,[xcol ycol]),handles.allgraphs(ai));
%idx=find(idx);
idx=allrows(idx);

%calculate pixel offsets:
pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');
xpix=(xlim(2)-xlim(1))./pos(3);
ypix=(ylim(2)-ylim(1))./pos(4);

xoff=6;
yoff=6;

d=udata.view.dataset;
a=udata.view.analysis;

%show highlight marker:
%determine size:
if udata.view.s==0
    s=sqrt(udata.format.minmarkersize);
else
    s=datasets.alldata{d}(idx,udata.view.s);
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    
    mins=min(datasets.alldata{d}(:,udata.view.s));
    maxs=max(datasets.alldata{d}(:,udata.view.s));
    
    if mins~=maxs %avoid divide by zero
        s=(((s-mins)/(maxs-mins)).^2)*maxsize + minsize;% + rand(length(x),1)/100;
        s=sqrt(round(s)+1);
    else
        s=sqrt(udata.format.minmarkersize);
    end
end

set(udata.explore.mouseoverhandles(1),'xdata',datasets.alldata{d}(idx,xcol),'ydata',datasets.alldata{d}(idx,ycol),'markersize',s,'visible','on');

%show text label:
set(udata.explore.mouseoverhandles(2),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol])+[(xoff-1)*xpix (yoff+s*0.75)*ypix])
set(udata.explore.mouseoverhandles(3),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol])+[(xoff+1)*xpix (yoff+s*0.75)*ypix])
set(udata.explore.mouseoverhandles(4),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol])+[xoff*xpix (yoff+1+s*0.75)*ypix])
set(udata.explore.mouseoverhandles(5),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol])+[xoff*xpix (yoff-1+s*0.75)*ypix])
set(udata.explore.mouseoverhandles(6),'position',datasets.alldata{udata.view.dataset}(idx,[xcol ycol])+[xoff*xpix (yoff+s*0.75)*ypix])

% if handles.rowlabelcolumn{d}==0
%     set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.0f',idx)));
% else
%     switch handles.datatype{d}{handles.rowlabelcolumn{d}}
%         case 'string'
%             val=handles.discretevalues{d}{a}{handles.rowlabelcolumn{d}}{datasets.alldata{d}(idx,handles.rowlabelcolumn{d})};
%             set(udata.explore.mouseoverhandles(2:end),'visible','on','string',val);
%         otherwise
%             val=datasets.alldata{d}(idx,handles.rowlabelcolumn{d});
%             set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.6g',val)));
%     end
% end


val = ravegetrowlabelstring(handles,datasets,d,a,idx);
 set(udata.explore.mouseoverhandles(2:end),'visible','on','string',val);

if udata.view.c>0 && udata.format.colorbar
    %make mouseover pointers:
    
    legdata=get(handles.fakerax(ai),'userdata');
    aaa=findobj(legdata,'tag','Colorbar');
    pos=get(aaa,'position');
    ylim=get(aaa,'ylim');
    xlim=get(aaa,'xlim');
    
    clim=[min(datasets.alldata{d}(:,udata.view.c)) max(datasets.alldata{d}(:,udata.view.c))];
    
    %determine current c value:
    thisvalue=datasets.alldata{d}(idx,udata.view.c);
    thiscoord=interp1(clim,ylim,thisvalue);
    pixels=pos(3)./(xlim(2)-xlim(1)); %pixels per unit

    set(udata.explore.cbarmouseovervalue,'ydata',[thiscoord-1 thiscoord+1  thiscoord],'visible','on');
    set(udata.explore.cbarmouseovertext,'position',[xlim(2)+3/pixels,thiscoord],'visible','on','string',sprintf('%5.5g',thisvalue));
end
