function viewtabdensity(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.76,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.2,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
xaxistext=text(.25-.10317,.73,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.66,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,.59,'Color Tiles by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
sizetext=text(.25-.10317,.52,'Size Tiles by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
formattext=text(.25-.10317,.52-.07,'Grid Shape:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
gridsizetext=text(.25-.10317,0.375,'Grid Resolution:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

%% variable lists
analysismenu=uicontrol('position',[origin(1)+55 origin(2)+537 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',udata.view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+492 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',udata.view.dataset);
xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+422 180 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',udata.view.x);
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+377 180 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.y);
colormenu=uicontrol('position',[origin(1)+55 origin(2)+332 180 30],...
    'style','popupmenu','string',[cellstr('<Data Density>'),cellstr('<Majority Row Color>'),cellstr('<Fixed Color>'),handles.allnames{d}(1:end)],'callback',@colormenu_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',udata.view.c+3);
sizemenu=uicontrol('position',[origin(1)+55 origin(2)+287 180 30],...
    'style','popupmenu','string',[cellstr('<Data Density>'),cellstr('<Uniform Size>'),handles.allnames{d}(1:end)],'callback',@sizemenu_callback,...
    'backgroundcolor',[1 1 1],'tag','sizemenu','value',udata.view.s+2);


switch udata.view.gridshape
    case 'hexagon'
        val=1;
end


formatmenu=uicontrol('position',[origin(1)+55 origin(2)+242 180 30],...
    'style','popupmenu','string',{'Hexagon'},'callback',@formatmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','gridshapemenu','value',val);

value=udata.view.gridsize/2;

gridsizecounter=uicontrol('position',[104+3.9*value origin(2)+235-65 40 20],...
    'style','text','string',num2str(udata.view.gridsize),'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',12,'horizontalalignment','left','fontweight','bold');

%scale slider:
[jslider1 hslider1]=javacomponent('javax.swing.JSlider',[origin(1)+50 origin(2)+255-60 190 30]);
jslider1.setPaintTicks(1)
jslider1.setSnapToTicks(0)
jslider1.setMinimum(5)
jslider1.setMaximum(50)
jslider1.setMajorTickSpacing(2);
%jslider.setMinorTickSpacing(1);
jslider1.setValue(value);
set(jslider1,'background',java.awt.Color.white)
set(jslider1,'StateChangedCallback',{@gridsize_Callback,gridsizecounter});


precisecheck=uicontrol('position',[origin(1)+35 origin(2)+142 210 30],...
    'style','checkbox','string','Draw 1-point cells at exact location','callback',@precisecheck_callback,...
    'backgroundcolor',[1 1 1],'value',udata.view.preciseoutliers);



%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu colormenu,...
    analysistext projecttext analysismenu dataseriestext optionstext,...
    sizetext sizemenu formattext formatmenu gridsizetext gridsizecounter hslider1 precisecheck];

handles.activetab='view';

guidata(src,handles);

%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=get(src,'value');

%get initial columns for this data set:
if ~all(handles.isfunction{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isfunction{d}),1);
    y=find((~handles.isconstant{d} & handles.isfunction{d}),1);
    c=0;
    s=0;
else
    x=find((~handles.isconstant{d}),1);
    y=find((~handles.isconstant{d}),1);
    c=0;
    s=0;
end

udata.view.dataset=d;
udata.view.x=x;
udata.view.y=y;
udata.view.c=c;
udata.view.s=s;
udata.format.xlim=[];
udata.format.ylim=[];

set(handles.fakeax(handles.activeindex),'userdata',udata);


handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);
viewtab(handles.fig,[])
ravecreatedensity(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatedensity(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.x=(get(src,'value'));
udata.format.xlim=[];
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatedensity(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.y=(get(src,'value'));
udata.format.ylim=[];
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatedensity(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colormenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
guidata(src,handles);
udata.view.c=get(src,'value')-3;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatedensity(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizemenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.s=get(src,'value')-2;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatedensity(src,[]);

function gridsize_Callback(src,ev,hObject) %#ok<INUSL>
gridsize=src.getValue*2;

pos=get(hObject,'position');
set(hObject,'string',sprintf('%3.0f',gridsize),'position',[104+3.9*src.getValue pos(2:4)]);

if src.getValueIsAdjusting;return;end

handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.gridsize=gridsize;
set(handles.fakeax(handles.activeindex),'userdata',udata)
guidata(hObject,handles);
%update histogram:
ravecreatedensity(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function formatmenu_callback(src,ev)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function precisecheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.preciseoutliers=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatedensity(handles.fig,[]);
