function formattabparallelcoords(src,eventdata) %#ok<INUSD>
%rave format tab for line graphs.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata'); %i think the (1) is for if multiple graphs are selected.

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.60,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
legendtext=text(.15-.10317,.12*1.0317-.0317,'Legends','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);

%% GRAPH UICONTROLS

bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

bgidx=udata.format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{1}(2,:),'value',bgidx==1,...
    'callback',@bgblobpc_callback,'userdata',1,'tag','bgblob');
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{2}(2,:),'value',bgidx==2,...
    'callback',@bgblobpc_callback,'userdata',2,'tag','bgblob');
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{3}(2,:),'value',bgidx==3,...
    'callback',@bgblobpc_callback,'userdata',3,'tag','bgblob');
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{4}(2,:),'value',bgidx==4,...
    'callback',@bgblobpc_callback,'userdata',4,'tag','bgblob');


%% Axes UICONTROLS

xlim=get(handles.activegraph,'xlim');
texts=findobj(handles.activegraph,'tag','axeslabel');
%oldstring=unlinewrap(get(texts(1),'string'));


xvartext=uicontrol('position',[origin(1)+20 origin(2)+498 180 20],...
    'style','text','string','Variable:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

xvarmenu=uicontrol('position',[origin(1)+85 origin(2)+500 160 20],...
    'style','popupmenu','string',handles.allnames{udata.view.dataset}(udata.view.x),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@xvarmenu_callback,'tag','xvarmenu');

% xlabeltext=uicontrol('position',[origin(1)+25 origin(2)+498-25 180 20],...
%     'style','text','string','X Label:','backgroundcolor',handles.colors.tabbg,...
%     'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlimtext=uicontrol('position',[origin(1)+36 origin(2)+474-25 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xto=uicontrol('position',[origin(1)+158 origin(2)+474-25 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
% xlabelbox=uicontrol('position',[origin(1)+85 origin(2)+500-25 160 20],...
%     'style','edit','string',oldstring,'backgroundcolor',[1 1 1],...
%     'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@xlabel_callback,'tag','xlabelbox');
xminbox=uicontrol('position',[origin(1)+85 origin(2)+476-25 70 20],...
    'style','edit','string',xlim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmin_callback,...
    'tag','xminbox','enable','off');
xmaxbox=uicontrol('position',[origin(1)+175 origin(2)+476-25 70 20],...
    'style','edit','string',xlim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmax_callback,...
    'tag','xmaxbox','enable','off');
xresetbutton=uicontrol('position',[origin(1)+85 origin(2)+452-25 160 20],...
    'style','pushbutton','string','Reset X Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@xresetbutton_callback,'enable','off');

titletext=uicontrol('position',[origin(1)+25 origin(2)+397 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+400 180 20],...
    'style','edit','string',get(get(handles.activegraph,'title'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

%%  marker DATA SERIES UICONTROLS

markersizetext=uicontrol('position',[origin(1)+30 origin(2)+275-25-50 80 20],...
    'style','text','string','Filter Size:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
markercolortext=uicontrol('position',[origin(1)+24 origin(2)+240-25-50 180 20],...
    'style','text','string','Filter Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
selecttext=uicontrol('position',[origin(1)+21 origin(2)+64+65 180 20],...
    'style','text','string','Select Data:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


offcolor=[.9 .9 .9];
oncolor=handles.colors.text;

markersizeaxes=axes('units','pixels','position',[origin(1)+100 origin(2)+277-25-50 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1]);

%markersizeoptions:
line(.05,.5,'marker','s','parent',markersizeaxes,'markersize',3,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.12,.5,'marker','s','parent',markersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.22,.5,'marker','s','parent',markersizeaxes,'markersize',6,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.33,.5,'marker','s','parent',markersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.45,.5,'marker','s','parent',markersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.59,.5,'marker','s','parent',markersizeaxes,'markersize',12,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.75,.5,'marker','s','parent',markersizeaxes,'markersize',14,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.95,.5,'marker','s','parent',markersizeaxes,'markersize',18,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')

%handles.sizeblobs=get(markersizeaxes,'children');

%make size blobs the right style
set(get(markersizeaxes,'children'),'marker',udata.format.marker)

%color the selected blob
hhh=findobj(markersizeaxes,'tag','sizeblob','markersize',udata.format.markersize);
set(hhh,'markerfacecolor',oncolor);

noisycolorscheck=uicontrol('position',[origin(1)+41 origin(2)+250+20 150 20],...
    'style','checkbox','string','Use Noisy Colors','backgroundcolor',handles.colors.tabbg,...
    'fontsize',10,'horizontalalignment','left','callback',@ncolor_callback,'fontweight','bold','fontname','arial',...
    'value',udata.format.ncolor);

markercolor=uicontrol('position',[origin(1)+115 origin(2)+242-25-50 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.markercolor,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@mcolor_callback);

resetfilterbutton=uicontrol('position',[origin(1)+115+35 origin(2)+242-25-50 100 20],...
    'style','pushbutton','string','Reset ALL Filters','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',8,'horizontalalignment','left','callback',@resetfilter_callback);


%%  line DATA SERIES UICONTROLS

linesizetext=uicontrol('position',[origin(1)+26 origin(2)+313+20 80 20],...
    'style','text','string','Line Width:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
linecolortext=uicontrol('position',[origin(1)+60 origin(2)+280+20 180 20],...
    'style','text','string','Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

%linestyleoptions:
offcolor=[.5 .5 .5];
oncolor=handles.colors.text;

%width slider:
[jslider hslider]=javacomponent('javax.swing.JSlider',[origin(1)+125 origin(2)+317+20 110 27]);
jslider.setPaintTicks(1)
jslider.setSnapToTicks(1)
jslider.setMinimum(1)
jslider.setMaximum(10)
jslider.setMajorTickSpacing(1);
jslider.setValue(udata.format.linesize);
set(jslider,'background',java.awt.Color.white)
set(jslider,'StateChangedCallback',{@linewidth_callback,handles.fig});

% handles.javacomps=jslider;

widthaxes=axes('units','pixels','position',[origin(1)+125 origin(2)+330 110 5],'visible','off');
gauge=imread('widthgauge.bmp');
image(gauge,'parent',widthaxes)
set(widthaxes,'visible','off');

cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.lcmap});

linecolor=uicontrol('position',[origin(1)+115 origin(2)+281+20 120 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','cdata',cdata,'callback',@lcolor_callback);

%% legend uicontrols
selectinbutton=uicontrol('position',[origin(1)+50+60 origin(2)+64+65 60 22],...
    'style','pushbutton','string','Feasible','backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left','callback',@selectinbutton_callback,'tag','hidefilteredbutton');

selectoutbutton=uicontrol('position',[origin(1)+115+60 origin(2)+64+65 60 22],...
    'style','pushbutton','string','Infeasible','backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',10,'horizontalalignment','left','callback',@selectoutbutton_callback,'tag','hidefilteredbutton');

legendcheck=uicontrol('position',[origin(1)+85 origin(2)+48-20 160 20],...
    'style','checkbox','string','Show Legend','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@legendcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',0,'enable','off');

colorbarcheck=uicontrol('position',[origin(1)+85 origin(2)+26-20 160 20],...
    'style','checkbox','string','Show Colorbar','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@colorbarcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',udata.format.colorbar);


%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext bgwhite...
    bglight bgdark bgblack...
    xlimtext xminbox xto xmaxbox...
    xresetbutton markersizetext markercolortext...
    markersizeaxes markercolor linesizetext linecolortext...
    widthaxes linecolor legendtext  titletext titlebox...
    selecttext hslider noisycolorscheck selectinbutton selectoutbutton...
    xvartext xvarmenu legendcheck colorbarcheck resetfilterbutton];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);

%% HERE BE CALLBACKS
%
%
%
%
%
%
%
%
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizeblob_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);

offcolor=[.9 .9 .9];

sizeblobs=findobj(handles.tabobjects,'tag','sizeblob');

set(sizeblobs,'markerfacecolor',offcolor)
set(src,'markerfacecolor',handles.colors.text)
%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.markersize=get(src,'markersize');
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(udata.view.mindraggers(:,1),'markersize',get(src,'markersize'))
set(udata.view.maxdraggers(:,1),'markersize',get(src,'markersize'))
set(udata.view.mindraggers(:,2),'markersize',get(src,'markersize')+10)
set(udata.view.maxdraggers(:,2),'markersize',get(src,'markersize')+10)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function bgblobpc_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
uicontrol(handles.dummyobj)

bgblobs=findobj(handles.tabobjects,'tag','bgblob');
set(bgblobs,'value',0);
set(src,'value',1);

newidx=get(src,'userdata');
udata.format.bg=newidx;

%get colors:
axescolors=handles.colors.axes{newidx};
fgcolor=axescolors(1,:);
bgcolor=axescolors(2,:);
lightgrid=axescolors(3,:);
stronggrid=axescolors(4,:);

%change colors
set(handles.fakerax(handles.activeindex),'color',bgcolor,'xcolor',lightgrid,'ycolor',lightgrid)
set(handles.fakeax(handles.activeindex),'xcolor',stronggrid,'ycolor',stronggrid);
set(handles.activegraph,'xcolor',fgcolor,'ycolor',fgcolor,'zcolor',fgcolor);
set([get(handles.activegraph,'xlabel') get(handles.activegraph,'ylabel') get(handles.activegraph,'zlabel')],'color',fgcolor)

%change colors
texters=findobj(handles.activegraph,'tag','mintexter','-or','tag','maxtexter');
set(texters,'backgroundcolor',bgcolor);

linez=findobj(handles.activegraph,'tag','parallelaxes');
set(linez,'color',fgcolor);
set(texters,'color',fgcolor);
udata.view.offcolor=lightgrid;

background=findobj(handles.fakerax(handles.activeindex),'tag','background');
set(background,'facecolor',bgcolor);

set(handles.fakeax(handles.activeindex),'userdata',udata);

allkidz=sort(findobj(handles.activegraph,'tag','main'));
selected=sort(findobj(handles.activegraph,'tag','selected'));
hiddens=findobj(handles.activegraph,'tag','hidden');

set(hiddens,'color',udata.view.offcolor);


% set(allkidz(udata.view.filtered),'color',udata.view.offcolor)
% set(selected(udata.view.filtered),'color',udata.view.offcolor)
set(handles.fakeax(handles.activeindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function xmin_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=str2double(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(1)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

function xmax_callback(src, eventdata) %#ok<INUSD>

handles=guidata(src);
newval=str2double(get(src,'string'));
xlim=get(handles.activegraph,'xlim');
xlim(2)=newval;
set(handles.activegraph,'xlim',xlim)
set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))


function xresetbutton_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
set(handles.activegraph,'xlimmode','auto')
xlim=get(handles.activegraph,'xlim');

set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))
set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',get(handles.activegraph,'ylim'))

xminbox=findobj(handles.tabobjects,'tag','xminbox');
xmaxbox=findobj(handles.tabobjects,'tag','xmaxbox');

set(xminbox,'string',num2str(xlim(1)))
set(xmaxbox,'string',num2str(xlim(2)))


function linewidth_callback(src,eventdata,fighandle) %#ok<INUSL>

handles=guidata(fighandle);

%update inputs

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.linesize=src.getValue/2;
set(handles.fakeax(handles.activeindex),'userdata',udata);


%get target data series
targets=findobj(handles.activegraph,'tag','filtered');
set(targets,'linewidth',udata.format.linesize);


targets=findobj(handles.activegraph,'tag','main');
set(targets,'linewidth',udata.format.linesize);

selected=findobj(handles.activegraph,'tag','selected');
set(selected,'linewidth',udata.format.linesize+1);


%update graph


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xlabel_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);

axpos=get(handles.activegraph,'position');
texts=findobj(handles.activegraph,'tag','axeslabel');

nvars=numel(texts);
width=axpos(3)/(nvars-1);
maxchars=round(width/8);


xvarmenu=findobj(handles.tabobjects,'tag','xvarmenu');

set(texts(get(xvarmenu,'value')),'string',linewrap(get(src,'string'),maxchars))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function mcolor_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
uicontrol(handles.dummyobj)

udata.format.markercolor=ravecolorchooser(handles.fig,udata.format.markercolor,'Pick a Color');


set(src,'backgroundcolor',udata.format.markercolor)

targets=findobj(handles.activegraph,'tag','mindragger','-or','tag','maxdragger');
set(targets,'markerfacecolor',udata.format.markercolor)

set(handles.fakeax(handles.activeindex),'userdata',udata);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function lcolor_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
uicontrol(handles.dummyobj)


newcmap=ravechoosecolormap(src,[],udata.format.lcmap);

if newcmap==udata.format.lcmap;return;end
udata.format.lcmap=newcmap;

colorz=handles.cmapnames;
newcolormap=colorz{newcmap};

cdata=ravemakecdata(handles.fig,[],newcolormap);
set(src,'cdata',cdata);


set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateparallelcoords(handles.fig,[]);


if udata.format.colorbar;
    if udata.view.c
        ravemakecolorbar(handles.fig,[]);
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5


function xvarmenu_callback(src,ev)
handles=guidata(src);


texts=findobj(handles.activegraph,'tag','axeslabel');
xlabelbox=findobj(handles.tabobjects,'tag','xlabelbox');

oldstring=unlinewrap(get(texts(get(src,'value')),'string'));

set(xlabelbox,'string',oldstring);


function legendcheck_callback(src,ev)





function resetfilter_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.maxfiltercoord=ones(1,numel(udata.view.maxfiltercoord));
udata.view.minfiltercoord=zeros(1,numel(udata.view.minfiltercoord));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateparallelcoords(handles.fig,[]);




function selectinbutton_callback(src,ev)
%need to base selection on ALL rows, including hidden ones. otherwise
%indexing gets screwed up.
handles=guidata(src);
datasets=raveguidata(src,'datasets');
udata=get(handles.fakeax(handles.activeindex),'userdata');

%filter on ALL data:
allydata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
%normalize:
data1=bsxfun(@minus,allydata,min(allydata));
data2=bsxfun(@rdivide,data1,max(data1));
data2(isnan(data2))=.5;
allydata=data2;


maxoutlier=bsxfun(@gt,allydata,udata.view.maxfiltercoord(udata.view.x));
minoutlier=bsxfun(@lt,allydata,udata.view.minfiltercoord(udata.view.x));

outliers=minoutlier | maxoutlier;
outliers=any(outliers,2);

selected=sort(findobj(handles.activegraph,'tag','selected'));

set(selected,'visible','off');
set(selected(~udata.view.filtered),'visible','on');

handles.isselected{udata.view.dataset}{udata.view.analysis}=~outliers;

set(handles.fakeax(handles.activeindex),'userdata',udata);

raveupdateanalysis(handles.fig,handles,'isselected',[],udata.view.dataset,udata.view.analysis);


function selectoutbutton_callback(src,ev)
handles=guidata(src);
datasets=raveguidata(src,'datasets');
udata=get(handles.fakeax(handles.activeindex),'userdata');

%filter on ALL data:
allydata=datasets.alldata{udata.view.dataset}(:,udata.view.x);
%normalize:
data1=bsxfun(@minus,allydata,min(allydata));
data2=bsxfun(@rdivide,data1,max(data1));
data2(isnan(data2))=.5;
allydata=data2;

%allydata=(allydata-udata.view.varmins(udata.view.x))./udata.view.varranges(udata.view.x);

maxoutlier=bsxfun(@gt,allydata,udata.view.maxfiltercoord(udata.view.x));
minoutlier=bsxfun(@lt,allydata,udata.view.minfiltercoord(udata.view.x));

outliers=minoutlier | maxoutlier;
outliers=any(outliers,2);


selected=sort(findobj(handles.activegraph,'tag','selected'));

set(selected,'visible','off');
set(selected(udata.view.filtered),'visible','on');

handles.isselected{udata.view.dataset}{udata.view.analysis}=outliers;

set(handles.fakeax(handles.activeindex),'userdata',udata);

raveupdateanalysis(handles.fig,handles,'isselected',[],udata.view.dataset,udata.view.analysis);





function ncolor_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.ncolor=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateparallelcoords(handles.fig,[]);






function colorbarcheck_callback(src,ev)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.colorbar=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);


ravecreateparallelcoords(src,[]);

