function pointselecthistogram(src,ev) 
handles=guidata(src);

clear sizeselectionhistogram

src=ancestor(src,'axes');

ai=get(src,'userdata');
udata=get(handles.fakeax(ai),'userdata');

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.didntmove=true;

%subax=get(src,'parent');
c=find(handles.subax{ai}==src);

if handles.isnoise{udata.view.dataset}(udata.view.x(c));return;end

handles.temp.c=c;
handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on','visible','off');

set(handles.temp.selection,'userdata',handles.isselected{udata.view.dataset}{udata.view.analysis});

handles.temp.wasselected=handles.isselected{udata.view.dataset}{udata.view.analysis};

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',{@sizeselectionhistogram,ai});
set(handles.fig,'WindowButtonUpFcn',{@ravesizeselectiondone,ai});
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);



function ravesizeselectiondone(src,eventdata,ai) 
handles=sizeselectionhistogram(src);


if isempty(handles)
    handles=guidata(src);
end

udata=get(handles.fakeax(ai),'userdata');
datasets=raveguidata(handles.fig,'datasets');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
set(handles.infobar,'string','');

if handles.temp.didntmove
    processpointselecthistogram(findobj(gca,'tag','main'),[]);
    return
end

inpoints=get(handles.temp.selection,'userdata');
delete(handles.temp.selection);

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

%store indices of selected points.
handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;

guidata(src,handles);


%update other graphs:
handles=raveupdateanalysis(src,handles,'isselected',[],udata.view.dataset,udata.view.analysis);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=datasets.alldata{udata.view.dataset}(inpoints,:);
    raveupdateanalysis(src,handles,'xdials',[],udata.view.dataset,udata.view.analysis);
end




function processpointselecthistogram(src,ev)
handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

%if ~strcmp(handles.selectionmode,'point');return;end;
set(handles.infobar,'string','shift+click to add to selection, alt+click to remove from selection, ctrl+click to select subset');

ai=get(gca,'userdata');
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;

subax=get(src,'parent');
clicked=get(subax,'currentpoint');

xclick=clicked(1,1,1);
c=find(handles.subax{ai}==subax);
x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));  

edges=udata.view.edges{c};
[count,bins]=histc(x,edges);


if ~ismember(handles.datatype{udata.view.dataset}{udata.view.x(c)},{'string','discrete'})
    bins(bins==max(bins))=max(bins)-1; %overflow
end

%find corresponding data range:
thisbin=find((edges-xclick)>0,1,'first')-1;%==min(abs(edges-xclick)),1)-1; %index of next largest edge. 

inpoints=bins==thisbin;

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

inpoints = inpoints & mainrows;

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~filteredrows;
end

if min(edges)==max(edges) %if this variable is constant, select all data
    inpoints=mainrows;
end

mods = get(handles.fig,'currentmodifier');

if numel(mods)>1;return;end %not defined for multiple modifiers

if isempty(mods)
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
elseif strcmp(mods,'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(mods,'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(mods,'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}=lastselected & inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

for c=1:numel(handles.subax{ai})
    
    if handles.isnoise{d}(udata.view.x(c));continue;end %noisy variables don't show selection

    selected=findobj(handles.subax{ai}(c),'tag','selected');
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));
    
    edges=udata.view.edges{c};
    selectedcount=histc(x(handles.isselected{udata.view.dataset}{udata.view.analysis}),edges);
    selectedcount(end-1)=selectedcount(end-1)+selectedcount(end); %overflow
    selectedcount=selectedcount(1:end-1);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:);
    
    seldata=[zeros(size(selectedcount,1),1),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';

    sv=get(selected,'vertices');
    sv(:,2)=seldata(:);
    set(selected,'vertices',sv);

end


raveupdateanalysis(src,handles,'isselected',ai,udata.view.dataset,udata.view.analysis);
