function ravemouseoverhistogramdata(src,ev,ai)
%persistent handles udata

handles=guidata(src);

% if handles.prefs.mouseoverdelay>0
%     set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
%     stop(handles.mousetimer);
%     start(handles.mousetimer);
% else %process immediately
    processmouseover(handles.fig,[],handles,ai);    
% end

function processmouseover(src,ev,handles,ai)
datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(ai),'userdata');

obj=hittest(handles.fig);

subax=get(obj,'parent');
if ~any(subax==handles.subax{ai});return;end

clicked=get(subax,'currentpoint');

xclick=clicked(1,1,1);
c=find(handles.subax{ai}==subax);
x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));  

edges=udata.view.edges{c};

if isempty(edges);return;end %for invalid histograms e.g. random vars




[count,bins]=histc(x,edges);

if ~ismember(handles.datatype{udata.view.dataset}{udata.view.x(c)},{'string','discrete'})
    bins(bins==max(bins))=max(bins)-1; %overflow
end


%find corresponding data range:
thisbin=find((edges-xclick)>0,1,'first')-1;%==min(abs(edges-xclick)),1)-1; %index of next largest edge. 

if isempty(thisbin);return;end


inpoints=bins==thisbin;

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

inpoints = inpoints & mainrows;

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~filteredrows;
end

if min(edges)==max(edges) %if this variable is constant, select all data
    inpoints=mainrows;
end


for c=1:numel(handles.subax{ai})
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));
    
    edges=udata.view.edges{c};
    
    if isempty(edges);continue;end %for invalid histograms, e.g. random variables 
    
    selectedcount=histc(x(inpoints),edges);
    selectedcount(end-1)=selectedcount(end-1)+selectedcount(end); %overflow
    selectedcount=selectedcount(1:end-1);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:)';
    
    selectedcount=[0 selectedcount;selectedcount 0];
    edges=[edges;edges];
    
    set(udata.explore.mouseoverhandles(c),'xdata',edges(:),'ydata',selectedcount(:),'visible','on')
    
end






