function handles=raveupdatehistogramisfiltered(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);

datasets=raveguidata(handles.fig,'datasets');
getudata;
ai=handles.activeindex;

a=udata.view.analysis; 
d=udata.view.dataset; %data set index
xcol=udata.view.x;

%allnothidden=handles.isvisible{d}{a};
%if isempty(allnothidden);return;end % empty data set;

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

for c=1:numel(handles.subax{ai})
    
    if handles.isnoise{d}(xcol(c));continue;end
    
    
    main=findobj(get(handles.subax{ai}(c),'children'),'tag','main');
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));

    edges=udata.view.edges{c};
    maincount=histc(x(mainrows & ~isnan(x)),edges);
    maincount(end-1)=maincount(end-1)+maincount(end); %overflow
    maincount=maincount(1:end-1);

    if udata.view.normalize %normalize counts (make pdfs)
        maincount=maincount./size(handles.isselected{udata.view.dataset}{1},1);
    end
    
    maincount=maincount(:);

    maindata=[zeros(size(maincount,1),1),maincount,maincount,zeros(size(maincount,1),1)];
    maindata=maindata';
  
    
%     if ~handles.ishg2
%     mh=get(main,'children');
%     mh=findobj(mh,'type','patch'); %not sure why, but main includes several rectangle objects as well...
    mv=get(main,'vertices');
    mv(:,2)=maindata(:);
    set(main,'vertices',mv);
%     else
%        set(main,'ydata',maincount); 
%     end
    
    
    
    if udata.view.showfilter
       lox=findobj(handles.subax{ai}(c),'tag','loxfilter');
       hix=findobj(handles.subax{ai}(c),'tag','hixfilter');
       xlimz=get(handles.subax{ai}(c),'xlim');
       minf=handles.minfilter{d}{a}(xcol(c));
       maxf=handles.maxfilter{d}{a}(xcol(c));

       set(lox,'xdata',minf)
       set(hix,'xdata',maxf)
       
       if minf+eps(minf)<xlimz(1)
           set(lox,'visible','off')
       else
           set(lox,'visible','on')
       end
       
       if maxf>xlimz(2)+eps(xlimz(2));
           set(hix,'visible','off')
       else
           set(hix,'visible','on')
       end
    end
end