function handles=raveupdatehistogramisselected(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');
getudata;
ai=handles.activeindex;

a=udata.view.analysis;
d=udata.view.dataset; %data set index

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

for c=1:numel(handles.subax{ai})
    
    if handles.isnoise{d}(udata.view.x(c));continue;end
    
    selected=findobj(get(handles.subax{ai}(c),'children'),'tag','selected');
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));
    
    edges=udata.view.edges{c};
    selectedcount=histc(x(selectedrows & ~isnan(x)),edges);
    selectedcount(end-1)=selectedcount(end-1)+selectedcount(end); %overflow
    selectedcount=selectedcount(1:end-1);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:); %ensure it is a column (sometimes it turns into a row, not sure why)
    
    seldata=[zeros(size(selectedcount,1),1),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';
    
    sv=get(selected,'vertices');
    sv(:,2)=seldata(:);
    set(selected,'vertices',sv);
    
    
    
end