function handles=raveupdatehistogramvisiblerows(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');
getudata;
ai=handles.activeindex;

a=udata.view.analysis; 
d=udata.view.dataset; %data set index


allnothidden=handles.isvisible{d}{a};
allisselected=handles.isselected{d}{a};
allisfiltered=handles.isfiltered{d}{a};

if isempty(allnothidden);return;end % empty data set;

for c=1:numel(handles.subax{ai})
    main=ravefindobjinternal(get(handles.subax{ai}(c),'children'),'tag','main');
    selected=ravefindobjinternal(get(handles.subax{ai}(c),'children'),'tag','selected');
    filtered=ravefindobjinternal(get(handles.subax{ai}(c),'children'),'tag','filtered');
    
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));
    keep=~isnan(x);
    x=x(keep);
    isselected=allisselected(keep);
    nothidden=allnothidden(keep);
    isfiltered=allisfiltered(keep);
    
    nbars=udata.view.nbars-1; %dont make more bars than there are unique values.
    if min(x)==max(x)
      edges=[x(1)-1 x(1)+1];
    elseif ~isempty(x)
        edges=linspace(min(x),max(x),nbars+1);
    else
        edges=[0 1];
    end
    
    filtcount=histc(x(nothidden),edges);
    maincount=histc(x(nothidden & ~isfiltered),edges);
    
    if ~isempty(x);        
        selectedcount=histc(x(isselected & nothidden),edges);
    else
        selectedcount=[0 0];
    end
    
    if udata.view.normalize %normalize counts (make pdfs)
        maincount=maincount./length(x);
        selectedcount=selectedcount./length(x);
    end
    
    set(main,'ydata',maincount(:)');
    set(selected,'ydata',selectedcount(:)');
    set(filtered,'ydata',filtcount(:)');
end