function outs=sizeselectionhistogram(src,eventdata,ai)
outs=[];
persistent handles

if isempty(handles)
    handles=guidata(src);
end


if nargin==1 %used to retrieve final handles value.
    outs=handles;
    return
end




datasets=raveguidata(handles.fig,'datasets');
handles.temp.didntmove=false;
udata=get(handles.fakeax(ai),'userdata');
set(udata.explore.mouseoverhandles,'visible','off');

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:
c=handles.temp.c;
d=udata.view.dataset;
a=udata.view.analysis;
x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));

edges=udata.view.edges{c};
[count bins]=histc(x,edges);

if ~ismember(handles.datatype{udata.view.dataset}{udata.view.x(c)},{'string','discrete'})
    bins(bins==max(bins))=max(bins)-1; %overflow
end

%find corresponding data range:
lowbin=find(abs((edges-pos1))==min(abs(edges-pos1)),1); %index of next largest edge.
lowbin=find((edges-pos1)>0,1,'first')-1;%==min(abs(edges-xclick)),1)-1; %index of next largest edge.

highbin=find(abs((edges-(pos1+pos3)))==min(abs(edges-(pos1+pos3))),1);
highbin=find((edges-(pos1+pos3))>0,1,'first')-1;%==min(abs(edges-xclick)),1)-1; %index of next largest edge.
if isempty(highbin);highbin=max(bins);end %this happens if you go off the right side of the graph;

inpoints= bins>=lowbin & bins<=highbin;

[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

inpoints = inpoints & mainrows;

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~filteredrows;
end

if min(edges)==max(edges) %if this variable is constant, select all data
    inpoints=mainrows;
end

mods = get(handles.fig,'currentmodifier');
if numel(mods)>1;return;end %not defined for multiple modifiers

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints = handles.temp.wasselected | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.temp.wasselected;
    lastselected(inpoints)=false;
    inpoints= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    inpoints=handles.temp.wasselected & inpoints;
end

handles.isselected{d}{a}=inpoints;

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

for c=1:numel(handles.subax{ai})
    
    if handles.isnoise{d}(udata.view.x(c));continue;end
    
    selected=findobj(handles.subax{ai}(c),'tag','selected');
    x=datasets.alldata{udata.view.dataset}(:,udata.view.x(c));
    edges=udata.view.edges{c};
    selectedcount=histc(x(handles.isselected{udata.view.dataset}{udata.view.analysis}),edges);
    selectedcount(end-1)=selectedcount(end-1)+selectedcount(end); %overflow
    selectedcount=selectedcount(1:end-1);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:);
    
    
    seldata=[zeros(size(selectedcount,1),1),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';
    
    sv=get(selected,'vertices');
    sv(:,2)=seldata(:);
    set(selected,'vertices',sv);

end

handles=raveupdateanalysis(src,handles,'isselected',ai,udata.view.dataset,udata.view.analysis);

set(handles.temp.selection,'userdata',inpoints)
