function formattabbubbleplot(src,eventdata) %#ok<INUSD>
%rave format tab for line graphs.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
delete(handles.tabobjects)


if udata.view.x==0
    handles.tabobjects=[];
    guidata(handles.fig,handles);
    return
end


%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,0.75,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
legendtext=text(.15-.10317,.09*1.0317-.0317,'Legends','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);

%% GRAPH UICONTROLS

bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

bgidx=udata.format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{1}(2,:),'value',bgidx==1,...
    'callback',@bgblob_callback,'userdata',1,'tag','bgblob');
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{2}(2,:),'value',bgidx==2,...
    'callback',@bgblob_callback,'userdata',2,'tag','bgblob');
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{3}(2,:),'value',bgidx==3,...
    'callback',@bgblob_callback,'userdata',3,'tag','bgblob');
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{4}(2,:),'value',bgidx==4,...
    'callback',@bgblob_callback,'userdata',4,'tag','bgblob');

titletext=uicontrol('position',[origin(1)+25 origin(2)+332+165 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+333+165 180 20],...
    'style','edit','string',get(get(handles.activegraph,'title'),'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

%% DATA SERIES UICONTROLS
sorttext=uicontrol('position',[origin(1)+25 origin(2)+332+105 180 20],...
    'style','text','string','Arrange bubbles by:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
sortmenu=uicontrol('position',[origin(1)+40 origin(2)+398+20 180 20],...
    'style','popupmenu','string',{'Default order';'Largest in center';'Smallest in center'},'backgroundcolor',[1 1 1],...
    'horizontalalignment','left','callback',@sortmenu_callback,'value',udata.format.sortby);

colortext=uicontrol('position',[origin(1)+25 origin(2)+332+105-50 180 20],...
    'style','text','string','Color bubbles by:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
colormenu=uicontrol('position',[origin(1)+40 origin(2)+398+20-50 180 20],...
    'style','popupmenu','string',{'Color by area','Color by category'},'backgroundcolor',[1 1 1],...
    'horizontalalignment','left','callback',@colormenu_callback,'value',udata.format.colormode);

colormaptext=uicontrol('position',[origin(1)+25 origin(2)+332+105-100 180 20],...
    'style','text','string','Colormap:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');


cdata=ravemakecdata(handles.fig,[],handles.cmapnames{udata.format.mcmap});
markercolor=uicontrol('position',[origin(1)+99 origin(2)+182+160 120 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','cdata',cdata,'callback',@mcolor_callback);

edgecheck=uicontrol('position',[origin(1)+08 origin(2)+122-25+210 150 20],'style','checkbox',...
    'string','','value',udata.format.drawedge,'backgroundcolor',handles.colors.tabbg,...
    'callback',@edgecheck_callback);

edgetext=uicontrol('position',[origin(1)+25 origin(2)+120-25+210 150 20],...
    'style','text','string','Edge Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

edgecolor=uicontrol('position',[origin(1)+115-6 origin(2)+122-25+210 25 25],...
    'style','pushbutton','string','','backgroundcolor',udata.format.edgecolor,...
    'callback',@edgeblob_callback);

%% legend uicontrols
legendbutton=uicontrol('position',[origin(1)+85 origin(2)+06 160 20],...
    'style','pushbutton','string','Format Legend','fontname','arial','fontsize',10,...
    'backgroundcolor',handles.colors.buttonbg,'callback',[],...
    'fontweight','bold','visible','off');

colorbarcheck=uicontrol('position',[origin(1)+85 origin(2)+6 160 20],...
    'style','checkbox','string','Show Colorbar','fontname','arial narrow','fontsize',10,...
    'backgroundcolor',handles.colors.tabbg,'callback',@colorbarcheck_callback,...
    'fontweight','normal','horizontalalignment','left','value',udata.format.colorbar);


%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext bgwhite...
    bglight bgdark bgblack legendtext legendbutton titletext titlebox...
    edgetext sorttext sortmenu colortext colormenu...
    colormaptext markercolor edgecolor edgecheck colorbarcheck];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);

%% HERE BE CALLBACKS
%
%
%
%
%
%
%
%
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function title_callback(src,eventdata)
%generic function for adding titles to single-axis graphs.

handles=guidata(src);
set(get(handles.activegraph,'title'),'string',get(src,'string'),'fontsize',handles.fonts.graphtitlesize,'fontname',handles.fonts.graphtitle,'visible','on')

raveresizeaxes(handles.fig,[],handles.activeindex);
clear ravearrangeobjects

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edgeblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.edgecolor,'Choose a bar fill color');
set(src,'backgroundcolor',newcolor);
udata.format.edgecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
%update barcategorical:
ravecreatebubbleplot(handles.fig,[]);


function edgecheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.drawedge=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
%update barcategorical:
ravecreatebubbleplot(handles.fig,[]);


function sortmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.sortby=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
%update barcategorical:
ravecreatebubbleplot(handles.fig,[]);

function colormenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.colormode=get(src,'value');

%to control colorbar creation:
if get(src,'value')==1
    udata.view.c=udata.view.y;
else
    udata.view.c=0;
end


set(handles.fakeax(handles.activeindex),'userdata',udata);
%update barcategorical:
ravecreatebubbleplot(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mcolor_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

[newcmap,reverse]=ravechoosecolormap(src,[],udata.format.mcmap,udata.format.reversecolors);
if newcmap==udata.format.mcmap && reverse==udata.format.reversecolors
    return
end

udata.format.mcmap=newcmap;
udata.format.reversecolors=reverse;

colorz=handles.cmapnames;
newcolormap=colorz{newcmap};

cdata=ravemakecdata(handles.fig,[],newcolormap);
set(src,'cdata',cdata);

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebubbleplot(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colorbarcheck_callback(src,eventdata)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.colorbar=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatescatter(src,[]);

