function ravemouseoverbubbledata(src,ev,ai)
%persistent handles udata

handles=guidata(src);

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles.fig,[],handles,ai);    
end

function processmouseover(src,ev,handles,ai)
udata=get(handles.fakeax(ai),'userdata');

%show mouseovertext:
loc=get(handles.allgraphs(ai),'currentpoint');

xclick=loc(1,1);
yclick=loc(1,2);


%figure out which circle the mouse is in:
centers=udata.view.centers;
radii=udata.view.radii;

%calculate distance to each center:
dists=sqrt((centers(:,1)-xclick).^2+(centers(:,2)-yclick).^2);

inhere=find(dists<=radii,1);

if isempty(inhere);return;end

%get label of this circle:
xcol=udata.view.x;
d=udata.view.dataset;
a=udata.view.analysis;

if strcmp(handles.datatype{d}{xcol},'string')
    label=handles.discretevalues{d}{a}{xcol}{udata.view.index(inhere)};
else
    label=strtrim(sprintf('%8.6g',handles.discretevalues{d}{a}{xcol}{udata.view.index(inhere)}));
end

%calculate pixel offsets:
pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');

xpix=(xlim(2)-xlim(1))./pos(3);
ypix=(ylim(2)-ylim(1))./pos(4);

xoff=6;
yoff=6;

d=udata.view.dataset;
a=udata.view.analysis;

% highlight selected circle:
nverts=40;
thetas=linspace(0,2*pi,nverts);
allverts=zeros(nverts,2);
allverts(:,2)=radii(inhere)*sin(thetas)+centers(inhere,2);
allverts(:,1)=radii(inhere)*cos(thetas)+centers(inhere,1);

set(udata.explore.mouseoverhandles(1),'xdata',allverts(:,1),'ydata',allverts(:,2),'visible','on');

%show text label:
set(udata.explore.mouseoverhandles(2),'position',[xclick yclick 100]+[(xoff-1)*xpix (yoff)*ypix 0])
set(udata.explore.mouseoverhandles(3),'position',[xclick yclick 100]+[(xoff+1)*xpix (yoff)*ypix 0])
set(udata.explore.mouseoverhandles(4),'position',[xclick yclick 100]+[xoff*xpix (yoff+1)*ypix 0])
set(udata.explore.mouseoverhandles(5),'position',[xclick yclick 100]+[xoff*xpix (yoff-1)*ypix 0])
set(udata.explore.mouseoverhandles(6),'position',[xclick yclick 100]+[xoff*xpix (yoff)*ypix 0])

set(udata.explore.mouseoverhandles(2:end),'visible','on','string',label);

% return
% 
% if udata.view.c>0 && udata.format.colorbar
%     %make mouseover pointers:
%     
%     legdata=get(handles.fakerax(ai),'userdata');
%     aaa=findobj(legdata,'tag','Colorbar');
%     pos=get(aaa,'position');
%     ylim=get(aaa,'ylim');
%     xlim=get(aaa,'xlim');
%     
%     clim=[min(datasets.alldata{d}(:,udata.view.c)) max(datasets.alldata{d}(:,udata.view.c))];
%     
%     %determine current c value:
%     thisvalue=datasets.alldata{d}(idx,udata.view.c);
%     thiscoord=interp1(clim,ylim,thisvalue);
%     pixels=pos(3)./(xlim(2)-xlim(1)); %pixels per unit
% 
%     set(udata.explore.cbarmouseovervalue,'ydata',[thiscoord-1 thiscoord+1  thiscoord],'visible','on');
%     set(udata.explore.cbarmouseovertext,'position',[xlim(2)+3/pixels,thiscoord],'visible','on','string',sprintf('%5.5g',thisvalue));
% end
