function buttondownfcnternscatter(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by Matt Daskilewicz, with minor contributions from David Pate

%determines what to do when a scatter3D plot is clicked, then does it.
handles=guidata(src);
ai=find(handles.allgraphs==src);
udata=get(handles.fakeax(ai),'userdata');

%determine if selection is active:

isalt=strcmpi(get(handles.fig,'selectiontype'),'Alt') && ~ismember('control',get(handles.fig,'currentmodifier'));


switch handles.selectionmode
    case 'point'
        %note: point selection happens by clicking data series, not axes.
        set(udata.view.mainhandles,'HitTest','on')
        if isempty(get(handles.fig,'currentmodifier'))
            raveunselectfcn(src,[]);
        end
    case 'box'
        set(get(handles.allgraphs(ai),'children'),'HitTest','off')
        boxselectternscatter(src,[]);
    case 'lasso'
        set(get(handles.allgraphs(ai),'children'),'HitTest','off')
        lassoselectternscatter(src,[]);
    otherwise %do nothing
        set(get(handles.allgraphs(ai),'children'),'HitTest','off')
        
end

