function updateternscatterisselected(src,ai,isselected,handles)
%updates the scatter plot with index ai to display the selection in
%isselected (logical)

if nargin<4
handles=guidata(src);
end

datasets=raveguidata(handles.fig,'datasets');
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

x=datasets.alldata{d}(:,udata.view.x);
y=datasets.alldata{d}(:,udata.view.y);
z=datasets.alldata{d}(:,udata.view.z);

[x,y]=terncoords(x,z,y);


if nargin<3 || isempty(isselected)
isselected=handles.isselected{d}{a}; 
end


nothidden=handles.isvisible{d}{a};

selpatchhandles=udata.view.selhandles;
patchidx=udata.view.patchidx;
npatches=max(patchidx);
%selected handles
for j=1:npatches
    selidx=patchidx==j & isselected & nothidden;
    if any(selidx)
        set(selpatchhandles(j),'xdata',x(selidx),'ydata',y(selidx),'visible','on');
    else
        set(selpatchhandles(j),'visible','off');
    end
end

