function ravecreateblank(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%raveresizeaxes(src,[],handles.activeindex) %make appropriate margins for this graph type.
%inputs=varargin{3};

targetaxes=handles.activegraph;
cla(targetaxes);
% legend(targetaxes,'off');

if ~udata.format.persistentlimits
    set(targetaxes,'xlimmode','auto','ylimmode','auto','xtickmode','auto','ytickmode','auto')
else
    set(targetaxes,'xtickmode','auto','ytickmode','auto')
end

%font formatting
set(targetaxes,'climmode','manual','clim',[1 size(get(handles.fig,'colormap'),1)]);


%Make graph %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fcn=udata.view.function;
if ~isempty(fcn)
   fcn=str2func(fcn);
   fcn(handles.fig,[]);
   handles=guidata(handles.fig);
end

%Set label fonts:
set(get(targetaxes,'xlabel'),'fontsize',handles.fonts.graphsize,...
    'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)
set(get(targetaxes,'ylabel'),'fontsize',handles.fonts.graphsize,...
    'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)
set(get(targetaxes,'zlabel'),'fontsize',handles.fonts.graphsize,...
    'fontweight','normal','interpreter','none','fontname',handles.fonts.graph)

%Synchronize limits:
set(handles.fakerax(handles.activeindex),'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'))
set(handles.fakeax(handles.activeindex),'xlim',get(targetaxes,'xlim'),'ylim',get(targetaxes,'ylim'))
udata.format.xlim=get(targetaxes,'xlim');
udata.format.ylim=get(targetaxes,'ylim');
set(targetaxes,'xlimmode','manual','ylimmode','manual');

%adjust gridlines to match settings:
ravesetgridsingle;

set(handles.fakeax(handles.activeindex),'userdata',udata);
%update handles
guidata(src,handles)
ravemakecolorbar(handles.fig,[]);

raveresizeaxes(handles.fig,[],handles.activeindex);
clear ravearrangeobjects
raveupdateexploremethods(handles.fig,handles,handles.activeindex,'recreate');

