function viewtabblank3D(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');
origin=get(handles.tabaxes,'position');


%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.35*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');



fcntext=text(.25-.10317,0.7111,'Function that creates this graph:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
xaxistext=text(.25-.10317,0.639,'"X" Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,0.5667,'"Y" Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
zaxistext=text(.25-.10317,0.496,'"Z" Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,0.424,'"Color" Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
sizetext=text(.25-.10317,0.354,'"Size" Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists
htmlnames=makevarliststring(handles.fig,[],d);

htmlnames=['<Not Used>' htmlnames];

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',udata.view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',udata.view.dataset);

fcnedit=uicontrol('position',[origin(1)+55 origin(2)+415 180 22],...
    'style','edit','string',udata.view.function,'callback',@fcnedit_callback,...
    'backgroundcolor',[1 1 1],'tag','fcnedit','hor','left');
xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+365 180 30],...
    'style','popupmenu','string',htmlnames,'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',udata.view.x+1);
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+320 180 30],...
    'style','popupmenu','string',htmlnames,'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.y+1);
zaxismenu=uicontrol('position',[origin(1)+55 origin(2)+275 180 30],...
    'style','popupmenu','string',htmlnames,'callback',@zaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',udata.view.z+1);
colormenu=uicontrol('position',[origin(1)+55 origin(2)+230 180 30],...
    'style','popupmenu','string',[{'<Use Row Colors>'},htmlnames(1:end)],'callback',@colormenu_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',udata.view.c+1);
sizemenu=uicontrol('position',[origin(1)+55 origin(2)+185 180 30],...
    'style','popupmenu','string',[{'<Uniform Size>'},htmlnames(1:end)],'callback',@sizemenu_callback,...
    'backgroundcolor',[1 1 1],'tag','sizemenu','value',udata.view.s+1);


%% buttons

%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu colormenu,...
     analysistext projecttext analysismenu dataseriestext optionstext,...
       sizetext sizemenu fcntext zaxistext fcnedit zaxismenu];

handles.activetab='view';

guidata(src,handles);

%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=get(src,'value');

%get initial columns for this data set:
if ~all(handles.isfunction{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isfunction{d}),1);
    y=find((~handles.isconstant{d} & handles.isfunction{d}),1);
    c=0;
    s=0;
else
    x=find((~handles.isconstant{d}),1);
    y=find((~handles.isconstant{d}),1);
    c=0;
    s=0;
end

udata.view.dataset=d;
udata.view.x=x;
udata.view.y=y;
udata.view.c=c;
udata.view.s=s;

set(handles.fakeax(handles.activeindex),'userdata',udata);

handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);
ravecreateblank3D(src,[]);
viewtab(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fcnedit_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.function=get(src,'string');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.x=get(src,'value')-1;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.y=get(src,'value')-1;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function zaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.z=get(src,'value')-1;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colormenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.c=get(src,'value')-1;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizemenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.s=get(src,'value')-1;
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreateblank3D(src,[]);



