function ravecreatetablesinglepoint(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

%convert data into a cell array of strings:
data=udata.view.data;
numrows=size(data,1);

%numcols=numel(colnames);
xcol=udata.view.y;

if ~isempty(data)
    data=num2cell(data);
    for r=1:numrows
        if ~strcmp(handles.datatype{d}{xcol(r)},'string')
            data{r,1}=sprintf('%-12.5g',data{r,1});
        else
            data{r,1}=handles.discretevalues{d}{a}{xcol(r)}{data{r,1}};
        end
    end
end

rownames=udata.view.rownames;
rowheight=udata.view.rowheight;
colnames=udata.view.colnames(udata.view.x);
colwidths=udata.view.colwidths(udata.view.x);
headerheight=udata.view.headerheight;
headerwidth=udata.view.headerwidth;
rowcolors=udata.format.unselectedcolor;
rhcolors=udata.format.rowheadercolor;

ravemaketablecore(handles.fig,[],handles.activeindex,data,rownames,rowheight,colnames,colwidths,headerwidth,headerheight,rowcolors,rhcolors);

raveresizetable(handles.fig,[],handles.activeindex);
%fix scrolling
verttablescroll(handles.activegraph,[],0)
