function raveupdatetablestatistics(src,ev,handles)
%create data for table based on udata.view

if nargin<3
handles=guidata(src);
end

datasets=raveguidata(handles.fig,'datasets');

udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

%udata.view.colnames=handles.allnames{d}(udata.view.y);
udata.view.rownames=udata.view.stats(udata.view.x);

stats=zeros(16,numel(udata.view.y));

if udata.view.z==1 %all points
    idx=true(size(handles.isselected{d}{1},1),1);
elseif udata.view.z==2 %selected points
    idx=handles.isselected{d}{a};
else %unfiltered points
    idx=~handles.isfiltered{d}{a};
end


for c=1:numel(udata.view.y);
    thisdata=datasets.alldata{d}(idx,udata.view.y(c));
    thisdata=thisdata(~isnan(thisdata));
    if isempty(thisdata);continue;end
    
    stats(16,c)=max(thisdata);
    
    try
        q=quantile(thisdata,[0.01 0.05 0.1 0.25 0.5 0.75 0.9 0.95 0.99]);
    catch
        q=zeros(9,1);
    end
    
    
    stats(15:-1:7,c)=q;
    
    stats(6,c)=max(thisdata);
    stats(5,c)=std(thisdata)./sqrt(size(thisdata,1));
    stats(4,c)=var(thisdata);
    stats(3,c)=std(thisdata);
    stats(2,c)=mean(thisdata);
    stats(1,c)=size(thisdata,1);
end


stats=stats(udata.view.x,:);

udata.view.data=stats;

set(handles.fakeax(handles.activeindex),'userdata',udata)
ravecreatetablestatistics(src,ev);

% 
% 
% udata.view.stats={'Sample Size';
%     'Mean';
%     'Std Dev';
%     'Variance';
%     'Std Err of Mean';
%     'Maximum';
%     '99%';
%     '95%';
%     '90%';
%     '75%';
%     '50% (Median)';
%     '25%';
%     '10%';
%     '5%';
%     '1%';
%     'Minimum'};