//A simple table model, just like a defaultablemodel but returns correct column classes. 
//Also has an optional "row status" vector that can be used to color rows when used with RaveRowStatusRenderer
//
//
//
//


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;

import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;

public class RaveDataTypeTableModel extends DefaultTableModel {
    protected DefaultTableModel tableModel;
    public int[] rowStatus;
    
    public RaveDataTypeTableModel(Object rowData[][], Object columnNames[]) {
        super(rowData,columnNames);
        
        int[] rowStatus = new int[this.getRowCount()];
        
        this.rowStatus = rowStatus;
         
        for (int i = 0; i < this.getRowCount(); i++)
            this.rowStatus[i] = 0;
    }
    
    public Class getColumnClass(int col) {
        try {
            if (getRowCount() > 0)
                return getValueAt(0, col).getClass();
            else
                return "".getClass();
        }
        catch (Exception e)
        {
            return "".getClass();  
        }
    }
    
    
    public void setRowStatus(Integer[] newRowStatus) {
        for (int i = 0; i < newRowStatus.length; i++)
            this.rowStatus[i] = newRowStatus[i].intValue();
    }
    
    public int[] getRowStatus() {
        return rowStatus;
    }
}

