function formattabmaintable(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Table Colors','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);
selectiontext=text(.15-.10317,.6*1.0317-.0317,'Selection','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18,'fontname','magneto','color',handles.colors.title);


%% GRAPH UICONTROLS
texttext=uicontrol('position',[origin(1)+57 origin(2)+569 180 20],...
    'style','text','string','Text','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
textblob=uicontrol('position',[origin(1)+30 origin(2)+573 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.text,...
    'callback',@textblob_callback);

bgtext=uicontrol('position',[origin(1)+57 origin(2)+569-25 180 20],...
    'style','text','string','Background','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
bgblob=uicontrol('position',[origin(1)+30 origin(2)+573-25 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.background,...
    'callback',@bgblob_callback);

hidtext=uicontrol('position',[origin(1)+57 origin(2)+569-50 180 20],...
    'style','text','string','Hidden Row Background','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
hidblob=uicontrol('position',[origin(1)+30 origin(2)+573-50 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.shaded,...
    'callback',@shadeblob_callback);

seltext=uicontrol('position',[origin(1)+57 origin(2)+569-75 180 20],...
    'style','text','string','Selection Background','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
selblob=uicontrol('position',[origin(1)+30 origin(2)+573-75 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.selected,...
    'callback',@selectblob_callback);

selhidtext=uicontrol('position',[origin(1)+57 origin(2)+569-100 200 20],...
    'style','text','string','Hidden+Selected Background','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
selhidblob=uicontrol('position',[origin(1)+30 origin(2)+573-100 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.selectedshaded,...
    'callback',@shadeselectblob_callback);

gridtext=uicontrol('position',[origin(1)+57 origin(2)+569-125 180 20],...
    'style','text','string','Grid Lines','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridblob=uicontrol('position',[origin(1)+30 origin(2)+573-125 20 20],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.maintable.grid,...
    'callback',@gridblob_callback);

userowcolorscheck=uicontrol('position',[origin(1)+33 origin(2)+569-145 220 20],...
    'style','checkbox','string','Display Row Colors in Header','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','value',handles.maintable.colorrows);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

recolortext=uicontrol('position',[origin(1)+30 origin(2)+335 180 20],...
    'style','text','string','Recolor selected rows:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

colortestbutton=zeros(1,10);
for c=1:10
    colortestbutton(c)=uicontrol('position',[origin(1)+10+22*c origin(2)+315 18 18],...
        'style','pushbutton','string','','value',0,'backgroundcolor',handles.prefs.rowcolors(c,:),...
        'fontname','arial narrow','fontsize',6,'horizontalalignment','left',...
        'callback',@rowcolorblob_callback,'tag','rowcolorblob','userdata',c);
    
end


hidebutton=uicontrol('position',[origin(1)+32 origin(2)+280 216 24],'style','pushbutton',...
    'string','Hide Selected Rows','callback',@ravemaintablehide,'background',handles.colors.buttonbg,'tag','');

showbutton=uicontrol('position',[origin(1)+32 origin(2)+250 216 24],'style','pushbutton',...
    'string','Unhide Selected Rows','callback',@ravemaintableunhide,'background',handles.colors.buttonbg,'tag','');


%% group items and finish up
handles.tabobjects=[graphtext texttext textblob bgtext bgblob hidtext hidblob...
    selhidblob selhidtext selblob seltext colortestbutton gridtext gridblob userowcolorscheck...
    selectiontext recolortext hidebutton showbutton];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rowcolorblob_callback(src,ev)
handles=guidata(src);

d=handles.maintable.d;
a=handles.maintable.a;


isselected=handles.maintable.jtable.getSelectedRows();
for g=1:numel(isselected);
    isselected(g)=handles.maintable.models{d}.modelIndex(isselected(g));
end
isselected=isselected+1;

if strcmp(get(handles.fig,'currentmodifier'),'control')
    
    oldcolor=handles.prefs.rowcolors(get(src,'userdata'),:);
    newcolor=ravecolorchooser(handles.fig,oldcolor,'Choose a new row color');
    thecolors=get(handles.fig,'colormap');
    
    thecolors(1920+get(src,'userdata'),:)=newcolor;
    set(handles.fig,'colormap',thecolors);
    
    set(src,'backgroundcolor',newcolor);
    for d=1:numel(handles.datasetnames)
        handles.maintable.models{d}.setRowColorSpec(get(src,'userdata')-1,java.awt.Color(newcolor(1),newcolor(2),newcolor(3)));
    end
end

handles.rowcolors{d}{a}(isselected)=uint16(get(src,'userdata'));
handles.analysisupdatespending{d}{a}=union(handles.analysisupdatespending{d}{a},'rowcolors');
guidata(handles.fig,handles);

%update table:
rowcolors=handles.rowcolors{d}{a};
jRowColors=javaArray('java.lang.Integer',size(rowcolors,1));
for r=1:numel(rowcolors)
    jRowColors(r)=java.lang.Integer(rowcolors(r)-1);
end
handles.maintable.models{d}.setRowColors(jRowColors)

%update display:
rowHeaderViewport=handles.maintable.jscroll.getComponent(3);
rowHeader=rowHeaderViewport.getComponent(0);
rowHeader.repaint;


function textblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.text,'Choose a text color');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.text=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));

%CELL RENDERERS:
obj=java.lang.Double(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setTextColor(newColor);

obj=java.lang.String;
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setTextColor(newColor);

obj=java.lang.Integer(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setTextColor(newColor);

obj=java.awt.Rectangle(0,0,1,1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setTextColor(newColor);

handles.maintable.jtable.repaint;

guidata(src,handles);


function bgblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.background,'Choose a cell background color');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.background=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));

%CELL RENDERERS:
obj=java.lang.Double(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setBackgroundColor(newColor);

obj=java.lang.String;
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setBackgroundColor(newColor);

obj=java.lang.Integer(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setBackgroundColor(newColor);

obj=java.awt.Rectangle(0,0,1,1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setBackgroundColor(newColor);

handles.maintable.jtable.repaint;
guidata(src,handles);


function shadeblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.shaded,'Choose a color for hidden cells');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.shaded=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));

%CELL RENDERERS:
obj=java.lang.Double(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setShadedColor(newColor);

obj=java.lang.String;
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setShadedColor(newColor);

obj=java.lang.Integer(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setShadedColor(newColor);

obj=java.awt.Rectangle(0,0,1,1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setShadedColor(newColor);

handles.maintable.jtable.repaint;

guidata(src,handles);



function selectblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.selected,'Choose a color for selected cells');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.selected=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));

%CELL RENDERERS:
obj=java.lang.Double(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedColor(newColor);

obj=java.lang.String;
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedColor(newColor);

obj=java.lang.Integer(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedColor(newColor);

obj=java.awt.Rectangle(0,0,1,1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedColor(newColor);

guidata(src,handles);


function shadeselectblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.selectedshaded,'Choose a color for selected/hidden cells');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.selectedshaded=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));
%CELL RENDERERS:
obj=java.lang.Double(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedShadedColor(newColor);

obj=java.lang.String;
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedShadedColor(newColor);

obj=java.lang.Integer(1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedShadedColor(newColor);

obj=java.awt.Rectangle(0,0,1,1);
class=obj.getClass();
rrr=handles.maintable.jtable.getDefaultRenderer(class);
rrr.setSelectedShadedColor(newColor);
handles.maintable.jtable.repaint;

guidata(src,handles);


function gridblob_callback(src,ev)
handles=guidata(src);
newcolor=ravecolorchooser(handles.fig,handles.colors.maintable.grid,'Choose a grid line color');
set(src,'backgroundcolor',newcolor);
handles.colors.maintable.grid=newcolor;

newColor=java.awt.Color(newcolor(1),newcolor(2),newcolor(3));
handles.maintable.jtable.setGridColor(newColor);
handles.maintable.jtable.repaint;

guidata(src,handles);




