function ravemaintablesort(src,ev,directive,subsort)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

MouseEvent=get(0,'userdata');

d=handles.maintable.d;
model=handles.maintable.models{d};

x=MouseEvent.getX;
columnModel=handles.maintable.jtable.getColumnModel();
viewcol=columnModel.getColumnIndexAtX(x); %View Index
modelcol=handles.maintable.jtable.convertColumnIndexToModel(viewcol); %model index

%turn off tablechanged callback to avoid an error:
hhh=handle(handles.maintable.models{d},'callbackproperties');
set(hhh,'TableChangedCallback',[]);

%get current selection:

selectedRows=handles.maintable.jtable.getSelectedRows; %in displayed coordinates
for g=1:numel(selectedRows)
    selectedRows(g)=handles.maintable.models{d}.modelIndex(selectedRows(g));
end


if strcmp(subsort,'clear') %clear existing sorts
    colcount=model.getColumnCount;
    for c=0:colcount-1
        model.setSortingStatus(c,0);        
    end    
end

switch directive %implement new sort
    case 'ascending'
        model.setSortingStatus(modelcol,1);
    case 'descending'
        model.setSortingStatus(modelcol,-1);
    case 'rank'
        %not implemented.
end

drawnow; %MUST drawnow to get viewIndex to work correctly.

%maintain existing selection:
if ~isempty(selectedRows)
    for g=1:numel(selectedRows)
        selectedRows(g)=handles.maintable.models{d}.viewIndex(selectedRows(g));
    end
    
    handles.maintable.jtable.setRowSelectionInterval(selectedRows(1),selectedRows(1));
    for i=2:numel(selectedRows)
        handles.maintable.jtable.addRowSelectionInterval(selectedRows(i),selectedRows(i));
    end
end


%turn table callback back on:
set(hhh,'TableChangedCallback',{@ravemaintablechangedcallback,handles.fig});

