function mhandle=makehelpblob(parent,x,y,helpfile,bgcolor,tooltip)
%makes a small button in parent (figure or uipanel) at coords x,y (lower left corner) that
%displays helpfile (string) in a web browser.
%  if helpfile begins with * it is the name of a matlab function instead of
%  a url. It will be displayed with doc(helpfile) (minus the * of course).
%h is the handle of the help button.
%(h is a jbutton)

if nargin<5
    bgcolor=java.awt.Color.white;
else
    R=bgcolor(1);
    G=bgcolor(2);
    B=bgcolor(3);
    bgcolor=java.awt.Color(R,G,B);
end

h = com.mathworks.mwswing.MJButton('?');
h.setBorder([]);
h.setBackground(bgcolor);
h.setForeground(java.awt.Color.blue);
h.setCursor(java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
h.setFlyOverAppearance(true);

if nargin==6
    h.setToolTipText(tooltip);
else
    h.setToolTipText('Display help on this topic');
end

[jhandle,mhandle] = javacomponent(h,[x y 16 18],parent); %#ok
set(h, 'ActionPerformedCallback',{@displayhelp,helpfile});

function displayhelp(jsrc,jev,strng)

if strng(1)~='*';
    strng=strrep(strng,'helproot','http://www.rave.gatech.edu/help/index.php');
    web(strng);
else
    doc(strng(2:end))
end





