function f=newmanageanalysesgui(src,ev)

handles=guidata(src);
handles.temp.tabobjects=[]; %category menu objects

f=figure('units','pixels','position',[0 0 651 659],'menubar','none','toolbar','none','windowstyle','normal',...
    'name','Manage analyses','numbertitle','off','resize','off','windowkeypressfcn',@keycap);

origin=get(src,'position');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);
set(f,'closerequestfcn',@closegui)

%set theme:
set(f,'color',handles.colors.frame);
handles.temp.f=f;
guidata(f,handles);

titleaxes=axes('units','pixels','position',[12 613 312 39],'parent',f,'visible','off');

uipanel1=uipanel('parent',f,'units','pixels','position',[50 440 551 169],'bordertype','etchedin',...
    'backgroundcolor',handles.colors.tabbg);
uipanel2=uipanel('parent',f,'units','pixels','position',[50 57 551 364],'bordertype','etchedin',...
    'backgroundcolor',handles.colors.tabbg,'tag','uipanel2');

topframeaxes=axes('parent',uipanel1,'visible','off','units','pixels','position',[3 124 312 39]);

uicontrol('style','pushbutton','string','Create a New Analysis','position',[323 125 212 38],...
    'parent',uipanel1,'tag','createbutton','callback',@createbutton_Callback);
uicontrol('style','pushbutton','string','Rename Selected Analysis','position',[323 78 212 38],...
    'parent',uipanel1,'tag','renamebutton','callback',@renamebutton_Callback);
uicontrol('style','pushbutton','string','Delete Selected Analysis','position',[323 31 212 38],...
    'parent',uipanel1,'tag','deletebutton','callback',@deletebutton_Callback);

uicontrol('style','listbox','string',handles.analysisnames,'value',1,...
    'max',1,'parent',uipanel1,'position',[9 9 309 111],'tag','analysislist','backgroundcolor',[1 1 1]);


bottomframeaxes=axes('parent',uipanel2,'visible','off','units','pixels','position',[6 328 541 31]);

uicontrol('style','text','position',[21 308 401 15],'parent',uipanel2,'fontweight','bold',...
    'string','Select an analysis above and a dataset from the menu below to make changes','backgroundcolor',handles.colors.tabbg)

uicontrol('style','popupmenu','string',handles.datasetnames,'tag','datasetmenu',...
    'parent',uipanel2,'position',[29 283 279 21],'callback',@datasetmenu_Callback,'backgroundcolor',[1 1 1]);

uicontrol('style','pushbutton','parent',uipanel2,'position',[12 236 200 38],...
    'string','Change Input Variable Ranges','tag','changerangebutton','callback',@changerangebutton_Callback);
uicontrol('style','text','position',[222 197 325 78],'parent',uipanel2,...
    'string','By default, input variable ranges are defined by the maximum and minimum values in the corresponding data set. If you would like to use other ranges, change them here.',...
    'hor','left','backgroundcolor',handles.colors.tabbg)

uicontrol('style','pushbutton','parent',uipanel2,'position',[12 181 200 38],...
    'string','Edit Row Color Labels','tag','rowcolorlabelbutton','callback',@rowcolorlabel_Callback);
uicontrol('style','text','position',[222 184 325 37],'parent',uipanel2,...
    'string','Assign labels to the Row Colors that will appear in the legends of supported workspace objects.',...
    'hor','left','backgroundcolor',handles.colors.tabbg)

uicontrol('style','pushbutton','position',[258 9 133 40],'string','Done',...
    'fontsize',14,'tag','donebutton','callback',@closegui);

%make titles
text(0,.4,'Manage Analyses','parent',titleaxes,'fontname',handles.fonts.title,'fontsize',handles.fonts.titlesize,...
    'color',handles.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Create / Rename / Delete','parent',topframeaxes,'fontname',handles.fonts.tab,'fontsize',handles.fonts.tabsize,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.2,'Modify Existing Analyses','parent',bottomframeaxes,'fontname',handles.fonts.tab,'fontsize',handles.fonts.tabsize,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function closegui(src,ev)
%send updated handles back to main rave window
handles=guidata(src);
guidata(handles.fig,handles);
delete(handles.temp.f)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function createbutton_Callback(src, eventdata) 

handles=guidata(src);

%prompt for name:
%newname=inputdlg('Name this analysis:','New Analysis');
set(0,'userdata',[]);
origin=get(handles.fig,'position');

askbox=figure('units','pixels','position',[origin(1)+origin(3)/2-350/2 origin(2)+origin(4)/2-150/2 350 150],...
    'numbertitle','off','menubar','none','name','Create New Analysis','color',handles.colors.frame,...
    'resize','off','windowstyle','modal');


uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
    'position',[20 100 320 40],...
    'string','Select the analysis to use as a starting point for the new analysis:',...
    'horizontalalignment','left')
uicontrol('style','popupmenu','string',handles.analysisnames,'backgroundcolor',[1 1 1],'units','pixels',...
    'position',[60-20 70+30 180 22],'tag','analysismenu')

uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
    'position',[20 50 320 40],...
    'string','Name the new analysis:','horizontalalignment','left')
uu=uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
    'position',[60-20 50 180 22],'tag','analysisname','hor','left');

uicontrol('style','pushbutton','string','Ok','parent',askbox,'units','pixels',...
    'position',[110 10 100 30],'callback',@newanalysispopup_callback,'fontsize',10);
uicontrol('style','pushbutton','string','Cancel','parent',askbox,'units','pixels',...
    'position',[220 10 100 30],'callback',@newanalysispopup_callback,'fontsize',10);

uicontrol(uu);
uiwait(askbox)

outdata=get(0,'userdata');

if isempty(outdata);return;end;

newname=outdata.name;
index=outdata.value;

%add this name to the list:
oldnames=get(handles.analysislist,'string');
oldnames{end+1}=newname;
set(handles.analysislist,'string',oldnames);

%make new cells for this analysis:
handles.analysisnames=oldnames;
for D=1:numel(handles.datasetnames) %apparently can't use deal here.
   %handles.targetvalues{D}{end+1}=handles.targetvalues{D}{index};
    handles.xdials{D}{end+1}=handles.xdials{D}{index};
    handles.minlimit{D}{end+1}=handles.minlimit{D}{index};
    handles.maxlimit{D}{end+1}=handles.maxlimit{D}{index};
    handles.discretevalues{D}{end+1}= handles.discretevalues{D}{index};
    handles.rowcolors{D}{end+1}=handles.rowcolors{D}{index};
    handles.ineqconstraints{D}{end+1}=handles.ineqconstraints{D}{index};
    handles.isselected{D}{end+1}=handles.isselected{D}{index};
    handles.isvisible{D}{end+1}=handles.isvisible{D}{index};
    handles.constrainthandles{D}{end+1}=handles.constrainthandles{D}{index};
    handles.constrainttext{D}{end+1}=handles.constrainttext{D}{index};
    handles.constrainttype{D}{end+1}=handles.constrainttype{D}{index};
    handles.constraintvalues{D}{end+1}=handles.constraintvalues{D}{index};
    handles.constraintadders{D}{end+1}=handles.constraintadders{D}{index};
    handles.constraintscalers{D}{end+1}=handles.constraintscalers{D}{index};
    handles.constraintvars{D}{end+1}=handles.constraintvars{D};
    handles.constraintcolors{D}{end+1}=handles.constraintcolors{D};
    handles.isfiltered{D}{end+1}=handles.isfiltered{D}{index};
    handles.minfilter{D}{end+1}=handles.minfilter{D}{index};
    handles.maxfilter{D}{end+1}=handles.maxfilter{D}{index};
    handles.rowcolorlabels{D}{end+1} = handles.rowcolorlabels{D}{index};
    handles.discretefilter{D}{end+1}=handles.discretefilter{D}{index};
    handles.analysisupdatespending{D}{end+1}=cell(0);
end

%update da handles
guidata(src,handles);


% --- Executes on button press in changerangebutton.
function changerangebutton_Callback(src,ev)
handles=guidata(src);

datasetmenu=findobj(gcbf,'tag','datasetmenu');
analysislist=findobj(gcbf,'tag','analysislist');

set(0,'userdata',get(handles.fig,'position'));

d=get(datasetmenu,'value');
a=get(analysislist,'value');

hhh=ravechangerangesgui(d,a,handles);
uiwait(hhh);

newranges=get(0,'userdata');
if ~isstruct(newranges);return;end

handles=newranges;

guidata(handles.fig,handles);
guidata(src,handles);

set(0,'userdata',[]);



% --- Executes on button press in constrainbutton.
function constrainbutton_Callback(src, eventdata) 


function renamebutton_Callback(src, eventdata)


function deletebutton_Callback(src, eventdata)



function newanalysispopup_callback(src,ev)
%callback for the donebuttons of the create new analysis popup window.
amenu=findobj(get(src,'parent'),'tag','analysismenu');
aname=findobj(get(src,'parent'),'tag','analysisname');


outdata.value=get(amenu,'value');
outdata.name=get(aname,'string');

set(0,'userdata',[]);
if strcmp(get(src,'string'),'Ok')
    if isempty(outdata.name)
        errordlg('You must enter a name for the new analysis','Name Required');
        return
    end
    set(0,'userdata',outdata);
end

close(get(gcbo,'parent'))


function rowcolorlabel_Callback(src,ev)
handles=guidata(src);

updatasetmenu = findobj(get(src,'parent'),'tag','datasetmenu');
d = get(updatasetmenu,'value');
upanalysismenu = findobj(get(src,'parent'),'tag','datasetmenu');
a = get(upanalysismenu,'value');

f = get(src,'parent');


%prompt for name:
set(0,'userdata',[]);
origin=get(handles.fig,'position');

askbox=figure('units','pixels','position',[origin(1)+origin(3)/2-500/2 origin(2)+origin(4)/2-400/2 500 400],...
    'numbertitle','off','menubar','none','name','Edit Row Color Labels','color',handles.colors.frame,...
    'resize','off','windowstyle','normal','userdata',f,'windowkeypressfcn',@keycap);
guidata(askbox,handles);

uipanel('parent',askbox,'units','pixels','position',[30 50 440 340],'bordertype','etchedin',...
    'backgroundcolor',handles.colors.tabbg);

uicontrol('style','text','backgroundcolor',handles.colors.tabbg,'units','pixels',...
    'position',[40 360 320 22],'string','Select a data set:','horizontalalignment','left')
uicontrol('style','popupmenu','string',handles.datasetnames,'backgroundcolor',[1 1 1],'units','pixels',...
    'position',[50 340 180 22],'tag','datasetmenu','value',d)

uicontrol('style','text','backgroundcolor',handles.colors.tabbg,'units','pixels',...
    'position',[260 360 200 22],'string','Select an analysis:','horizontalalignment','left')
uicontrol('style','popupmenu','string',handles.analysisnames,'backgroundcolor',[1 1 1],'units','pixels',...
    'position',[270 340 180 22],'tag','analysismenu','value',a)


uicontrol('style','text','backgroundcolor',handles.colors.tabbg,'units','pixels',...
    'position',[40 290 420 40],'string','Enter color labels below. Labels will appear in legends when multiple row colors are in use. Colors with blank labels will never appear in legends.','horizontalalignment','left')


thecolors=handles.prefs.rowcolors;
for c=1:10
    uicontrol('position',[60 290-22*c 18 18],...
        'style','pushbutton','string','','value',0,'backgroundcolor',thecolors(c,:),...
        'fontname','arial narrow','fontsize',6,'horizontalalignment','left',...
        'callback','','tag','rowcolorblob','userdata',c);
    uicontrol('position',[60+40 290-22*c 320 18],...
        'style','edit','backgroundcolor',[1 1 1],'hor','left',...
        'string',handles.rowcolorlabels{d}{a}{c},'callback',@rowlabel_callback,...
        'userdata',c);
end

uicontrol('style','pushbutton','string','Done','parent',askbox,'units','pixels',...
    'position',[200 10 100 30],'callback',@rowcolorlabelpopup_callback,'fontsize',14);



function rowlabel_callback(src,ev)
handles=guidata(src);
f = get(src,'parent');
datasetmenu = findobj(f,'tag','datasetmenu');
analysismenu = findobj(f,'tag','analysismenu');
d = get(datasetmenu,'value');
a = get(analysismenu,'value');
c = get(src,'userdata');
handles.rowcolorlabels{d}{a}{c} = get(src,'string');
guidata(f,handles);


function rowcolorlabelpopup_callback(src,ev)

handles = guidata(src);
askbox = get(src,'parent');
f = get(askbox,'userdata');
guidata(f,handles);

close(get(gcbo,'parent'))





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function keycap(src,ev)
try %try because i'm not sure if older versions use same format for eventdata:
    if strcmp(ev.Key,'escape')
        close(gcbf);
    end
end




