
settings.fitindividually=get(ui(14),'value');

if ~settings.fitindividually
   settings.alloutputs=y;  %y is defined in ravemakemodelgui's addmodeltoqueue function
   settings.allactualvalues=datasets.alldata{d}(:,y);
else
   settings.alloutputs=[];
   settings.allactualvalues=[];
end

settings.nhiddennodes=ceil(eval(['[',get(ui(3),'string'),']']));

if any(isnan(settings.nhiddennodes) | isinf(settings.nhiddennodes) | settings.nhiddennodes>100 | settings.nhiddennodes<1)
    errordlg('You must enter a number between 1 and 100 for the number of hidden nodes in each layer.','Invalid settings');
    return
end

fcns=get(ui(5),'string');
settings.transferfcn=fcns{get(ui(5),'value')};
algs={'trainb','trainbfg','trainbr','trainbuwb','trainc','traincgb','traincgf','traincgp','traingd','traingda',...
        'traingdm','traingdx','trainlm','trainoss','trainr','trainrp','trains','trainscg'};
    
settings.trainalg=algs{get(ui(7),'value')};

%get settings from table:
s=updateffneuralnetsettingstable(settings.trainalg);

jscroll=get(ui(8),'javapeer');
jtable=jscroll.getViewport.getView;

for j=1:size(s,1);
    valz{j}=jtable.getValueAt(j-1,1);

    v=ver('nnet');
    if isempty(v)
        errordlg('This model type requires the MATLAB neural network toolbox, which does not appear to be installed. This toolbox can be purchased from The Mathworks.','Toolbox Required')
        return
    end
    
    %some version control:
    if strcmp(s{j,2},'mem_reduc')
        switch v.Release
            case {'(R2007a)','(R2007b)','(R2008a)','(R2008b)','(R2009a)','(R2009b)','(R2010a)'}
                settings.trainParam.(s{j,2})=valz{j};
            case {'(R2010b)','(R2011a)','(R2011b)','(R2012a)','(R2012b)'}
                settings.efficiency.memoryReduction=valz{j};
            otherwise
        end
    else
        
        if ~ischar(s{j,3}) && ischar(valz{j}) %if this is a string but it should be a number...
            settings.trainParam.(s{j,2})=eval(valz{j});
        else
            settings.trainParam.(s{j,2})=valz{j};
        end
        
        %settings.trainParam.(s{j,2})=valz{j};
    end
end

%settings.epochs=ceil(str2double(get(ui(9),'string')));
%settings.maxtime=ceil(str2double(get(ui(11),'string')));
%settings.iter=ceil(str2double(get(ui(13),'string')));

%check for valid values:

if isnan(settings.epochs) || settings.epochs<1
    errordlg('You must enter a positive number for Max epochs','Invalid settings');
    return
end

if isnan(settings.maxtime) || settings.maxtime<1
    errordlg('You must enter a positive number of seconds (or inf) for Max training time','Invalid settings');
    return
end

if isnan(settings.iter) || settings.iter<1
    errordlg('You must enter a positive number for Iterations','Invalid settings');
    return
end

settings.doregularization=get(ui(9),'value');
settings.regularizationvalue=str2double(get(ui(10),'string'));

if settings.doregularization && (isnan(settings.regualrizationvalue) || settings.regualrizationvalue<0 || settings.regualrizationvalue>1)
    errordlg('You must enter a value between 0 and 1 for the regularization parameter','Invalid settings');
    return
end

%settings.doearlystopping=get(ui(16),'value');

algz={'learncon','learngd','learngdm','learnh','learnhd','learnis','learnk','learnlv1','learnlv2','learnos','learnp','learnpn','learnsom','learnsomb','learnwh'};

settings.learnalg=algz{get(ui(12),'value')};
settings.notes=['H.Nodes = ',num2str(settings.nhiddennodes),'; Transfer fcn = ',settings.transferfcn,'; Training fcn = ',settings.trainalg,'; Learning fcn = ',settings.learnalg];




