function settings=ravemakemodelrbn(src,ev,settings)
handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

xcol=settings.inputs;
d=settings.dataset;
%fitdata=datasets.alldata{d}(settings.fitrows,xcol);
%fittodata=datasets.alldata{d}(settings.fitrows,settings.output);

xfitdata=datasets.alldata{d}(:,xcol);
yfitdata=datasets.alldata{d}(:,settings.output);


%normalize data: feedforward nets like data normalized from -1 to 1.

xmin=min(xfitdata);
xrange=max(xfitdata)-min(xfitdata);

ymin=min(yfitdata);
yrange=max(yfitdata)-min(yfitdata);

xfitdata=bsxfun(@minus,xfitdata,xmin);
xfitdata=bsxfun(@rdivide,xfitdata,xrange);

yfitdata=bsxfun(@minus,yfitdata,ymin);
yfitdata=bsxfun(@rdivide,yfitdata,yrange);

%xfitdata=xfitdata.*2-1;
%yfitdata=yfitdata.*2-1;

%check nn toolbox version:
v=ver('nnet');
if isempty(v)
    errordlg('This model type requires the MATLAB neural network toolbox, which does not appear to be installed. This toolbox can be purchased from The Mathworks.','Toolbox Required')
end


%make network:
net=newrb(xfitdata',yfitdata',settings.goal,settings.spread,settings.mn,10);

%calculate predictions:
alldata=datasets.alldata{d}(:,xcol);

%normalize:

alldata=bsxfun(@minus,alldata,xmin);
alldata=bsxfun(@rdivide,alldata,xrange);

preds=sim(net,alldata')';

preds=preds.*yrange+ymin;
      
settings.predictedvalues=preds;

%make model string:
varnames=handles.allnames{d}(xcol);
varnames=ravemakevariablenames(varnames);

line1='xdata = [';
for v=1:numel(varnames);
    line1=[line1,varnames{v},' ']; %#ok<AGROW>
end

str={};
%str{end+1} = [line1(1:end-1),'];'];


settings.modelstring=str';

