function settings=create_settings(src,ev,thismethod)
%create settings structure for optimizers.

handles=guidata(src);

%get default settings just to check which values should be converted to
%numbers:

if nargin<3
    methodmenu=findobj(handles.tabobjects,'tag','methodmenu');
    allmethods=get(methodmenu,'userdata');
    thismethod=allmethods{get(methodmenu,'value')};
end


[defaultdisplaynames,defaultsettingnames,defaultsettingvalues,isastring]=raveparseoptimizersettingsdefault(src,[],thismethod);

%get settings from objective tab (except the table):
[tabsettingnames,tabsettingvalues]=raveparseoptimizerobjectivetab(src,ev);

if nargin<3
    %get settings from table:
    [tabledisplaynames,tablesettingvalues]=raveparseoptimizersettingstable(src,ev,handles.opttemp.displaynames,handles.opttemp.isastring);
    
    %check that tabledisplaynames match handles.opttemp.displaynames:
    tableidx=[];
    for t=1:numel(tabledisplaynames)
        idx=find(strcmp(tabledisplaynames{t},handles.opttemp.displaynames));
        if ~isempty(idx)
            tableidx(end+1)=idx; %#ok<AGROW>
        end
    end
    
    tablesettingnames=handles.opttemp.settingnames(tableidx);
    if isempty(tablesettingnames);tablesettingvalues={};end
    
    %merge table settings with default settings:
    settingnames=[tabsettingnames(:);tablesettingnames(:)];
    settingvalues=[tabsettingvalues(:);tablesettingvalues(:)];
else
    settingnames=[tabsettingnames(:)];
    settingvalues=[tabsettingvalues(:)];
end


for s=1:numel(settingnames)
    [check idx]=ismember(settingnames{s},defaultsettingnames);
    if check
        try
            if ~isastring(idx)
                settingvalues{s}=str2num(settingvalues{s}); %#ok<ST2NM>
            end
        end
    end
end


%turn into a structure:
namevaluepairs=[settingnames settingvalues]';
namevaluepairs=namevaluepairs(:)';
settings=struct(namevaluepairs{:});
