function optimize_startbutton_callback(src,ev)
handles=guidata(src);

if isempty(handles.opttemp.batchname) %single run
    
    settings=create_settings(src,ev);
    handles.opttemp.settings=settings;
    handles.opttemp.batchname='';
    
    if ~handles.prefs.keepalloptimizerresults
        handles.optimizerresults=cell(0);
    end
    
    guidata(handles.fig,handles);
    do_optimizer(src,ev,settings);
    
else %batch mode
    handles.opttemp.batchname=inputdlg('Name this batch. Results will be saved in a folder with this name.');
    if isempty(handles.opttemp.batchname)
        errordlg('You must enter a name for the batch.')
    end
    
    guidata(src,handles);
    for j=1:numel(handles.opttemp.settings)
        handles.opttemp.filename=handles.opttemp.filenames{j};
        guidata(src,handles);
        settings=handles.opttemp.settings{j};
        do_optimizer(src,ev,settings);
        exportdata_callback(src,ev);
    end
end

%try %#ok<TRYNC>
txtcheck=findobj(handles.tabobjects,'tag','txtcheck');
if get(txtcheck,'value')
    ravesendtxtmessage(handles.fig,[],'Your optimizer has finished.');
end

if isjava(handles.trayIcon)
    trayIconClasses = handles.trayIcon.getClass.getClasses;
    MessageTypes = trayIconClasses(1).getEnumConstants;
    handles.trayIcon.displayMessage('Rave','Your optimizer has finished.',MessageTypes(3));
end

handles=guidata(handles.fig);
handles.opttemp.batchname='';
guidata(handles.fig,handles);

%need to update analysis?
%upate graph to show variations in ALL dimensions:
if settings.updateanalysis && ismember(settings.plotaxes,handles.allgraphs)
    raveupdateanalysis(handles.fig,handles,'xdials',[],settings.d,settings.a);
end