function matches=parenthesesmatch(s,pair1,pair2)
%this function analyzes a text string and returns the positions of the
%matching parentheses pairs.
%
%Default behavior is to call this function with one input, and it will find
%matching ( ) pairs. You can alternately call with three inputs, where
%inputs 2 and 3 are single-character strings and it will find matching
%pairs of those characters instead. e.g. parenthesesmatch(mystr,'{','}')
%

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

if nargin==1
    pair1='(';
    pair2=')';
end
    



%find parenthases in the string s:
leftps=find(s==pair1)';
rightps=find(s==pair2)';

if pair1==pair2 %if both delimiters are the same character
    leftps=leftps(1:numel(leftps)-mod(numel(leftps),2)); %take only an even number of delimiters
    matches=reshape(leftps,2,[])';
    return
end



%nleft=length(leftps);
nright=length(rightps);

%construct two vectors to show which parenthasis in the opposing group this
%group matches to:
%leftmatch=zeros(length(leftps),1);
rightmatch=zeros(length(rightps),1);

%also have logic vectors to keep track of which parenteses have already
%found their match:
notmatchedl=true(length(leftps),1);
%notmatchedr=true(length(rightps),1);


for k=1:nright %start with first closer, match this to the preceeding opener.
    %find candidates for rightmatch
    possiblematches=leftps<rightps(k);
    possiblematches=possiblematches & notmatchedl;
    %logic vector of matching parentheses that occur after this one
    if sum(possiblematches)==0 %no match for this )
        %go to next psright, and leave this as 0 in rightmatch.
    else
        rightmatch(k)=max(leftps(possiblematches));
        notmatchedl(leftps==max(leftps(possiblematches)))=0;
    end
end

matches=sortrows([rightmatch rightps],1);
