function isnondominated=pareto_filter(paretodata)
%Fast min-the-best pareto filtering on rows of paretodata. Filters across all columns of pareto data
%(so remove the ones you dont want to filter by before using this funciton). Only works for
%min-the-best (so reformat the data so that min is best before using this function)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


numpts=size(paretodata,1); %number of rows

%initialize vars:
i=0;
index=1:numpts; %index is a list of the indices (into paretodata) of remaining nondominated points
nondomdata=paretodata; %nondomdata is an array of the remaining nondominated points. (dom'd rows removed)
isnondominated=true(numpts,1);

%% sort data:
% 
% Xmin=min(paretodata);
% X1=paretodata-Xmin(ones(numpts,1),:); %FASTER THEN REPMAT?
% Xmean=mean(X1);
% 
% [x,checklist]=sort(max(X1./Xmean(ones(numpts,1),:),[],2));
% 
% paretodata=paretodata(checklist,:);
% nondomdata=paretodata;
% %% 
% 

while i<index(end);
    i=index(find(index>i,1));

    thisrow=paretodata(i,:); %check this row against all others 
     
    asgood=bsxfun(@le,nondomdata,thisrow);
    better=bsxfun(@lt,nondomdata,thisrow);   
    
    asgood=all(asgood,2);
    better=any(better,2);
    E=asgood & better; %determine domination
   
    isnondominated(E)=false;
    %remove all rows this row dominates from remaining iterations:
    index=index(isnondominated);     
    nondomdata=nondomdata(isnondominated,:);  
    isnondominated=true(size(nondomdata,1),1);
end

%convert index into logic vector:
isnondominated=false(numpts,1);
isnondominated(index)=true;