%General
function raveeditprefsgeneral(src,ev)

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2013 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

c1=uicontrol('style','checkbox','string','Rave window is resizable',...
    'position',[260 428 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',handles.prefs.isresizable,'callback',@resizecheck_callback);
c2=uicontrol('style','checkbox','string','Auto-rasterize graphs',...
    'position',[260 398 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',handles.prefs.alwaysrasterize,'callback',@rasterizecheck_callback);
c3=uicontrol('style','checkbox','string','Update linked graphs instantly',...
    'position',[260 368 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',handles.prefs.alwaysupdate,'callback',@linkcheck_callback);
c4=uicontrol('style','checkbox','string','Update current point whenever a single point (row) is selected',...
    'position',[260 338 540 20],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',handles.prefs.setxdialswhensingleselected,'callback',@cpcheck_callback);

txt1=uicontrol('style','text','string','Interpret Variable names using:',...
    'position',[260 310 540 18],'backgroundcolor',handles.colors.frame,'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal');

mvalue=find(ismember({'none';'tex';'latex'},{handles.prefs.interpreter}));

m1=uicontrol('style','popup','string',{'none';'TeX';'LaTeX'},...
    'position',[270 285 100 18],'backgroundcolor',[1 1 1],'fontsize',10,'hor','left',...
    'parent',src,'fontweight','normal','value',mvalue,'callback',@interpmenu_callback);

handles.temp.tabobjects=[c1 c2 c3 c4 txt1 m1];

guidata(src,handles);


function resizecheck_callback(src,ev)
handles=guidata(src);
handles.prefs.isresizable=get(src,'value');
guidata(src,handles);


function rasterizecheck_callback(src,ev)
handles=guidata(src);
handles.prefs.alwaysrasterize=get(src,'value');
guidata(src,handles);

function linkcheck_callback(src,ev)
handles=guidata(src);
handles.prefs.alwaysupdate=get(src,'value');
guidata(src,handles);

function cpcheck_callback(src,ev)
handles=guidata(src);
handles.prefs.setxdialswhensingleselected=get(src,'value');
guidata(src,handles);

function interpmenu_callback(src,ev)
str=get(src,'string');
v=lower(str{get(src,'value')});
handles=guidata(src);
handles.prefs.interpreter=v;
guidata(src,handles);

