function outrows=ravecalculatefilteredstate(src,ev,d,a)
%returns a logical list of which rows in dataset d, analysis a, are
%currently filtered. 

handles=guidata(src);
datasets=raveguidata(handles.fig,'datasets');

[nrows,nvars]=size(datasets.alldata{d});

allthisdata = datasets.alldata{d}; %for large data sets, faster to call this once than subsidx into datasets.alldata in a loop below:

inrows=false(nrows,nvars);

for x=1:nvars;
    if handles.isconstant{d}(x)
        inrows(:,x)=true;
        continue
    end
    
    switch handles.datatype{d}{x}
        case 'continuous'
            inrows(allthisdata(:,x)+eps(max(allthisdata(:,x)))>=handles.minfilter{d}{a}(x)-eps(handles.minfilter{d}{a}(x)) & allthisdata(:,x)-eps(max(allthisdata(:,x)))<=handles.maxfilter{d}{a}(x)+eps(handles.maxfilter{d}{a}(x)),x)=true;
            %NaN ignores filters:
%             inrows(isnan(datasets.alldata{d}(:,x)),x)=true;
        case 'string'
            filt=find(handles.discretefilter{d}{a}{x});
            inrows(ismembc(allthisdata(:,x),filt),x)=true; 
            %NaN ignores filters:
%             inrows(isnan(datasets.alldata{d}(:,x)),x)=true;
        case 'discrete'
            filt=sort(handles.discretevalues{d}{a}{x}(handles.discretefilter{d}{a}{x}));
            inrows(ismembc(allthisdata(:,x),filt),x)=true;
            %NaN ignores filters:
%             inrows(isnan(datasets.alldata{d}(:,x),x))=true;
        otherwise
            inrows(:,x)=true; %dont filter on unsupported variable types
            
    end
    
    %do not exclude NaN data. If you would like NaN data to show up as
    %being filtered, set right hand side to false below:
    inrows(isnan(allthisdata(:,x)),x)=true;
end
outrows=~all(inrows,2);


