function [w,h]=ravecalculatestringlength(string,fontname,fontsize,fontstyle,AxisCanvas)
%Calculates the pixel dimensions of the specified string, in the specified
%font. Fontstyle may be either 'plain','bold',or 'italic' (bold+italic not
%allowed... just use bold). Last input is a java graphics object (generally handles.AxisCanvas)
%
% First output is the string length, 2nd output is the string height.

%make javafont:
switch lower(fontstyle)
    case 'plain'
        style=java.awt.Font.PLAIN;
    case 'bold'
        style=java.awt.Font.BOLD;
    case 'italic'
        style=java.awt.Font.ITALIC;
    otherwise
        style=java.awt.Font.PLAIN;
end

font=java.awt.Font(fontname,style,ceil(fontsize*4/3)); %4/3 factor accounts for difference between java/matlab scales (72 vs 96 dpi);

%calculate string dimensions in pixels:
graphics=AxisCanvas.getGraphics;
metrics=graphics.getFontMetrics(font);
bounds=metrics.getStringBounds(string,graphics);
w=bounds.getWidth;
h=metrics.getHeight;

