function ravecreatelinkvariable(src,d1,d2,v1,v2,x,newname)
%Copies variable x from d1 to d2 by linking v2 in d2 to v1 in d1. The copied variable will have name = newname.

handles = guidata(src);

datasets=raveguidata(handles.fig,'datasets');
vectordata=raveguidata(handles.fig,'vectordata');
datasets.datatype{d2}{end+1}=handles.datatype{d1}{x};

%Define the link:
idx = numel(datasets.datatype{d2});
datasets.isvirtual{d2}(idx) = true; %Note: isvirtual grows automatically when datasets.datatype is set. Other variables do not so they get end+1:
datasets.virtuald{d2}(idx) = d1; %index of the data set this variable links to
datasets.linkfrom{d2}(idx) = v2; %index of the column this variable links from
datasets.linkto{d2}(idx)= v1; %index of the column this variable links to
datasets.virtualc{d2}(idx) = x; %index of the column in the linked-to dataset(virtuald) whose values should be returned in this column.
datasets.isvalid{d2}(:,idx) = datasets.isvalid{d1}(:,x);

raveguidata(src,datasets);

vectordata.vectordata{d2}=[vectordata.vectordata{d2},cell(size(vectordata.vectordata{d2},1),1)];
raveguidata(src,vectordata);

handles.basenames{d2}{end+1}=newname;
% handles.datasetlinks{d2}{end+1}=handles.datasetlinks{d1}{x};
% handles.datasetlinkinfo{d2}{end+1}=handles.datasetlinkinfo{d1}{x};
handles.variablecolors{d2}(end+1,:)=handles.variablecolors{d1}(x,:);
handles.allunits{d2}{end+1}=handles.allunits{d1}{x}; %havent implemented this yet
handles.isincluded{d2}(end+1)=handles.isincluded{d1}(x);
handles.isconstant{d2}(end+1)=handles.isconstant{d1}(x);
handles.isfunction{d2}(end+1)=handles.isfunction{d1}(x);
handles.funclass{d2}{end+1}=handles.funclass{d1}{x};
handles.funattributes{d2}{end+1}=handles.funattributes{d1}{x};
handles.funnames{d2}{end+1}=handles.funnames{d1}{x};
handles.funvars{d2}{end+1}=length(handles.funvars{d2})+1;
handles.depvars{d2}{end+1}=length(handles.depvars{d2})+1;
handles.nargout{d2}(end+1)=handles.nargout{d1}(x);
handles.datatype{d2}{end+1}=handles.datatype{d1}{x};
handles.isnoise{d2}(end+1)=handles.isnoise{d1}(x);
handles.preferences{d2}(end+1)=handles.preferences{d1}(x);
handles.targetvalues{d2}(end+1)=handles.targetvalues{d1}(x);
handles.isobjective{d2}(end+1)=handles.isobjective{d1}(x);
handles.maintable.colwidths{d2}(end+1)=handles.maintable.colwidths{d1}(x);
handles.distributions{d2}{end+1}=handles.distributions{d1}{x}; 
handles.aggregatingstatistic{d2}{end+1}=handles.aggregatingstatistic{d1}{x};
handles.activedistribution{d2}(end+1)=handles.activedistribution{d1}(x);

for a=1:numel(handles.analysisnames)
    handles.xdials{d2}{a}(end+1)=handles.xdials{d1}{a}(x);
    handles.minlimit{d2}{a}(end+1)=handles.minlimit{d1}{a}(x);
    handles.maxlimit{d2}{a}(end+1)=handles.maxlimit{d1}{a}(x);
    handles.minfilter{d2}{a}(end+1)=handles.minfilter{d1}{a}(x);
    handles.maxfilter{d2}{a}(end+1)=handles.maxfilter{d1}{a}(x);
    handles.discretevalues{d2}{a}{end+1}=handles.discretevalues{d1}{a}{x};
end

handles.allnames{d2}(end+1)=ravemakevariablename(handles,d2,numel(handles.basenames{d2}));

guidata(src,handles);

%update maintable udata to display new columns:
handles.maintable.x{d2}=union(handles.maintable.x{d2},size(handles.funnames{d2},2));
ravefinish; %make a done sound.



