function ravedataset2gv(handles,d,x,outfile,varargin)
%Converts a Rave dataset structure to a .gv file that can be sent to GraphViz
%to generate an output file. 

names=handles.allnames{d};

adj=zeros(numel(names));
while ~isempty(x)
    x=sort(x,'descend');
    thisx=x(1);
    parents=handles.funvars{d}{thisx};
    adj(parents,thisx)=1;
    x=union(x,parents);
    x=x(x<thisx);
end

%Set diagonal elements to 0 since they don't get drawn:
n=size(adj,1);
adj(1:n+1:n^2)=0;

[edges(:,1),edges(:,2)]=find(adj>0);

fid=fopen(outfile,'w');
fprintf(fid,'digraph G {\n');

%Make edges:
for g=1:size(edges,1);
    fprintf(fid,'"%s" -> "%s" [arrowhead=none];\n',names{edges(g,1)},names{edges(g,2)});    
end

fprintf(fid,'}');
fclose all;





