function ravedefaultwindowbuttonmotionfcn(src,ev)
%IMPORTANT: to avoid massive computational difficulty, this function keeps
%handles as a persistent variable. That means any time you make a change to
%handles that could affect this function, you need to clear this function. 
%This includes at least:
%  *adding a handle to handles.mouseoverobjects
%  *using raveupdatedataset

%for speed, this function uses ismembc on handles.mouseoverobjects. This
%requires that handles.mouseoverobjects be sorted, so any modifications to
%that vector should be followed by a sort. 

persistent handles

if isempty(handles) || src~=handles.fig %when using two Raves at the same time, need to reload handles for each separate Rave window. 
    handles=guidata(src);
end

% hittest(handles.fig)




if ~handles.prefs.processmouseovers || isempty(handles.mouseoverhandles)
    return
end

%determine mouseover object:
obj=hittest(src);

if isempty(obj);return;end

b=find(handles.mouseoverhandles==obj,1,'first');
if isempty(b);return;end

%run mouseoverfunction:
%handles.mouseoverfunctions{b}{1} = function handle
%handles.mouseoverfunctions{b}{2:end} = additional function inputs. at a
%minimum this must contain ai, so that handles.mouseoverfunctions{b}{2} is
%always a valid index.

handles.mouseoverfunctions{b}{1}(obj,[],handles.mouseoverfunctions{b}{2:end});





