function f=ravedefinerowlabelgui(src,ev,d)
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);

%make figure:
f=figure('units','pixels','position',[0 0 400 200],'name',...
    'Set Row Label Column','numbertitle','off','menubar','none','resize','off');
handles.gui=f;
origin=get(0,'userdata');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=thispos(2)+origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);

%make tabs:

%get theme
load raveprefs
handles.prefs=raveprefs;
handles.colors=handles.prefs.colors;
handles.fonts=handles.perfs.fonts;

set(f,'color',handles.colors.frame)


uicontrol('style','text','units','pixels','position',[20 140 360 60],...
    'string',{'Select the variable whose values serve as identifying labels for the corresponding rows of the data set. The values of the selected variable will be displayed whenever Rave needs to identify a row of the data set by name.'},...
    'backgroundcolor',get(f,'color'),'hor','left');

uicontrol('style','popupmenu','units','pixels','position',[80 80 250 35],'tag','menu',...
    'string',[{'<Use Row Numbers>'},handles.indata.allnames{d}],'backgroundcolor',[1 1 1]);


uicontrol('style','pushbutton','units','pixels','position',[265 11 120 35],'tag','donebutton',...
    'string','Done','callback',@donebutton_Callback,'fontsize',12);


%guidata(f,handles);

% --- Executes on button press in donebutton.
function donebutton_Callback(src, eventdata)
handles=guidata(src);

menu=findobj(gcf,'tag','menu');
set(0,'userdata',get(menu,'value'));
close(gcf);



