function hhh=raveeditthemegui(src,ev) %#ok<INUSD>
%pop up window to let user pick variable colors and figure colormap.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
load raveprefs


%d=get(handles.listbox1,'value'); %selected data set.
%handles.d=d;
%handles.thisvar=1;
origin=get(handles.fig,'position');

hhh=figure('menubar','none','units','pixels','position',[origin(1)+origin(3)/2-240 origin(2)+origin(4)/2-300 700 600],'color',raveprefs.colors.frame,...
    'name','Choose default variable colors and figure colormap.','numbertitle','off','resize','off','windowstyle','normal');

titleaxes=axes('units','pixels','position',[20 550 400 40],'parent',hhh,'visible','off');
text(0,.4,'Change Variable Colors and Colormap','parent',titleaxes,'fontname',handles.fonts.title,'fontsize',handles.fonts.titlesize,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');

uicontrol('style','text','parent',hhh,'units','pixels','position',[35 535 400 22],'string','Choose one of the colormaps below for each application:',...
    'fontsize',10,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')
uicontrol('style','text','parent',hhh,'units','pixels','position',[55 518 500 22],...
    'string','Variable Colors are the default line color associated with each variable in a data set.',...
    'fontsize',10,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','normal')
uicontrol('style','text','parent',hhh,'units','pixels','position',[55 501 600 22],...
    'string','Colormap is used in scatterplots to color markers according to the value of a particular variable.',...
    'fontsize',10,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','normal')


colimage=imread('ravecolormaps.png');
colimagebg=colimage(:,:,1)==colimage(1,1,1) & colimage(:,:,2)==colimage(1,1,2) & colimage(:,:,3)==colimage(1,1,3);
colback=uint8(repmat(reshape(raveprefs.colors.frame.*255,[1 1 3]),[size(colimage,1) size(colimage,2)]));
colimagebg=uint8(colimagebg);
colimagebg=uint8(colimagebg);
%colimage=colimage.cdata;
colback=bsxfun(@times,colback,colimagebg);
colfront=bsxfun(@times,colimage,uint8(~colimagebg));
colimage=colback+colfront;


colaxes=axes('units','pixels','position',[210 200 size(colimage,2) size(colimage,1)],'parent',hhh);
image(colimage,'parent',colaxes);
set(colaxes,'visible','off')

%header row:
uicontrol('style','text','parent',hhh,'units','pixels','position',[10 450 400 22],...
    'string','Variable Colors:    Colormap:',...
    'fontsize',10,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

%colormapnames:
uicontrol('style','text','parent',hhh,'units','pixels','position',[550 416 150 22],...
    'string','Rave',...
    'fontsize',12,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

uicontrol('style','text','parent',hhh,'units','pixels','position',[550 370 150 22],...
    'string','HSV',...
    'fontsize',12,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

uicontrol('style','text','parent',hhh,'units','pixels','position',[550 320 150 22],...
    'string','Jet',...
    'fontsize',12,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

uicontrol('style','text','parent',hhh,'units','pixels','position',[550 270 150 22],...
    'string','Accel',...
    'fontsize',12,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

uicontrol('style','text','parent',hhh,'units','pixels','position',[550 220 150 22],...
    'string','Accel (Alt)',...
    'fontsize',12,'backgroundcolor',raveprefs.colors.frame,'horizontalalignment','left','fontweight','bold')

%checkboxes for options:
variablecolorz(1)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[55 416 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@variablecheck,'tag','variable','userdata','rave');
variablecolorz(2)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[55 370 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@variablecheck,'tag','variable','userdata','hsv');
variablecolorz(3)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[55 320 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@variablecheck,'tag','variable','userdata','jet');
variablecolorz(4)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[55 270 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@variablecheck,'tag','variable','userdata','accel');
variablecolorz(5)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[55 220 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@variablecheck,'tag','variable','userdata','altaccel');


colormapz(1)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[155 416 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@colormapcheck,'tag','colormap','userdata','rave');
colormapz(2)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[155 370 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@colormapcheck,'tag','colormap','userdata','hsv');
colormapz(3)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[155 320 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@colormapcheck,'tag','colormap','userdata','jet');
colormapz(4)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[155 270 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@colormapcheck,'tag','colormap','userdata','accel');
colormapz(5)=uicontrol('style','radiobutton','parent',hhh,'units','pixels','position',[155 220 26 26],'string','',...
    'backgroundcolor',raveprefs.colors.frame,'callback',@colormapcheck,'tag','colormap','userdata','altaccel');

uicontrol('style','checkbox','parent',hhh,'units','pixels','position',[155 180 260 26],'string','Reverse Colormap',...
    'backgroundcolor',raveprefs.colors.frame,'tag','reversecolormap')


selectedoptions=findobj(colormapz,'userdata',raveprefs.defaultcolormap);
set(selectedoptions,'value',1);
selectedoptions=findobj(variablecolorz,'userdata',raveprefs.defaultvariablecolors);
set(selectedoptions,'value',1);

uicontrol('style','pushbutton','parent',hhh,'units','pixels','position',[200 80 100 26],'string','Done',...
    'backgroundcolor',raveprefs.colors.buttonbg,'callback',@donebutton_callback)

uicontrol('style','pushbutton','parent',hhh,'units','pixels','position',[400 80 100 26],'string','Cancel',...
    'backgroundcolor',raveprefs.colors.buttonbg,'callback',@cancelbutton_callback)



function colormapcheck(src,ev)
colorchecks=findobj(get(src,'parent'),'tag','colormap');
set(colorchecks,'value',0)
set(src,'value',1)

function variablecheck(src,ev) %#ok<INUSD>
variablechecks=findobj(get(src,'parent'),'tag','variable');
set(variablechecks,'value',0)
set(src,'value',1)

function donebutton_callback(src,ev) %#ok<INUSD>

thiscolormap=findobj(get(src,'parent'),'tag','colormap','value',1);
thisvarcolor=findobj(get(src,'parent'),'tag','variable','value',1);

load raveprefs
    raveprefs.defaultcolormap=get(thiscolormap,'userdata');
    raveprefs.defaultvariablecolors=get(thisvarcolor,'userdata');
prefspath=which('raveprefs.mat');
save(prefspath,'raveprefs');

thisfigure=get(src,'parent');
close(thisfigure);

function cancelbutton_callback(src,ev) %#ok<INUSD>
thisfigure=get(src,'parent');
close(thisfigure);




