function indexx=ravegetindependentvars(handles,d,a,y,c)
% Given a list of function-variable indices, y, and a list of constraint
% indices, c, returns a list of the lowest-level (independent) variables 
% such that all y and c functions can be evaluated as functions of x.
%
% This function only returns independent variables. If intermediate
% functions need to be evaluated en route to evaluating y/c, they will not
% be included in indexx.

if nargin<5
    c=[];
end

%get variables for this functions:
indexx=[];

% for i=1:numel(y)
%    indexx=union(indexx,handles.funvars{d}{y(i)}); 
% end
indexx = unique([handles.funvars{d}{y}]);


%also variables for any constraints:
% for ac=1:numel(c)
%     indexx=union(indexx,handles.constraintvars{d}{a}{c(ac)});
% end
cindexx=unique([handles.constraintvars{d}{a}{c}]);
 
indexx = unique([indexx,cindexx]);


%get lowest level inputs:
while any(handles.isfunction{d}(indexx))
    arefuns=find(handles.isfunction{d}(indexx),1,'last');
    thisfun=indexx(arefuns);
    newvars=handles.funvars{d}{thisfun};
    indexx=union(indexx,newvars);
    indexx=setdiff(indexx,thisfun);
end

indexx=indexx(:)'; %other functions assume result will be a row vector