function udata = raveinitializeudatastandard(src,ev)
%Creates the standard udata fields that are required for all workspace
%objects with their default values. This lets you write shorter 
%"initializeudata" functions because you only need to fill in the 
%values that differ from the defaults. 


handles = guidata(src);

udata.manage.israsterized=0;

udata.attributes={};

udata.view.dataset=1;
udata.view.analysis=1;

udata.view.x = 0;
udata.view.y = 0;
udata.view.z = 0;
udata.view.c = 0;
udata.view.s = 0;

udata.view.constraints=0;

udata.format.xlim=[];
udata.format.ylim=[];
udata.format.zlim=[];
udata.format.clim=[];
udata.format.slim=[];
udata.format.persistentlimits=[0 0 0 0 0];

udata.format.title='';
udata.format.xlabel='';
udata.format.nxlabelrows=0; %number of rows of text of xlabel
udata.format.ylabel='';
udata.format.zlabel='';
udata.format.clabel='';
udata.format.slabel='';

udata.format.mcmap=handles.prefs.defaultcolormap; %main colormap
udata.format.colorbar=1;
udata.format.colormapping='global';
udata.format.legend=1;
udata.format.reversecolors=0;

udata.format.bg=1; %index for background color;
udata.format.grid=1; %index for grid;

udata.explore.method={};
udata.explore.extrainset=[0 0 0 0];
udata.explore.mouseover=true;
udata.explore.option=1;
udata.explore.tooltip=[]; %currently unused
udata.explore.mouseoverhandles=[];



