function nicenums = ravemakeniceticks(low,high,ntick)
%determine where to place tick marks on graphs. Based on "Nice numbers for
%Graph Labels" by Paul Heckbert. 

range=nicenum(high-low,false);
d=nicenum(range/(ntick-1),true);
graphmin=floor(low/d)*d;
graphmax=ceil(high/d)*d;
%nfrac=max(-floor(log10(d)),0);

nicenums=graphmin:d:graphmax;

function nice = nicenum(x,doround)
exponent= floor(log10(x));
f = x/(10^exponent);

if doround
    if f < 1.5; nf=1;
    elseif f<3; nf=2;
    elseif f<7; nf=5;
    else nf=10;
    end
else
    if f<=1; nf=1;
    elseif f<=2; nf=2;
    elseif f<=5; nf=5;
    else nf=10;
    end
end
    
nice= nf*10^exponent;
        

