function name=ravemakevariablename(handles,d,x)
%Makes an "allnames" name from a "basename" name by appending
%prefixes/suffixes as needed.
%NOTE: this function returns names in a cell array

name=handles.basenames{d}(x);


for i=1:numel(x)
    if handles.isfunction{d}(x)
        %Is this a function of random variables?
        ins=ravegetindependentvars(handles,d,1,x(i));
        if any(handles.isnoise{d}(ins)) %yes, this is a random variable
            switch handles.aggregatingstatistic{d}{x(i)}{1}
                case 'mean'
                    name{i}=['mean(',name{i},')'];
                case 'median'
                    name{i}=['median(',name{i},')'];
                case 'pfeasible'
                    name{i}=['P_{feas}(',name{i},')'];
                case 'plt'
                    name{i}=['P(',name{i},')<',num2str(handles.aggregatingstatistic{d}{x(i)}{2})];
                case 'pgt'
                    name{i}=['P(',name{i},')>',num2str(handles.aggregatingstatistic{d}{x(i)}{2})];
            end
        end
    end
end
