function ravematrixplotautoaxeslimits(src,ev,xinset,yinset)
%resets the axes limits for all subax in the active graph to be tight +
%margin, where margin is a fraction of the tight range (e.g. 0.05 for 5%
%margin)

handles=guidata(src);

ax=handles.subax{handles.activeindex};
fakeax=handles.subfakeax{handles.activeindex};
fakerax=handles.subfakerax{handles.activeindex};

% set(ax,'xlimmode','manual','ylimmode','manual')

rows=size(ax,1);
cols=size(ax,2);

for r=rows:-1:1
    for c=cols:-1:1
        xlim(r,c,:) = get(ax(r,c),'xlim');
        ylim(r,c,:) = get(ax(r,c),'ylim');
    end
end
        
xlimmin = min(xlim(:,:,1),[],1);
xlimmax = max(xlim(:,:,2),[],1);
ylimmin = min(ylim(:,:,1),[],2);
ylimmax = max(ylim(:,:,2),[],2);

badxlims=xlimmin==xlimmax;
xlimmin(badxlims)=xlimmin(badxlims)-0.5;
xlimmax(badxlims)=xlimmax(badxlims)+0.5;

badylims=ylimmin==ylimmax;
ylimmin(badylims)=ylimmin(badylims)-0.5;
ylimmax(badylims)=ylimmax(badylims)+0.5;

%% fix axes limits:
for r=1:rows,
    set(ax(r,1),'ylim',single([ylimmin(r,1) ylimmax(r,1)]))
    dy = diff(get(ax(r,1),'ylim'))*yinset;
    set(ax(r,:),'ylim',single([ylimmin(r,1)-dy ylimmax(r,1)+dy]))
    
    set(fakeax(r,1),'ylim',single([ylimmin(r,1) ylimmax(r,1)]))
    dy = diff(get(fakeax(r,1),'ylim'))*yinset;
    set(fakeax(r,:),'ylim',single([ylimmin(r,1)-dy ylimmax(r,1)+dy]))
    
    set(fakerax(r,1),'ylim',single([ylimmin(r,1) ylimmax(r,1)]))
    dy = diff(get(fakerax(r,1),'ylim'))*yinset;
    set(fakerax(r,:),'ylim',single([ylimmin(r,1)-dy ylimmax(r,1)+dy]))
    
    %force non exponential labels:
    set(ax(r,1),'YTickLabel',get(ax(r,1),'YTick'))
    set(fakeax(r,1),'YTickLabel','')
    set(fakerax(r,1),'YTickLabel','')
    
end
dx = zeros(1,cols);

for c=1:cols,
    set(ax(1,c),'xlim',single([xlimmin(1,c) xlimmax(1,c)]))
    dx(c) = diff(get(ax(1,c),'xlim'))*xinset;
    set(ax(:,c),'xlim',single([xlimmin(1,c)-dx(c) xlimmax(1,c)+dx(c)]))
    
    set(fakeax(1,c),'xlim',single([xlimmin(1,c) xlimmax(1,c)]))
    dx(c) = diff(get(fakeax(1,c),'xlim'))*xinset;
    set(fakeax(:,c),'xlim',single([xlimmin(1,c)-dx(c) xlimmax(1,c)+dx(c)]))
    
    set(fakerax(1,c),'xlim',single([xlimmin(1,c) xlimmax(1,c)]))
    dx(c) = diff(get(fakerax(1,c),'xlim'))*xinset;
    set(fakerax(:,c),'xlim',single([xlimmin(1,c)-dx(c) xlimmax(1,c)+dx(c)]))
    
    %force non exponential labels:
    set(ax(end,c),'XTickLabel',get(ax(end,c),'XTick'))
    set(fakeax(end,c),'XTickLabel','')
    set(fakerax(end,c),'XTickLabel','')
end