function ravemoveview(varargin)
%NOTE: this function depends on using varargin instead of specifying an exact number of inputs,
%so don't change that in the future.
%
%ravemoveview(handles.fig,[],clicked);
%clicked is optional
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2014 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


src=varargin{1};
handles=guidata(src);

%get existing position and click location
oldviewpos=get(handles.currentview,'position');

if numel(varargin)==3
    clicked=varargin{3};
    %round to nearest integers:
    clicked=round(clicked);
    
else
    clicked=get(handles.explorer,'currentpoint');
    %round to nearest integers:
    clicked=round(clicked);
    
    
    %update scrollbars
    if clicked(1,2,1)>handles.prefs.wsheight-oldviewpos(4)/2
        set(handles.vscroll,'value',handles.prefs.wsheight-oldviewpos(4)/2)
    elseif clicked(1,2,1)<oldviewpos(4)/2
        set(handles.vscroll,'value',oldviewpos(4)/2)
    else
        set(handles.vscroll,'value',clicked(1,2,1))
    end
    
    if clicked(1,1,1)>handles.prefs.wswidth-oldviewpos(3)/2
        set(handles.hscroll,'value',handles.prefs.wswidth-oldviewpos(3)/2)
    elseif clicked(1,1,1)<oldviewpos(3)/2
        set(handles.hscroll,'value',oldviewpos(3)/2)
    else
        set(handles.hscroll,'value',clicked(1,1,1))
    end
    
end

%center box on click location
clicked(1,1,1)=clicked(1,1,1)-oldviewpos(3)/2;
clicked(1,2,1)=clicked(1,2,1)-oldviewpos(4)/2;

%limit new location to always be inside workspace
if clicked(1,1,1)+oldviewpos(3)>handles.prefs.wswidth
    clicked(1,1,1)=handles.prefs.wswidth-oldviewpos(3);
elseif clicked(1,1,1)<0
    clicked(1,1,1)=0;
end

if clicked(1,2,1)+oldviewpos(4)>handles.prefs.wsheight
    clicked(1,2,1)=handles.prefs.wsheight-oldviewpos(4);
elseif clicked(1,2,1)<0
    clicked(1,2,1)=0;
end

%round to nearest integers:
clicked=round(clicked);

%move to new location
set(handles.currentview,'position',uint16([clicked(1,1,1) clicked(1,2,1) oldviewpos(3) oldviewpos(4)]));

%allow dragging
if numel(varargin)~=3
    set(handles.fig,'WindowButtonMotionFcn',@ravemoveview);
    set(handles.fig,'WindowButtonUpFcn',@movedone);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%update workspace to show new view:
raveupdateview(src,[],handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



function movedone(src,eventdata)
%load handles
handles=guidata(src);

%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);

