function [varnames,data,textdata,discretevalues,datatype,datasetnames]=raveparsevariables2dataset(handles,infile)
%Create "in" structure from variables in the main matlab workspace
in=[];
try
    infile=strrep(infile,',',' ');
    evalin('base',['save ravetempdata ',infile]);
    indata = load('ravetempdata.mat');
    delete('ravetempdata.mat');
catch
    try
        in=importdata(infile);
    catch
        errordlg('The data source you have entered does not seem to be a valid file name and is not the name of a variable in the base MATLAB workspace.','Invalid Data Source')
        return
    end
end

%determine how many varaibles were specified and which came first:
vars=symvar(infile);

if numel(vars)==1
    datafield=vars{1};
    namesfield='';
elseif numel(vars)==2
    if numel(unique(vars))<2
        errordlg('You must input a single workspace variable name or two different workspace variable names.')
    end
    %which variable is data and which is names?
    if ~iscell(indata.(vars{1}))
        datafield=vars{1};
        namesfield=vars{2};
    else
        datafield=vars{2};
        namesfield=vars{1};
    end
else
    errordlg('You can only specify the names of two workspace variables: a 2-D array of data and a 1-D cell array of variable names.');
    return
end

if isempty(in)
    in.textdata=num2cell(indata.(datafield));
    if ~isempty(namesfield)
        if ~iscellstr(indata.(namesfield))
            errordlg('When inputing workspace variable names, the variable containing the data must be listed first, (optionally) followed by the variable containing the column names')
        end
        indata.(namesfield)=indata.(namesfield)(:)'; %ensure is row
        in.colheaders=indata.(namesfield);
%         in.textdata=indata.(namesfield);
%         in.textdata = cell(size(in.data));
%         [in.textdata{:}] = deal('');
    else
        colnames=cell(1,size(in.data,2));
        for c=1:numel(colnames)
            colnames{c}=['Column ',num2str(c)];
        end
        in.colheaders=colnames;
%         in.textdata=colnames;
    end
end

[varnames,data,textdata,discretevalues,datatype]=raveparsedatastructure(handles,in);

