function raveputawaynoprompt(src,ev,ai)
%put away the graph with index ai without asking the user.
%See also: raveputaway
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);
name=handles.graphnames{ai};
if isempty(name)
    name='Untitled Graph';
end

udata=get(handles.fakeax(ai),'userdata'); %#ok this line may be used by the eval statements!
%hide main axes:
allparents=[handles.allgraphs(ai);handles.fakeax(ai);handles.fakerax(ai);...
    handles.subax{ai}(:);handles.subfakeax{ai}(:);handles.subfakerax{ai}(:)];
%move other graph-specific objects:
graphtype=get(handles.allgraphs(ai),'userdata');
if isfield(handles.graphinfo.(graphtype),'deletehandles')
    deletehandles=handles.graphinfo.(graphtype).deletehandles;
    for f=1:numel(deletehandles)
        thesehandles=eval([deletehandles{f},';']);
        allparents=[allparents;thesehandles(:)];  %#ok<AGROW>
    end
end

allparents=findobj(allparents,'parent',handles.wspanel,'-depth',1);

lastkids=get(handles.boneyard,'children');
set(allparents,'parent',handles.boneyard);
set(handles.boneyard,'children',[lastkids;allparents]);
set(handles.allblockers(ai),'visible','off')
set(handles.expblockers(ai),'visible','off')
set(handles.grabbers{ai},'visible','off')

handles.graphnames{handles.activeindex}=name;
handles.putaway=union(handles.putaway,handles.activeindex);

%make another graph the active graph:
newgraph=[];
for s=1:length(handles.allgraphs)
    if ishandle(handles.allgraphs(s)) && ~ismember(s,handles.putaway) %this graph hasnt been deleted and isnt put away
        newgraph=handles.allgraphs(s);
        break
    end
end

handles.activeindex=[];
handles.activegraph=[];
guidata(src,handles);

if ~isempty(newgraph) %graphs exist
    raveselectgraph(newgraph,[]) %make this graph current.
end






