function raveunhidepoints(src,ev)
%unhide all poitns in current analysis and update all graphs to reflect this. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

answer=questdlg('Are you sure you want to unhide all points on the current graph (and all graphs linked to this one)?','Unhide Points');

if ~strcmp(answer,'Yes');return;end

handles.isvisible{udata.view.dataset}{udata.view.analysis}=true(size(handles.isselected{udata.view.dataset}{1},1),1);

raveupdateanalysis(handles.fig,handles,'visiblerows',[],udata.view.dataset,udata.view.analysis);