function raveupdategraphtypes(src,ev)

handles=guidata(src);

%% load data for all graphtypes:
raveroot=which('rave');
raveroot=raveroot(1:end-6);
handles.graphinfo=struct;
graphclasses={'discrete';'continuous';'special';'table';'control';'annotation'};
for G=1:numel(graphclasses)

    maindir=fullfile(raveroot,'graphics',[graphclasses{G}]);
    graphtypes=dir(maindir);

    for g=3:numel(graphtypes)
       % h=g-2;
        if graphtypes(g).isdir && graphtypes(g).name(1)~='X'
            thisname=graphtypes(g).name;
            %remove leading numbers:
            firstletter=find(isstrprop(thisname,'alpha'),1);
            keyword=thisname(firstletter:end);
            %get graphinfo:
            fid=fopen(fullfile(maindir,thisname,'graphinfo.txt'),'r');
              
            %get properties for this graph type:
            properties=struct;
            try
            eval(['graphproperties',keyword]);
            catch %#ok<CTCH>
               addpath(fullfile(maindir,thisname),'-begin');
               try
                   eval(['graphproperties',keyword]);
               catch %#ok<CTCH>
                   error(['rave:filenotfound','The graphproperties.m file could not be found for graph type ' ...
                       keyword '. Either create this file or remove the ' keyword ' folder from Rave''s graphics directory']);
               end
                
            end
            handles.graphinfo.(keyword)=properties;
            handles.graphinfo.(keyword).longname=fgetl(fid);
            handles.graphinfo.(keyword).class=graphclasses{G};
            
            fclose(fid);
        end
    end
end

guidata(handles.fig,handles);

