function raveupdateview(src,ev,handles)
%Updates the workspace view to reflect the current position of
%handles.currentview. All functions that can scroll the workspace should
%simply set the position of handles.currentview, and then
%call this function to do the actual scrolling


oldpos = get(handles.wspanel,'userdata');

% wspanelpos=get(handles.wspanel,'position');
cvpos=get(handles.currentview,'position');

% wspos=handles.workspacepos;
% wsextent=get(handles.mainaxes,'position');


% wspanelpos(1)=-cvpos(1)+1;
% wspanelpos(2)=-cvpos(2);

%Small tweaks at the boundaries:
%{
if cvpos(1)==0
    wspanelpos(1)=wspanelpos(1)+0;
end

if cvpos(1)+cvpos(3)>=wsextent(3)
    wspanelpos(1)=wspanelpos(1)+2;
end

if cvpos(2)==0
    wspanelpos(2)=wspanelpos(2)-2;
end

if cvpos(2)+cvpos(4)>=wsextent(4)
    wspanelpos(2)=wspanelpos(2)+1;
end
%}

%Store position:
set(handles.wspanel,'userdata',cvpos);

%Move all objects:
wsobjects = get(handles.wspanel,'children');
wsobjects = setdiff(wsobjects,handles.mainaxes);

if iscell(wsobjects);wsobjects=[wsobjects{:}];end

offset = cvpos-oldpos;

% wsheight=handles.prefs.wsheight;

offset(1)=-offset(1);
offset(2)=-offset(2);

%This function should only shift objects, not resize them:
offset([3 4])=0;

posses = get(wsobjects,'position');

if iscell(posses)
    newposses = cellfun(@plus,posses,repmat({offset},size(posses)),'uniformoutput',false);
    set(wsobjects,{'position'},newposses);
else
    newposses = posses + offset;
    set(wsobjects,'position',newposses);
end

set(handles.mainaxes,'xlim',[cvpos(1) cvpos(1)+cvpos(3)],'ylim',[cvpos(2) cvpos(2)+cvpos(4)]);


%This bug seems to not affect the new workspace scrolling method:
%{
%fix table uipanel bug:
for ai=1:numel(handles.allgraphs)
    if ishandle(handles.fakerax(ai)) && strcmp(get(handles.fakerax(ai),'type'),'uipanel');
        p=handles.fakerax(ai);
        ppos=get(p,'position');
        set(p,'position',ppos); %makes table redraw in correct position
    end
end
%}



%check java workspace object visibility. This bug does not affect hg2:
if ~handles.ishg2
    
    idx=find(handles.isjavaworkspaceobject);
    for i=1:numel(idx)
        if ~ishandle(handles.allgraphs(idx(i)));continue;end %deleted objects
        %is object visible?
        pos=get(handles.allgraphs(idx(i)),'position');
        
        isfullyonscreen = handles.sheet(idx(i))==handles.activesheet && pos(1)>0 && pos(2)>0 && pos(1)+pos(3)<cvpos(3) && pos(2)+pos(4)<cvpos(4);
        
        udata=get(handles.fakeax(idx(i)),'userdata');
        
        try
            if ~isfullyonscreen
                set(udata.view.jscroll,'visible','off')
            else
                set(udata.view.jscroll,'visible','on')
            end
            
            j=get(udata.view.jscroll,'javapeer');
            j.doLayout;
            j.repaint;
        end
    end
end

