function udata=ravevalidateudata(src,udata,type)
%checks the udata structure to ensure it is up to date. Adds any new
%fields at their new default values. type is the workspace object keyword.

initfcn=str2func(['raveinitializeudata',type]);

nudata=initfcn(src,[]); %make updated udata

%merge fields with old udata:

newfields=fieldnames(nudata);
oldfields=fieldnames(udata);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        udata.(newfields{n})=nudata.(newfields{n});        
    end
end

if isfield(nudata,'manage')
    newfields=fieldnames(nudata.manage);
    if ~isfield(udata,'manage')
        udata.manage=struct([]);
    end
    oldfields=fieldnames(udata.manage);
    for n=1:numel(newfields)
        if ~ismember(newfields{n},oldfields)
            udata.manage.(newfields{n})=nudata.manage.(newfields{n});
        end
    end
end

newfields=fieldnames(nudata.view);
oldfields=fieldnames(udata.view);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        udata.view.(newfields{n})=nudata.view.(newfields{n});        
    end
end

newfields=fieldnames(nudata.format);
oldfields=fieldnames(udata.format);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        udata.format.(newfields{n})=nudata.format.(newfields{n});        
    end
end

newfields=fieldnames(nudata.explore);
oldfields=fieldnames(udata.explore);
for n=1:numel(newfields)
    if ~ismember(newfields{n},oldfields)
        udata.explore.(newfields{n})=nudata.explore.(newfields{n});        
    end
end
