function generatefflevels(src,ev)

handles=guidata(src);

%delete(handles.temp.tabobjects);
u=handles.temp.u;
uu=findobj(handles.temp.f,'tag','methodspanel');

methodtext=findobj(u,'tag','methodtext');
set(methodtext,'string',{'Full Factorial DoE assigns a (small) number of levels to each independent variable, and then generates a data table that includes all possible combinations of those levels. Thus if there are n variables and each variable has m levels, the data set will have m^n rows. Usually m=2 or 3.'})

datasetmenu=findobj(u,'tag','datasetmenu');
d=get(datasetmenu,'value');
analysismenu=findobj(u,'tag','analysismenu');
a=get(analysismenu,'value');

maxlevels=20;


nvars=sum(~handles.isfunction{d});
isvars=find(~handles.isfunction{d});
dblArray=javaArray('java.lang.Double',nvars,20);

colnames={};
for m=1:maxlevels
   colnames{end+1}=['Level ',num2str(m)];
end

%make default data:
leveledit=findobj(uu,'tag','leveledit');
nlevels=str2double(get(leveledit,'string'));
if isnan(nlevels)
    errordlg('You must enter a number between 1 and 20 in the "levels" box.','Invalid Entry')
    return
end

nlevels=round(nlevels);
if nlevels>20 || nlevels<1
    errordlg('You must enter a number between 1 and 20 in the "levels" box.','Invalid Entry')
    return
end

trows=1;

for r=1:nvars
    switch handles.datatype{d}{isvars(r)}
        case 'continuous'
            vals=linspace(handles.minlimit{d}{a}(isvars(r)),handles.maxlimit{d}{a}(isvars(r)),nlevels);
        case {'discrete','string','list'}
            vals=linspace(handles.minlimit{d}{a}(isvars(r)),handles.maxlimit{d}{a}(isvars(r)),nlevels);
            vals=roundto(vals,handles.discretevalues{d}{a}{isvars(r)});
        case {'logical'}
            vals=[handles.minlimit{d}{a}(isvars(r)) handles.maxlimit{d}{a}(isvars(r))];
        case {'integer'}
            vals=handles.minlimit{d}{a}(isvars(r)):handles.maxlimit{d}{a}(isvars(r));
            if numel(vals)>nlevels;
                vals=roundto(linspace(handles.minlimit{d}{a}(isvars(r)),handles.maxlimit{d}{a}(isvars(r)),nlevels),vals);
            end
    end
    for c=1:numel(vals)
        dblArray(r,c)=java.lang.Double(vals(c));
    end
    trows=trows*numel(vals);
end

dmodel=javax.swing.table.DefaultTableModel(dblArray,colnames);
handles.temp.jtable.setModel(dmodel);
set(handle(dmodel,'callbackproperties'),'TableChangedCallback',{@fftablechanged,handles.fig})

totalrows=findobj(uu,'tag','totalrows');
set(totalrows,'string',['Total Rows = ',num2str(trows)]);


function roundout=roundto(roundees,rounders)
%rounds roundees to nearest value in rounders inefficiently.
roundout=roundees;
for g=1:numel(roundees)
    newval=rounders(abs(rounders-roundees(g))==min(abs(rounders-roundees(g))));
    roundout(g)=newval(1);
end


