function ravesamplemakeuifullfactorial(src,ev)
handles=guidata(src);

delete(handles.temp.tabobjects);
u=handles.temp.u;
f=handles.temp.f;
uu=findobj(handles.temp.f,'tag','methodspanel');

methodtext=findobj(u,'tag','methodtext');
set(methodtext,'string',{'Full Factorial DoE assigns a (small) number of levels to each independent variable, and then generates a data table that includes all possible combinations of those levels. Thus if there are n variables and each variable has m levels, the data set will have m^n rows. Usually m=2 or 3.'})

fftext=uicontrol('parent',uu,'position',[30 240 500 60],'style','text',...
    'string',{'Use the generate button to populate the table and/or edit the table manually. Each variable must have at least one level. Variables do not all have to have the same number of levels. Empty and duplicate cells will be ignored. For text type variables, enter integer string indices.'},'backgroundcolor',handles.colors.tabbg,'hor','left');

datasetmenu=findobj(u,'tag','datasetmenu');
d=get(datasetmenu,'value');

maxlevels=20;

nvars=sum(~handles.isfunction{d});
isvars=find(~handles.isfunction{d});
dblArray=javaArray('java.lang.Double',nvars,maxlevels);

colnames={};
for m=1:maxlevels
   colnames{end+1}=['Level ',num2str(m)];
end

dmodel=javax.swing.table.DefaultTableModel(dblArray,colnames);
jtable=javax.swing.JTable(dmodel);
jtable.setAutoResizeMode(jtable.AUTO_RESIZE_OFF);
jscroll=javax.swing.JScrollPane(jtable);

dblRows=javaArray('java.lang.Object',nvars,1); %row header numbers
for g=1:nvars
    dblRows(g,1)=java.lang.String(handles.allnames{d}{isvars(g)});
end
rh=javax.swing.table.DefaultTableModel(dblRows,{'Variable Name'});
rowHeader=javax.swing.JTable(rh);

[jhandle mhandle]=javacomponent(jscroll,[30 0 500 220],uu);

handles.temp.jtable=jtable;
handles.temp.jscroll=jhandle;
guidata(handles.fig,handles);
guidata(f,handles);

%make the header the appropriate width:
headerWidth=150;
rhHeight=rowHeader.getPreferredSize.height;
rowHeader.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight))
rowHeader.setSize(java.awt.Dimension(headerWidth,rhHeight))

%put the row header in a viewport.
jv=javax.swing.JViewport;
jv.setView(rowHeader);
jv.setPreferredSize(java.awt.Dimension(headerWidth,rhHeight));

jscroll.setRowHeader(jv);
jscroll.setCorner(javax.swing.ScrollPaneConstants.UPPER_LEFT_CORNER, rowHeader.getTableHeader());

u1=uicontrol('position',[30 230 100 24],'parent',uu,'string','Generate Levels',...
    'callback',@generatefflevels,'style','pushbutton');
u2=uicontrol('position',[135 230 300 20],'parent',uu,'string','for a Full-Factorial DoE with up to                     levels.',...
    'callback','','style','text','backgroundcolor',handles.colors.tabbg,'hor','left');
u3=uicontrol('position',[395 230 140 20],'parent',uu,'string','Total Rows = 0',...
    'callback','','style','text','backgroundcolor',handles.colors.tabbg,'hor','left','fontweight','bold',...
    'tag','totalrows');
u4=uicontrol('position',[302 230 50 20],'parent',uu,'string','2',...
    'callback','','style','edit','backgroundcolor',handles.colors.tabbg,'hor','center','fontweight','bold',...
    'tag','leveledit');

% donebutton=findobj(f,'tag','donebutton');
% set(donebutton,'callback',@ravesamplefullfactorial);

generatefflevels(src,ev)


handles.temp.tabobjects=[u1 u2 u3 u4  mhandle fftext];

guidata(handles.temp.f,handles);