function varargout = savemetadatagui(varargin)
% SAVEMETADATAGUI M-file for savemetadatagui.fig
%      SAVEMETADATAGUI, by itself, creates a new SAVEMETADATAGUI or raises the existing
%      singleton*.
%
%      H = SAVEMETADATAGUI returns the handle to a new SAVEMETADATAGUI or the handle to
%      the existing singleton*.
%
%      SAVEMETADATAGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAVEMETADATAGUI.M with the given input arguments.
%
%      SAVEMETADATAGUI('Property','Value',...) creates a new SAVEMETADATAGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before savemetadatagui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to savemetadatagui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Edit the above text to modify the response to help savemetadatagui

% Last Modified by GUIDE v2.5 10-Jan-2015 15:36:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @savemetadatagui_OpeningFcn, ...
                   'gui_OutputFcn',  @savemetadatagui_OutputFcn, ...
                   'gui_LayoutFcn',  @savemetadatagui_LayoutFcn , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function h=savemetadatagui_LayoutFcn(varargin)
h=openfig('savemetadatagui.fig');


% --- Executes just before savemetadatagui is made visible.
function savemetadatagui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to savemetadatagui (see VARARGIN)
handles.fig=hObject;

hfig=get(0,'userdata');
origin=get(hfig,'pos');
thispos=get(hObject,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=thispos(2)+origin(2);
set(hObject,'position',thispos);

%set theme:
load raveprefs
handles.prefs=raveprefs;
handles.colors=handles.prefs.colors;
handles.fonts=handles.prefs.fonts;

set(0,'userdata','cancel');

set(hObject,'color',handles.colors.frame,'windowstyle','modal');
set(handles.uipanel1,'backgroundcolor',handles.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',handles.colors.frame,...
    'ycolor',handles.colors.frame,'zcolor',handles.colors.frame);


%make titles
text(0,.4,'Export Metadata','parent',handles.titleaxes,'fontname',handles.fonts.title,'fontsize',handles.fonts.titlesize,...
    'color',handles.colors.title,'horizontalalignment','left','verticalalignment','baseline');


%display button icons
A=imread('browse.png');
set(handles.browsebutton,'cdata',A)

%get exising handles structure from maingui
handles.indata=guidata(hfig); %gcbo = "manage data sets" button in maingui

set(handles.datasetmenu,'string',handles.indata.datasetnames)
set(handles.analysismenu,'string',handles.indata.analysisnames)

[path,name]=fileparts(handles.indata.datasetfiles{1});
if isempty(path) || ~isdir(path)
    path=pwd;
end

set(handles.pathedit,'string',path);




% Choose default command line output for savemetadatagui
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

function browsebutton_Callback(hObject, eventdata, handles)

newpath=uigetdir;
if ischar(newpath)
   set(handles.pathedit,'string',newpath) 
end


function savebutton_Callback(hObject, eventdata, handles)

newpath=get(handles.pathedit,'string');
if isempty(newpath)
    warndlg('You must enter a path.')
    return
end

makethesefiles=[get(handles.rvefun,'value') get(handles.rveval,'value'),...
    get(handles.rvecon,'value') get(handles.rvecur,'value') get(handles.rveopt,'value'),...
    get(handles.rvecol,'value') get(handles.rverow,'value') get(handles.rvedis,'value'),...
    get(handles.rvepoi,'value') get(handles.rvente,'value')];

userdata.path=newpath;
userdata.makethese=makethesefiles;
userdata.d=get(handles.datasetmenu,'value');
userdata.a=get(handles.analysismenu,'value');

set(0,'userdata',userdata);

delete(get(hObject,'parent'));

function cancelbutton_Callback(hObject, eventdata, handles)
set(0,'userdata','cancel')
delete(get(hObject,'parent'))


%useless crap:
function varargout = savemetadatagui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;
function analysismenu_Callback(hObject, eventdata, handles)
function analysismenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function datasetmenu_Callback(hObject, eventdata, handles)
function datasetmenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function rvefun_Callback(hObject, eventdata, handles)
function rveval_Callback(hObject, eventdata, handles)
function rvecon_Callback(hObject, eventdata, handles)
function rvecur_Callback(hObject, eventdata, handles)
function rveopt_Callback(hObject, eventdata, handles)
function rvecol_Callback(hObject, eventdata, handles)
function rverow_Callback(hObject, eventdata, handles)
function rvedis_Callback(hObject, eventdata, handles)

function pathedit_Callback(hObject, eventdata, handles)
function pathedit_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function rvepoi_Callback(hObject, eventdata, handles)
function rvente_Callback(hObject, eventdata, handles)

