function sampletab(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2013 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
set(handles.infobar,'string','');
handles.activetab='row';
guidata(src,handles);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.backtabposition)
set(handles.backtabaxes,'position',handles.fronttabposition)
[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,0); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)


%delete(handles.tabobjects);
set(handles.infobar,'string','');

%raise this tab to top
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,4,1); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end


%%
doetext=text(.15-.10317,0.969,'Generate Data','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',handles.fonts.titlesize,'fontname',handles.fonts.title,'color',handles.colors.title);



doebutton=uicontrol('position',[origin(1)+20 origin(2)+570 230 24],...
    'style','pushbutton','string','Structured Sampling (DoE)',...
    'callback',@doebutton_callback,'fontsize',10,...
    'backgroundcolor',handles.colors.buttonbg,'tag','doebutton');

mcbutton=uicontrol('position',[origin(1)+20 origin(2)+535 230 24],...
    'style','pushbutton','string','Random Sampling (Monte Carlo)',...
    'callback',@mcbutton_callback,'fontsize',10,...
    'backgroundcolor',handles.colors.buttonbg,'tag','mcbutton');


handles.tabobjects=[doetext doebutton mcbutton  ];

guidata(src,handles);


function doebutton_callback(src,ev)
ravesamplinggui(src,ev,'doe');


function mcbutton_callback(src,ev)
ravesamplinggui(src,ev,'montecarlo');



